/*
 * Generated by MyEclipse Struts
 * Template path: templates/java/JavaClass.vtl
 */
package action;

import java.sql.Timestamp;
import java.util.Date;
import java.util.Iterator;
import java.util.List;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.apache.struts.action.Action;
import org.apache.struts.action.ActionErrors;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;
import org.apache.struts.action.ActionMessage;
import org.apache.struts.action.ActionMessages;
import org.hibernate.Session;
import org.hibernate.Transaction;

import util.DatesToolbox;
import util.EncryptionToolbox;

import hibernate.Asociacion;
import hibernate.AsociacionDAO;
import hibernate.HibernateSessionFactory;
import hibernate.Localidad;
import hibernate.LocalidadDAO;
import hibernate.Perfil;
import hibernate.PerfilDAO;
import hibernate.Persona;
import hibernate.PersonaDAO;
import hibernate.Usuario;
import hibernate.UsuarioDAO;
import form.AsociacionExternaForm;


public class AsociacionExternaAction extends Action {
	/*
	 * Generated Methods
	 */
	private static Log log = LogFactory.getLog(AsociacionExternaAction.class);
	/** 
	 * Method execute
	 * @param mapping
	 * @param form
	 * @param request
	 * @param response
	 * @return ActionForward
	 */
	public ActionForward execute(ActionMapping mapping, ActionForm form,
			HttpServletRequest request, HttpServletResponse response) {
		
		AsociacionExternaForm asociacionForm = (AsociacionExternaForm) form;
		
		// Errores
		ActionErrors mensaje_error = new ActionErrors();
		// Mensajes
		ActionMessages mensajes = new ActionMessages();
		
		try {
			// Volver
			if (request.getParameter("volver") != null) {
				return mapping.findForward("volver");
			}
			
				AsociacionDAO asoDAO = new AsociacionDAO();
				Asociacion aso = new Asociacion();
				Session sesion = HibernateSessionFactory.getSession();
				Transaction tx = sesion.beginTransaction();
				
				aso.setNombre(asociacionForm.getNombre());
				if (asociacionForm.getDireccion() != null) 
					aso.setDireccion(asociacionForm.getDireccion());
				if ((asociacionForm.getLocalidad() != null) && (!asociacionForm.getLocalidad().equals("")) ) {
					LocalidadDAO locDAO = new LocalidadDAO();
					Localidad loc = locDAO.findById(Integer.parseInt(asociacionForm.getLocalidad()));
					aso.setLocalidad(loc);
				}
				if (asociacionForm.getTelefono() != null) 
					aso.setTelefono(asociacionForm.getTelefono());
				if ((asociacionForm.getId_coordinador() != null) && (!asociacionForm.getId_coordinador().equals("")) ) {
					UsuarioDAO userDAO = new UsuarioDAO();
					Usuario user = userDAO.findById(Integer.parseInt(asociacionForm.getId_coordinador()));
					aso.setPersona(user.getPersona());
				}
				if (asociacionForm.getDescripcion() != null) 
					aso.setDescripcion(asociacionForm.getDescripcion());
				
				
				
				/** 
				 *  COORDINADOR
				 */
				
				Usuario usuario;
				Perfil perfil = new Perfil();
				UsuarioDAO usuarioDAO = new UsuarioDAO();
				PerfilDAO perfilDAO = new PerfilDAO();
				Persona persona;
				PersonaDAO personaDAO = new PersonaDAO();
				
				boolean savePersona = true;
				
				// Existe una persona con ese DNI
				List listaPersonas = personaDAO.findByDni(asociacionForm.getDniCoord());
				// Se ha encontrado una persona con ese DNI
				if (listaPersonas.size() == 1) {
					// Cargamos la persona
					persona = (Persona) listaPersonas.get(0);
					// Si la persona esta borrada
					if (persona.getFechaBaja() != null) {
						// Recuperamos la persona
						persona.setFechaBaja(null);
						persona.setFechaAlta(new Timestamp(new Date().getTime()));
						savePersona = false;
					} else {
						// EDICION
						savePersona = false;
					}
				} else {
					// Nueva persona
					persona = new Persona();
					persona.setFechaAlta(new Timestamp(new Date().getTime()));
				}

				// Determina si es edicion o nueva insercion (save = true -> nuevo)
				boolean save = true;
				// Comprobamos si existe un usuario con ese nombre de usuario
				List listaUsuarios = usuarioDAO.findByLoginCompleto(asociacionForm
						.getUsuarioCoord());
				// Si se ha encontrado un usuario
				if (listaUsuarios.size() >= 1) {
					// Cargamos usuario
					usuario = (Usuario) listaUsuarios.get(0);
					// Si el usuario esta borrado (que debe estarlo)
					if (usuario.getFecBaja() != null) {
						usuario.setFecBaja(null);
						usuario.setFecAlta(new Timestamp(new Date().getTime()));
						save = false;
					} else {
						log.debug("El usuario " + usuario.getLogin()
								+ " existe y se va a editar");
						save = false;
					}
				} else {
					boolean encontrado = false;
					if (listaUsuarios.size() > 1) {
						usuario = (Usuario) listaUsuarios.get(0);
						Iterator<Usuario> it = listaUsuarios.iterator();
						while ((it.hasNext()) && (!encontrado)) {
							Usuario elem = (Usuario) it.next();
						}
						if (!encontrado) {
							usuario.setFecAlta(new Timestamp(new Date().getTime()));
							usuario.setFecBaja(null);
							save = false;
						}
					} else {
						// Nuevo usuario
						log.debug("Creamos usuario nuevo");
						usuario = new Usuario();
						usuario.setFecAlta(new Timestamp(new Date().getTime()));
					}
				}

				Localidad loc = new Localidad();
				LocalidadDAO locDAO = new LocalidadDAO();
				
				if ((asociacionForm.getLocalidad() != null) && (!asociacionForm.getLocalidad().toString().equals(""))) {
					String id_loc = asociacionForm.getLocalidad();
					loc = locDAO.findById(Integer.parseInt(id_loc));
				}

				
				// Datos del usuario
				// Persona
				if (asociacionForm.getDniCoord() != "") {
					persona.setDni(asociacionForm.getDniCoord());
				} else {
					persona.setDni(null);
				}
				persona.setNombre(asociacionForm.getNombreCoord());
				persona.setApellido1(asociacionForm.getApellido1Coord());
				persona.setApellido2(asociacionForm.getApellido2Coord());
				persona.setDireccion(asociacionForm.getDireccionCoord());
				persona.setCodigoPostal(asociacionForm.getCodigo_postalCoord());
				persona.setTelefono(asociacionForm.getTelefonoCoord());
				persona.setMovil(asociacionForm.getMovilCoord());
				persona.setEmail(asociacionForm.getEmailCoord());
				if ((asociacionForm.getFecha_nacimientoCoord() == "")
						|| (asociacionForm.getFecha_nacimientoCoord() == null)) {
					persona.setFechaNacimiento(null);
				} else {
					persona
							.setFechaNacimiento(DatesToolbox
									.getDBDateFromSpanish(asociacionForm
											.getFecha_nacimientoCoord()));
				}
				persona.setFechaAlta(new Timestamp(new Date().getTime()));
				persona.setLocalidad(loc);

				// Grabamos Persona
				if (savePersona)
					personaDAO.save(persona);
				else
					personaDAO.merge(persona);
				
				// Usuario
				usuario.setPersona(persona);
				usuario.setLogin(asociacionForm.getUsuarioCoord());

				if ((save) || (!asociacionForm.getClaveCoord().equals(""))) {
					usuario.setClave(EncryptionToolbox.md5(asociacionForm.getClaveCoord()));
				}

				usuario.setFecAlta(new Timestamp(new Date().getTime()));
				
				// Perfil Coordinador
				perfil = perfilDAO.findById(3);
				usuario.setPerfil(perfil);

				// Grabamos 
				if (save) {
					usuarioDAO.save(usuario);
				
				aso.setPersona(persona);
				aso.setFecAlta(new Timestamp(new Date().getTime()));
				asoDAO.save(aso);
					
				/**
				 * COORDINADOR
				 */
								
				tx.commit();
				sesion.close();
				// Mensaje de salida al usuario
				mensajes.add(ActionMessages.GLOBAL_MESSAGE,
							new ActionMessage("asociacion.formulario.creada",
									aso.getNombre()));
				this.saveMessages(request, mensajes);
				return mapping.findForward("success");
			}
				return mapping.findForward("fail");
			
		} catch (Exception e) {
			log.warn("Error en el proceso de creacion de la asociacion");
			e.printStackTrace();
			return mapping.findForward("fail");	
		}
	}
}