
package action;

import java.sql.Timestamp;
import java.util.Date;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.apache.struts.action.Action;
import org.apache.struts.action.ActionErrors;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;
import org.apache.struts.action.ActionMessage;
import org.apache.struts.action.ActionMessages;
import org.hibernate.Session;
import org.hibernate.Transaction;

import hibernate.Asociacion;
import hibernate.AsociacionDAO;
import hibernate.HibernateSessionFactory;


public class BorrarAsociacionAction extends Action {
	/*
	 * Generated Methods
	 */

	private static Log log = LogFactory.getLog(BorrarAsociacionAction.class);

	@Override
	public ActionForward execute(ActionMapping mapping, ActionForm form,
			HttpServletRequest request, HttpServletResponse response) {

		// Mensajes
		ActionMessages mensajes = new ActionMessages();
		// Errores
		ActionErrors mensajes_error = new ActionErrors();

		try {

			// Iniciamos la sesion
			Session sesion = HibernateSessionFactory.getSession();
			Transaction tx = sesion.beginTransaction();
			
			AsociacionDAO asoDAO = new AsociacionDAO();
			Asociacion aso;

			if (request.getSession().getAttribute("id") != null) {
				Integer id_auxiliar = Integer.parseInt(request.getSession()
						.getAttribute("id").toString());
				aso = asoDAO.findById(id_auxiliar);
				// No se ha encontrado voluntario
				if (aso == null) {
					// Error
					mensajes_error.add("mensajes_error", new ActionMessage(
							"asociacion.error.noencontrado"));
					this.saveMessages(request, mensajes_error);
					// Transaccion cancelada
					tx.rollback();
					sesion.close();
					return mapping.findForward("fail");
				}
				
				aso.setFecBaja(new Timestamp(new Date().getTime()));
				
				asoDAO.merge(aso);

				// Transaccion cerrada
				tx.commit();
				sesion.close();
				// Mensaje
				mensajes.add("mensajes", new ActionMessage("asociacion.formulario.borrada",
						aso.getNombre()));
				this.saveMessages(request, mensajes);
				// Volver
				return mapping.findForward("success");
			} else {
				// Error
				mensajes_error.add("mensajes_error", new ActionMessage(
						"asociacion.error.noencontrado"));
				this.saveMessages(request, mensajes_error);
				// Volver
				return mapping.findForward("fail");
			}
		} catch (Exception e) {
			log.warn("Error borrando asociacion");
			e.printStackTrace();
			return mapping.findForward("fail");
		}
	}
}