
package action;

import java.sql.Timestamp;
import java.util.Date;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.apache.struts.action.Action;
import org.apache.struts.action.ActionErrors;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;
import org.apache.struts.action.ActionMessage;
import org.apache.struts.action.ActionMessages;
import org.hibernate.Session;
import org.hibernate.Transaction;

import hibernate.PersonaDependiente;
import hibernate.PersonaDependienteDAO;
import hibernate.HibernateSessionFactory;
import form.PDForm;

public class BorrarPDAction extends Action {
	/*
	 * Generated Methods
	 */
	private static Log log = LogFactory.getLog(BorrarPDAction.class);
	
	public ActionForward execute(ActionMapping mapping, ActionForm form,
			HttpServletRequest request, HttpServletResponse response) {
		
		try {
			
			PDForm pdForm = (PDForm) form; 
			
			PersonaDependienteDAO benDAO = new PersonaDependienteDAO();
			PersonaDependiente ben;
			// Mensajes
			ActionMessages mensaje = new ActionMessages();
			// Errores
			ActionErrors mensaje_error = new ActionErrors(); 
			
			if (request.getSession().getAttribute("id") != null) {
				Integer id_ben = Integer.parseInt(request.getSession().getAttribute("id").toString());
				ben = benDAO.findById(id_ben);
				ben.setFecBajaBeneficiario(new Timestamp(new Date().getTime()));
				// Iniciamos la sesion			
				Session sesion = HibernateSessionFactory.getSession();			
				Transaction tx = sesion.beginTransaction();
				
				benDAO.merge(ben);
				
				// Transaccion
				tx.commit();
				sesion.close();
				// Mensaje
				mensaje.add("mensaje", new ActionMessage("PD.borrado", pdForm.getNombre() 
						+ " " + pdForm.getApellido1()));
				this.saveMessages(request, mensaje);
				// Volver
				return mapping.findForward("success");
			} else {
				// Mensaje
				mensaje_error.add("mensajes_error", new ActionMessage("beneficiario.error.borrado"));
				this.saveErrors(request, mensaje_error);
				// Error
				return mapping.findForward("error");
			}
		} catch (Exception e) {
			log.warn("Error borrando persona dependiente");
			e.printStackTrace();
			return mapping.findForward("fail");	
		}
	}
}