
package action;

import hibernate.Servicio;
import hibernate.ServicioDAO;
import hibernate.Usuario;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.apache.struts.action.Action;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;
import org.hibernate.Session;
import org.hibernate.Transaction;

import util.CorreoEnvio;
import util.GestionCorreoElectronico;

import hibernate.HibernateSessionFactory;
import form.TareaForm;

public class BorrarTareaAction extends Action {
	/*
	 * Generated Methods
	 */

	private static Log logs = LogFactory.getLog(BorrarTareaAction.class);

	public ActionForward execute(ActionMapping mapping, ActionForm form,
			HttpServletRequest request, HttpServletResponse response) {

		TareaForm tareaForm = (TareaForm) form;
		if (request.getSession().getAttribute("id") != null) {
			
			HttpSession session = request.getSession(false);
			Usuario u = null;
			if (session != null && session.getAttribute("usuario") != null) {
				u = (Usuario)session.getAttribute("usuario");
			}
			
			ServicioDAO serDAO = new ServicioDAO();
			Servicio ser = serDAO.findById(Integer.parseInt(request.getSession().getAttribute("id").toString()));
			// Mandamos mail según perfil de usuario
		
			if (u.getPerfil().getId() == 2) {
				// VOLUNTARIO
				// Mandamos mail
				try{
					// preparamos mail
					CorreoEnvio correo = new CorreoEnvio();
					correo.setAsunto("Tarea Eliminada");
					correo.setContenido("<b>" + ser.getAuxiliar().getAsociacion().getNombre() +"</b><br><br>Hola, " + 
							ser.getAuxiliar().getUsuario().getPersona().getNombre() + "<br>" +
							"La tarea que tenía programada para el próximo " + ser.getDia().getDescripcion() + " de " + 
							ser.getHoraByHoraInicio().getIntervalo() + 
							" a " + ser.getHoraByHoraFin().getIntervalo() + " con el paciente " + 
							ser.getPersonaDependiente().getPersona().getNombre_apellidos() +" ha sido suspendida " + 
							"<br><br>Para cualquier duda, por favor, identifiquese en la aplicación. " + 
							"<br>Gracias.");
					correo.setEmail_from(ser.getAuxiliar().getAsociacion().getPersona().getEmail());
					correo.setEmail_to(ser.getAuxiliar().getUsuario().getPersona().getEmail());
					correo.setCabecera("CiberVoluntariado");
					GestionCorreoElectronico.EnvioCorreo(correo);
					logs.debug("Se ha enviado el mail al voluntario correctamente");
				} catch (Exception e){
				   	logs.warn("Error inesperado enviando mail");
					e.printStackTrace();
					return mapping.findForward("fail");	
				}
			} else if (u.getPerfil().getId() == 3) {
				// COORDINADOR
				// Mandamos mail
				try{
					// preparamos mail
					CorreoEnvio correo = new CorreoEnvio();
					correo.setAsunto("Tarea Eliminada");
					correo.setContenido("<b>" + ser.getAuxiliar().getAsociacion().getNombre() +"</b><br><br>Hola, el Voluntario " + 
							ser.getAuxiliar().getUsuario().getPersona().getNombre() + "<br>" +
							"ha cancelado la tarea que tenía programada para el próximo " + ser.getDia().getDescripcion() + " de " + 
							ser.getHoraByHoraInicio().getIntervalo() + 
							" a " + ser.getHoraByHoraFin().getIntervalo() + " con el paciente " + 
							ser.getPersonaDependiente().getPersona().getNombre_apellidos()  + 
							"<br><br>Para cualquier duda, por favor, identifiquese en la aplicación. " + 
							"<br>Gracias.");
					correo.setEmail_from(ser.getAuxiliar().getUsuario().getPersona().getEmail());
					correo.setEmail_to(ser.getAuxiliar().getAsociacion().getPersona().getEmail());
					correo.setCabecera("CiberVoluntariado");
					GestionCorreoElectronico.EnvioCorreo(correo);
					logs.debug("Se ha enviado el mail al voluntario correctamente");
				} catch (Exception e){
				   	logs.warn("Error inesperado enviando mail");
					e.printStackTrace();
					return mapping.findForward("fail");	
				}
			}
			
			Session sesion = HibernateSessionFactory.getSession();
			Transaction tx = sesion.beginTransaction();
			String idVol = ser.getAuxiliar().getId().toString();
			serDAO.delete(ser);
			tx.commit();
			sesion.close();
			
			if (u.getPerfil().getId() == 3) 
				request.setAttribute("idVoluntario",idVol);
			return mapping.findForward("success");
			
		} else {
			return mapping.findForward("fail");
		}
	}
}