
package action;

import java.sql.Timestamp;
import java.util.Date;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.apache.struts.action.Action;
import org.apache.struts.action.ActionErrors;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;
import org.apache.struts.action.ActionMessage;
import org.apache.struts.action.ActionMessages;
import org.hibernate.JDBCException;
import org.hibernate.Session;
import org.hibernate.Transaction;

import hibernate.Usuario;
import hibernate.UsuarioDAO;
import hibernate.HibernateSessionFactory;

public class BorrarUsuarioAction extends Action {
	/*
	 * Generated Methods
	 */

	private static Log log = LogFactory.getLog(BorrarUsuarioAction.class);

	@Override
	public ActionForward execute(ActionMapping mapping, ActionForm form,
			HttpServletRequest request, HttpServletResponse response) {

		UsuarioDAO userDAO = new UsuarioDAO();
		// Errores
		ActionErrors errores = new ActionErrors();
		ActionMessages mensajes = new ActionMessages();

		Usuario user = null;
		
		try {
			// ID usuario
			if (request.getParameter("id")!= null) {
				int idUsuario = Integer.parseInt(request.getParameter("id").toString());
				user = userDAO.findById(idUsuario);
				// Encontrado
				if (user != null) {
					// No es el usuario loggeado
					if (!user.getLogin().equals(
							((Usuario) request.getSession()
									.getAttribute("usuario"))
									.getLogin())) {
						// Iniciamos la sesion
						Session sesion = HibernateSessionFactory.getSession();
						Transaction tx = sesion.beginTransaction();
						user.setFecBaja(new Timestamp(new Date().getTime()));
						// Guardar
						userDAO.merge(user);
						// Cierra sesion
						tx.commit();
						sesion.close();

					} else {
						// Error
						errores.add("mensaje_error", new ActionMessage(
								"usuario.error.borrar.usuarioactual"));
						this.saveErrors(request, errores);
					}
				} else {
					// Error
					errores.add("mensaje_error", new ActionMessage(
							"usuario.error.borrar.usuarionoexiste"));
					this.saveErrors(request, errores);
				}

			} else {
				// Error
				errores.add("mensaje_error", new ActionMessage(
						"usuario.error.borrar.usuarionoexiste"));
				this.saveErrors(request, errores);
				return mapping.findForward("fail");
			}
			if (user != null) {
				mensajes.add("mensaje",new ActionMessage(
					"usuario.formulario.borrado",user.getLogin()));
				this.saveMessages(request, mensajes);			
			}

			return mapping.findForward("success");

		} catch (JDBCException e) {
			throw e;
		} catch (Exception e) {
			e.printStackTrace();
			log.error("Error al borrar usuario");
			// Error
			errores.add("mensaje_error", new ActionMessage(
					"usuario.error.borrar.generico"));
			this.saveErrors(request, errores);
			return mapping.findForward("borrar");
		}
	}

}