
package action;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.apache.struts.action.Action;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;

import form.ConfirmarForm;
import util.ConstantesProyecto;

public class ConfirmarAction extends Action {
	/*
	 * Generated Methods
	 */

	private static Log log = LogFactory.getLog(ConfirmarAction.class);

	@Override
	public ActionForward execute(ActionMapping mapping, ActionForm form,
			HttpServletRequest request, HttpServletResponse response) throws Exception {

		ConfirmarForm confirmarForm = (ConfirmarForm) form;

		try {
			// Grabamos el id del atributo en la sesion
			request.getSession().setAttribute(
					confirmarForm.getNombre_atributo(),
					confirmarForm.getValor_atributo());

			// Cancel confirmacion
			if (request.getParameter("volver") != null) {
				log.debug("Se ha pulsado el boton Cancelar");
				switch (Integer.parseInt(confirmarForm.getId_confirmacion())) {
				
					case ConstantesProyecto.GLOBAL_CONFIRMAR_USUARIO:
						return mapping.findForward("cancel_usuario");
					case ConstantesProyecto.GLOBAL_CONFIRMAR_ASO:
						return mapping.findForward("cancel_aso");
					case ConstantesProyecto.GLOBAL_CONFIRMAR_VOLUNTARIO:
						return mapping.findForward("cancel_voluntario");
					case ConstantesProyecto.GLOBAL_CONFIRMAR_PD:
						return mapping.findForward("cancel_PD");
					case ConstantesProyecto.GLOBAL_CONFIRMAR_SERVICIO:
						if (confirmarForm.getIdVoluntario() != null) {
							request.getSession().setAttribute("idVoluntario", confirmarForm.getIdVoluntario());
						}
						return mapping.findForward("cancel_servicio");
					default:
						return mapping.findForward("fail");
				}

				// Confirmacion
			} else {

				switch (Integer.parseInt(confirmarForm.getId_confirmacion())) {
				
					case ConstantesProyecto.GLOBAL_CONFIRMAR_USUARIO:
						return mapping.findForward("success_usuario");
					case ConstantesProyecto.GLOBAL_CONFIRMAR_ASO:
						return mapping.findForward("success_aso");
					case ConstantesProyecto.GLOBAL_CONFIRMAR_VOLUNTARIO:
						return mapping.findForward("success_voluntario");
					case ConstantesProyecto.GLOBAL_CONFIRMAR_PD:
						return mapping.findForward("success_PD");
					case ConstantesProyecto.GLOBAL_CONFIRMAR_SERVICIO:
						if (confirmarForm.getIdVoluntario() != null) {
							request.setAttribute("idVoluntario", confirmarForm.getIdVoluntario());
						}
						return mapping.findForward("success_servicio");
					default:
						return mapping.findForward("fail");
				}
			}
		} catch (Exception e) {
			e.printStackTrace();
			throw e;
		}

	}
}