
package action;

import java.util.Collection;
import java.util.HashSet;
import java.util.Iterator;
import java.util.Set;

import hibernate.CuestionarioEstadoEconomico;
import hibernate.CuestionarioEstadoEconomicoDAO;
import hibernate.CuestionarioEstadoFamiliar;
import hibernate.CuestionarioEstadoFamiliarDAO;
import hibernate.CuestionarioEstadoFisico;
import hibernate.CuestionarioEstadoFisicoDAO;
import hibernate.CuestionarioEstadoPsiquico;
import hibernate.CuestionarioEstadoPsiquicoDAO;
import hibernate.HibernateSessionFactory;
import hibernate.PersonaDependiente;
import hibernate.PersonaDependienteDAO;
import hibernate.PreguntaEstadoEconomico;
import hibernate.PreguntaEstadoEconomicoDAO;
import hibernate.PreguntaEstadoFamiliar;
import hibernate.PreguntaEstadoFamiliarDAO;
import hibernate.PreguntaEstadoFisico;
import hibernate.PreguntaEstadoFisicoDAO;
import hibernate.PreguntaEstadoPsiquico;
import hibernate.PreguntaEstadoPsiquicoDAO;
import hibernate.RespuestaEstadoEconomico;
import hibernate.RespuestaEstadoEconomicoDAO;
import hibernate.RespuestaEstadoFamiliar;
import hibernate.RespuestaEstadoFamiliarDAO;
import hibernate.RespuestaEstadoFisico;
import hibernate.RespuestaEstadoFisicoDAO;
import hibernate.RespuestaEstadoPsiquico;
import hibernate.RespuestaEstadoPsiquicoDAO;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.apache.struts.action.Action;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;
import org.hibernate.Session;
import org.hibernate.Transaction;

import form.CuestionarioForm;

public class CuestionarioAction extends Action {
	
	private static Log logs = LogFactory.getLog(CuestionarioAction.class);
	
	public boolean respondido(String[] a) {
		boolean res = false;
		for (int i=0;i<a.length;i++) {
			if (a[i]!=null) {
				res = true;
			}
		}
		return res;
	}
	
	public ActionForward execute(ActionMapping mapping, ActionForm form,
			HttpServletRequest request, HttpServletResponse response) {
		
		CuestionarioForm cform = (CuestionarioForm) form;
		
		try {
			if (request.getParameter("volver") != null) {
				return mapping.findForward("volver");
			}
			if ((cform.getId_persona() != null) && (!"".equals(cform.getId_persona()))) {
				// Persona Dependiente
				PersonaDependienteDAO perDAO = new PersonaDependienteDAO();
				PersonaDependiente per = perDAO.findById(Integer.parseInt(cform.getId_persona()));
				// cargamos nombre
				cform.setNombre(per.getPersona().getNombre_apellidos());
				// Listados de preguntas para cuestionarios
				// Psiquico
				PreguntaEstadoPsiquicoDAO pepDAO = new PreguntaEstadoPsiquicoDAO();
				Collection<PreguntaEstadoPsiquico> listadopreguntaspsiquico = pepDAO.findAll();
				request.setAttribute("psiquicas", listadopreguntaspsiquico); // new ArrayList<PreguntaEstadoPsiquico>();
				// Fisico
				PreguntaEstadoFisicoDAO pefDAO = new PreguntaEstadoFisicoDAO();
				Collection<PreguntaEstadoFisico> listadopreguntasfisico = pefDAO.findAll(); // new ArrayList<PreguntaEstadoFisico>();
				request.setAttribute("fisicas", listadopreguntasfisico);	
				// Economico
				PreguntaEstadoEconomicoDAO peeDAO = new PreguntaEstadoEconomicoDAO();
				Collection<PreguntaEstadoEconomico> listadopreguntaseconomico = peeDAO.findAll(); // new ArrayList<PreguntaEstadoEconomico>();
				request.setAttribute("economicas", listadopreguntaseconomico);	
				//  Familiar
				PreguntaEstadoFamiliarDAO pefaDAO = new PreguntaEstadoFamiliarDAO();
				Collection<PreguntaEstadoFamiliar> listadopreguntasfamiliar = pefaDAO.findAll(); // new ArrayList<PreguntaEstadoFamiliar>();
				request.setAttribute("familiares", listadopreguntasfamiliar);
				
				// Cuestionario Fisico
				if (cform.getPf() != null) {
					String[] pf = new String[cform.getPf().length];
					for (int i=0; i<cform.getPf().length; i++) {
						int j = i+1;
						String c = "puntuacionfisicas_" + j;
						if ((request.getParameter(c) != null) && 
								(!"".equals(request.getParameter(c).toString()))) {
							pf[i] = request.getParameter(c).toString();
						} else {
							pf[i] = null;
						}
					}
					boolean savefisico = false;
		
					if (respondido(pf)) {
						CuestionarioEstadoFisico cf = new CuestionarioEstadoFisico();
						if (per.getCuestionarioEstadoFisico() != null) {
							// Tiene Cuestionario
							cf = per.getCuestionarioEstadoFisico();
						} else {
							// No Tiene Cuestionario
							savefisico = true;
							// cf se queda igual que en la definición
						}
						RespuestaEstadoFisicoDAO rfDAO = new RespuestaEstadoFisicoDAO();
						if ((cf.getRespuestaEstadoFisicos() != null) && 
								(cf.getRespuestaEstadoFisicos().size() > 0)){
							// Tiene Respuestas
							Set<RespuestaEstadoFisico> s = cf.getRespuestaEstadoFisicos();
							Iterator<RespuestaEstadoFisico> itr = s.iterator();
							while (itr.hasNext()) {
								RespuestaEstadoFisico elem = itr.next();
								int indice = elem.getPreguntaEstadoFisico().getId()-1;
								Integer respuesta = null;
								if (pf[indice] != null)
									respuesta = Integer.parseInt(pf[indice]);
								elem.setPuntuacion(respuesta);
								Session sesion = HibernateSessionFactory.getSession();
								Transaction tx = sesion.beginTransaction();
								rfDAO.merge(elem);
								tx.commit();
								sesion.close();
							}
						} else {
							// No tiene Respuestas
							Set<RespuestaEstadoFisico> s = new HashSet<RespuestaEstadoFisico>();
							// Guardamos el nuevo cf en la BBDD
							Session sesion = HibernateSessionFactory.getSession();
							Transaction tx = sesion.beginTransaction();
							CuestionarioEstadoFisicoDAO cfDAO = new CuestionarioEstadoFisicoDAO();
							if( savefisico)
								cfDAO.save(cf);
							else
								cfDAO.merge(cf);
							per.setCuestionarioEstadoFisico(cf);
							perDAO.merge(per);
							tx.commit();
							sesion.close();
							for (int i=0; i<cform.getPf().length; i++) {
								Integer respuesta = null;
								if (pf[i] != null)
									respuesta = Integer.parseInt(pf[i]);
								// int respuesta = Integer.parseInt(pf[i]);
								RespuestaEstadoFisico ref = new RespuestaEstadoFisico();
								ref.setPuntuacion(respuesta);
								ref.setCuestionarioEstadoFisico(cf);
								ref.setPreguntaEstadoFisico(pefDAO.findById(i+1));
								Session sesion1 = HibernateSessionFactory.getSession();
								Transaction tx1 = sesion1.beginTransaction();
								rfDAO.save(ref);
								tx1.commit();
								sesion1.close();
							}
						}
						Session sesion = HibernateSessionFactory.getSession();
						Transaction tx = sesion.beginTransaction();
						CuestionarioEstadoFisicoDAO cfDAO = new CuestionarioEstadoFisicoDAO();
						cfDAO.merge(cf);
						tx.commit();
						sesion.close();
					}
				}
				
				// Cuestionario Psiquico
				if (cform.getPp() != null) {
					String[] pp = new String[cform.getPp().length];
					for (int i=0; i<cform.getPp().length; i++) {
						int j = i+1;
						String c = "psiquicas_" + j;
						if ((request.getParameter(c) != null) && 
								(!"".equals(request.getParameter(c).toString()))) {
							pp[i] = request.getParameter(c).toString();
						} else {
							pp[i] = null;
						}
					}
					boolean savepsiquico = false;
					
					if (respondido(pp)) {
						CuestionarioEstadoPsiquico cp = new CuestionarioEstadoPsiquico();
						if (per.getCuestionarioEstadoPsiquico() != null) {
							// Tiene Cuestionario
							cp = per.getCuestionarioEstadoPsiquico();
						} else {
							savepsiquico = true;
							// No Tiene Cuestionario
							// cf se queda igual que en la definición
						}
						RespuestaEstadoPsiquicoDAO rpDAO = new RespuestaEstadoPsiquicoDAO();
						if ((cp.getRespuestaEstadoPsiquicos() != null) && 
								(cp.getRespuestaEstadoPsiquicos().size() > 0)){
							// Tiene Respuestas
							Set<RespuestaEstadoPsiquico> s = cp.getRespuestaEstadoPsiquicos();
							Iterator<RespuestaEstadoPsiquico> itr = s.iterator();
							while (itr.hasNext()) {
								RespuestaEstadoPsiquico elem = itr.next();
								int indice = elem.getPreguntaEstadoPsiquico().getId()-1;
								Integer respuesta = null;
								if (pp[indice] != null)
									respuesta = Integer.parseInt(pp[indice]);
								elem.setPuntuacion(respuesta);
								Session sesion = HibernateSessionFactory.getSession();
								Transaction tx = sesion.beginTransaction();
								rpDAO.merge(elem);
								tx.commit();
								sesion.close();
							}
						} else {
							// No tiene Respuestas
							Set<RespuestaEstadoPsiquico> s = new HashSet<RespuestaEstadoPsiquico>();
							// Guardamos el nuevo cf en la BBDD
							Session sesion = HibernateSessionFactory.getSession();
							Transaction tx = sesion.beginTransaction();
							CuestionarioEstadoPsiquicoDAO cpDAO = new CuestionarioEstadoPsiquicoDAO();
							if( savepsiquico)
								cpDAO.save(cp);
							else
								cpDAO.merge(cp);
							cpDAO.save(cp);
							per.setCuestionarioEstadoPsiquico(cp);
							perDAO.merge(per);
							tx.commit();
							sesion.close();
							for (int i=0; i<cform.getPf().length; i++) {
								Integer respuesta = null;
								if (pp[i] != null)
									respuesta = Integer.parseInt(pp[i]);
								RespuestaEstadoPsiquico rep = new RespuestaEstadoPsiquico();
								rep.setPuntuacion(respuesta);
								rep.setCuestionarioEstadoPsiquico(cp);
								rep.setPreguntaEstadoPsiquico(pepDAO.findById(i+1));
								Session sesion1 = HibernateSessionFactory.getSession();
								Transaction tx1 = sesion1.beginTransaction();
								rpDAO.save(rep);
								tx1.commit();
								sesion1.close();
							}
						}
						Session sesion = HibernateSessionFactory.getSession();
						Transaction tx = sesion.beginTransaction();
						CuestionarioEstadoPsiquicoDAO cpDAO = new CuestionarioEstadoPsiquicoDAO();
						cpDAO.merge(cp);
						tx.commit();
						sesion.close();
					}
				}
				
				// Cuestionario Familiar
				if (cform.getPfa() != null) {
					String[] pfa = new String[cform.getPfa().length];
					for (int i=0; i<cform.getPfa().length; i++) {
						int j = i+1;
						String c = "familiares_" + j;
						if ((request.getParameter(c) != null) && 
								(!"".equals(request.getParameter(c).toString()))) {
							pfa[i] = request.getParameter(c).toString();
						} else {
							pfa[i] = null;
						}
					}
					boolean savefamiliar = false;
					
					if (respondido(pfa)) {
						CuestionarioEstadoFamiliar cfa = new CuestionarioEstadoFamiliar();
						if (per.getCuestionarioEstadoFamiliar() != null) {
							// Tiene Cuestionario
							cfa = per.getCuestionarioEstadoFamiliar();
						} else {
							savefamiliar = true;
							// No Tiene Cuestionario
							// cf se queda igual que en la definición
						}
						RespuestaEstadoFamiliarDAO rfaDAO = new RespuestaEstadoFamiliarDAO();
						if ((cfa.getRespuestaEstadoFamiliars() != null) && 
								(cfa.getRespuestaEstadoFamiliars().size() > 0)){
							// Tiene Respuestas
							Set<RespuestaEstadoFamiliar> s = cfa.getRespuestaEstadoFamiliars();
							Iterator<RespuestaEstadoFamiliar> itr = s.iterator();
							while (itr.hasNext()) {
								RespuestaEstadoFamiliar elem = itr.next();
								int indice = elem.getPreguntaEstadoFamiliar().getId()-1;
								Integer respuesta = null;
								if (pfa[indice] != null)
									respuesta = Integer.parseInt(pfa[indice]);
								elem.setPuntuacion(respuesta);
								Session sesion = HibernateSessionFactory.getSession();
								Transaction tx = sesion.beginTransaction();
								rfaDAO.merge(elem);
								tx.commit();
								sesion.close();
							}
						} else {
							// No tiene Respuestas
							Set<RespuestaEstadoFamiliar> s = new HashSet<RespuestaEstadoFamiliar>();
							// Guardamos el nuevo cfa en la BBDD
							Session sesion = HibernateSessionFactory.getSession();
							Transaction tx = sesion.beginTransaction();
							CuestionarioEstadoFamiliarDAO cfaDAO = new CuestionarioEstadoFamiliarDAO();
							if( savefamiliar)
								cfaDAO.save(cfa);
							else
								cfaDAO.merge(cfa);
							per.setCuestionarioEstadoFamiliar(cfa);
							perDAO.merge(per);
							tx.commit();
							sesion.close();
							for (int i=0; i<cform.getPf().length; i++) {
								Integer respuesta = null;
								if (pfa[i] != null)
									respuesta = Integer.parseInt(pfa[i]);
								RespuestaEstadoFamiliar refa = new RespuestaEstadoFamiliar();
								refa.setPuntuacion(respuesta);
								refa.setCuestionarioEstadoFamiliar(cfa);
								refa.setPreguntaEstadoFamiliar(pefaDAO.findById(i+1));
								Session sesion1 = HibernateSessionFactory.getSession();
								Transaction tx1 = sesion1.beginTransaction();
								rfaDAO.save(refa);
								tx1.commit();
								sesion1.close();
							}
						}
						Session sesion = HibernateSessionFactory.getSession();
						Transaction tx = sesion.beginTransaction();
						CuestionarioEstadoFamiliarDAO cfaDAO = new CuestionarioEstadoFamiliarDAO();
						cfaDAO.merge(cfa);
						tx.commit();
						sesion.close();
					}
				}
				
				// Cuestionario Economico
				if (cform.getPe() != null) {
					String[] pe = new String[cform.getPe().length];
					for (int i=0; i<cform.getPe().length; i++) {
						int j = i+1;
						String c = "economicas_" + j;
						if ((request.getParameter(c) != null) && 
								(!"".equals(request.getParameter(c).toString()))) {
							pe[i] = request.getParameter(c).toString();
						} else {
							pe[i] = null;
						}
					}
					boolean saveeconomico = false;
					if (respondido(pe)) {
						CuestionarioEstadoEconomico ce = new CuestionarioEstadoEconomico();
						if (per.getCuestionarioEstadoEconomico() != null) {
							// Tiene Cuestionario
							ce = per.getCuestionarioEstadoEconomico();
						} else {
							saveeconomico = true;
							// No Tiene Cuestionario
							// ce se queda igual que en la definición
						}
						RespuestaEstadoEconomicoDAO reDAO = new RespuestaEstadoEconomicoDAO();
						if ((ce.getRespuestaEstadoEconomicos() != null) && 
								(ce.getRespuestaEstadoEconomicos().size() > 0)){
							// Tiene Respuestas
							Set<RespuestaEstadoEconomico> s = ce.getRespuestaEstadoEconomicos();
							Iterator<RespuestaEstadoEconomico> itr = s.iterator();
							while (itr.hasNext()) {
								RespuestaEstadoEconomico elem = itr.next();
								int indice = elem.getPreguntaEstadoEconomico().getId()-1;
								Integer respuesta = null;
								if (pe[indice] != null)
									respuesta = Integer.parseInt(pe[indice]);
								elem.setPuntuacion(respuesta);
								Session sesion = HibernateSessionFactory.getSession();
								Transaction tx = sesion.beginTransaction();
								reDAO.merge(elem);
								tx.commit();
								sesion.close();
							}
						} else {
							// No tiene Respuestas
							Set<RespuestaEstadoEconomico> s = new HashSet<RespuestaEstadoEconomico>();
							// Guardamos el nuevo ce en la BBDD
							Session sesion = HibernateSessionFactory.getSession();
							Transaction tx = sesion.beginTransaction();
							CuestionarioEstadoEconomicoDAO ceDAO = new CuestionarioEstadoEconomicoDAO();
							if( saveeconomico)
								ceDAO.save(ce);
							else
								ceDAO.merge(ce);
							per.setCuestionarioEstadoEconomico(ce);
							perDAO.merge(per);
							tx.commit();
							sesion.close();
							for (int i=0; i<cform.getPf().length; i++) {
								Integer respuesta = null;
								if (pe[i] != null)
									respuesta = Integer.parseInt(pe[i]);
								RespuestaEstadoEconomico ree = new RespuestaEstadoEconomico();
								ree.setPuntuacion(respuesta);
								ree.setCuestionarioEstadoEconomico(ce);
								ree.setPreguntaEstadoEconomico(peeDAO.findById(i+1));
								Session sesion1 = HibernateSessionFactory.getSession();
								Transaction tx1 = sesion1.beginTransaction();
								reDAO.save(ree);
								tx1.commit();
								sesion1.close();
							}
						}
						Session sesion = HibernateSessionFactory.getSession();
						Transaction tx = sesion.beginTransaction();
						CuestionarioEstadoEconomicoDAO ceDAO = new CuestionarioEstadoEconomicoDAO();
						ceDAO.merge(ce);
						tx.commit();
						sesion.close();
					}
				}
				return  mapping.findForward("success");
			} else {
				return mapping.findForward("fail");
			}
		} catch (Exception e) {
			logs.error("Error guardando cuestionarios");
			e.printStackTrace();
			return  mapping.findForward("fail");
		}
	}
}