
package action;

import java.util.List;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.apache.struts.action.Action;
import org.apache.struts.action.ActionErrors;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;
import org.apache.struts.action.ActionMessage;
import org.apache.struts.action.ActionMessages;
import org.hibernate.Session;
import org.hibernate.Transaction;

import hibernate.Localidad;
import hibernate.LocalidadDAO;
import hibernate.PerfilDAO;
import hibernate.Persona;
import hibernate.PersonaDAO;
import hibernate.Usuario;
import hibernate.UsuarioDAO;

import hibernate.HibernateSessionFactory;

import util.DatesToolbox;
import util.EncryptionToolbox;
import form.MiUsuarioForm;


public class EditarMiUsuarioAction extends Action {
	
		private static Log log = LogFactory.getLog(EditarMiUsuarioAction.class);

		@Override
		public ActionForward execute(ActionMapping mapping, ActionForm form,
				HttpServletRequest request, HttpServletResponse response) {

			// Formulario
			MiUsuarioForm usuarioForm = (MiUsuarioForm) form;

			// Errores
			ActionErrors errores = new ActionErrors();
			// Mensajes
			ActionMessages mensajes = new ActionMessages();
			Session sesion = HibernateSessionFactory.getSession();
			Transaction tx = sesion.beginTransaction();
			
			try {
				
				UsuarioDAO usuarioDAO = new UsuarioDAO();
				Usuario usuario = usuarioDAO.findById((usuarioForm.getId()));
				Persona persona = usuario.getPersona();
				
				PerfilDAO perfilDAO = new PerfilDAO();
				PersonaDAO personaDAO = new PersonaDAO();
				
				// Volver
				if (request.getParameter("volver") != null) {
					return mapping.findForward("volver");
				}
				
				if (!persona.getDni().equals(usuarioForm.getDni())) {
					// Existe una persona con ese DNI
					List listaPersonas = personaDAO.findByDni(usuarioForm.getDni());
					// Se ha encontrado una persona con ese DNI
					if (listaPersonas.size() == 1) {
						// DNI Repetido
						log.warn("No existe DNI");
						mensajes.add("dni", new ActionMessage("usuario.error.dni.repetido"));
						return mapping.findForward("dniRepetido");
					} else {
						// Asignamos nuevo dni
						persona.setDni(usuarioForm.getDni());
					}
				}
				usuario.setLogin(usuarioForm.getUsuario());

				Localidad loc = new Localidad();
				LocalidadDAO locDAO = new LocalidadDAO();
				
				if ((usuarioForm.getLocalidad() != null) && (!usuarioForm.getLocalidad().toString().equals(""))) {
					String id_loc = usuarioForm.getLocalidad();
					loc = locDAO.findById(Integer.parseInt(id_loc));
				}

				// Persona
				persona.setNombre(usuarioForm.getNombre());
				persona.setApellido1(usuarioForm.getApellido1());
				persona.setApellido2(usuarioForm.getApellido2());
				persona.setDireccion(usuarioForm.getDireccion());
				persona.setCodigoPostal(usuarioForm.getCodigo_postal());
				persona.setTelefono(usuarioForm.getTelefono());
				persona.setMovil(usuarioForm.getMovil());
				persona.setEmail(usuarioForm.getEmail());
				if ((usuarioForm.getFecha_nacimiento() == "")
						|| (usuarioForm.getFecha_nacimiento() == null)) {
					persona.setFechaNacimiento(null);
				} else {
					persona
							.setFechaNacimiento(DatesToolbox
									.getDBDateFromSpanish(usuarioForm
											.getFecha_nacimiento()));
				}
				persona.setLocalidad(loc);

				personaDAO.merge(persona);

				// usuario
				usuario.setPersona(persona);
				usuario.setLogin(usuarioForm.getUsuario());
				if ((usuarioForm.getClave1() != null) && (usuarioForm.getClave2() != null)
						&& (!"".equals(usuarioForm.getClave1())) && (!"".equals(usuarioForm.getClave2()))) {
					usuario.setClave(EncryptionToolbox.md5(usuarioForm.getClave1()));
				}

				// Grabamos	
					usuarioDAO.merge(usuario);
					tx.commit();
					sesion.close();
					// Mensaje
					mensajes.add(ActionMessages.GLOBAL_MESSAGE,
							new ActionMessage("usuario.formulario.modificado",
									usuario.getLogin()));
					this.saveMessages(request, mensajes);
					// Volver
					log.debug("Datos del Usuario insertados correctamente");
					return mapping.findForward("success");

			} catch (Exception e) {
				// Error
				e.printStackTrace();
				tx.rollback();
				sesion.close();
				log.error("Error al grabar el usuario");
				errores.add("errores", new ActionMessage(
						"usuario.error.grabar.generico"));
				this.saveErrors(request, errores);
				return mapping.findForward("fail");
			}
		}
	}