
package action;

import hibernate.Asociacion;
import hibernate.AsociacionDAO;
import hibernate.Auxiliar;
import hibernate.HibernateSessionFactory;
import hibernate.Persona;
import hibernate.PersonaDependiente;
import hibernate.Usuario;
import hibernate.VistaPd;
import hibernate.VistaPdDAO;
import hibernate.VistaVoluntarios;
import hibernate.VistaVoluntariosDAO;

import java.util.ArrayList;
import java.util.Collection;
import java.util.Iterator;
import java.util.Set;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.apache.struts.action.Action;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;
import org.hibernate.Criteria;
import org.hibernate.criterion.Restrictions;

import form.ListadoAgendaForm;

public class ListadoAgendaAction extends Action {

	private static Log logs = LogFactory.getLog(ListadoAgendaAction.class);

	public ActionForward execute(ActionMapping mapping, ActionForm form,
			HttpServletRequest request, HttpServletResponse response) {
		
		ListadoAgendaForm listadoAgendaForm = (ListadoAgendaForm) form;
		
		Collection<PersonaDependiente> listaPD = new ArrayList<PersonaDependiente>();
		Collection<Auxiliar> listaVoluntarios = new ArrayList<Auxiliar>();
		
		HttpSession session = request.getSession(false);
		if (session != null && session.getAttribute("usuario") != null) {
			Usuario u = (Usuario)session.getAttribute("usuario");
			logs.debug("El usuario Loggeado es " + u.getLogin());
		
			if ("3".equals(u.getPerfil().getId().toString())) {
				// Es coordinador
				AsociacionDAO asoDAO = new AsociacionDAO();
				Collection<Asociacion> l = asoDAO.findAll();
				Iterator<Asociacion> i = l.iterator();
				boolean esta = false;
				Asociacion miAso = new Asociacion();
				while ((i.hasNext()) && (!esta)) {
					Asociacion aso = (Asociacion)i.next();
					Persona p = aso.getPersona();
					if (p != null) {
						if (p.getId().equals(u.getPersona().getId())) {
							// Hemos encontrado la Asociaci�n del coordinador logeado
							miAso = aso;
							esta = true;
							request.setAttribute("id", miAso.getId().toString());
						}
					}
				}
				VistaVoluntariosDAO vistaVolDAO = new VistaVoluntariosDAO();
				// Criterio Busqueda
				if ((listadoAgendaForm.getNombreFiltroAgenda() != null)
						&& (!listadoAgendaForm.getNombreFiltroAgenda().equals(""))) {
					// Asignamos el criteria
					Criteria c = HibernateSessionFactory.getSession().createCriteria(
							VistaVoluntarios.class);
					
					c.add(Restrictions.eq("idAsociacion", miAso.getId()));
					c.add(Restrictions.isNull("fecBajaUsuario"));	
					c.add(Restrictions.or(Restrictions.ilike("login", "%" 
							+ listadoAgendaForm.getNombreFiltroAgenda()+ "%"),
							Restrictions.or(Restrictions.ilike("nombre", "%" 
							+ listadoAgendaForm.getNombreFiltroAgenda() + "%"),
							Restrictions.or(Restrictions.ilike("apellido1", "%"
													+ listadoAgendaForm.getNombreFiltroAgenda() + "%"),
							Restrictions.ilike("apellido2", "%"	+ listadoAgendaForm.getNombreFiltroAgenda() + "%"))))
						);
					listaVoluntarios = c.list();
				} else {
					listaVoluntarios = vistaVolDAO.findAllAsociacion(miAso.getId().toString());
				}
				request.getSession().setAttribute("listadoVoluntarios", listaVoluntarios);
				return mapping.findForward("successCoordinador");
			} else if ("2".equals(u.getPerfil().getId().toString())) {
				// Es voluntario
				VistaPdDAO vistaPdDAO = new VistaPdDAO(); 
				Set<Auxiliar> vols = u.getAuxiliars();
				Auxiliar a = (Auxiliar)vols.toArray()[0];
				// Criterio Busqueda
				// Asignamos el criteria
				Criteria c = HibernateSessionFactory.getSession().createCriteria(
						VistaPd.class);
				if ((listadoAgendaForm.getNombreFiltroAgenda() != null)
						&& (!listadoAgendaForm.getNombreFiltroAgenda().equals(""))) {
					c.add(Restrictions.eq("idAsociacion", a.getAsociacion().getId()));
					c.add(Restrictions.eq("idAuxiliar",  a.getId()));
					c.add(Restrictions.isNull("fecBaja"));	
					c.add(Restrictions.or(Restrictions.ilike("nombre",
							"%"	+ listadoAgendaForm.getNombreFiltroAgenda() + "%"),
							Restrictions.or(
								Restrictions.ilike("apellido1", "%"
													+ listadoAgendaForm.getNombreFiltroAgenda() + "%"),
								Restrictions.ilike("apellido2", "%"
													+ listadoAgendaForm.getNombreFiltroAgenda() + "%"))));
					listaPD = c.list();
				} else {
					listaPD = vistaPdDAO.findAllAsociacionVoluntario(
							a.getAsociacion().getId().toString(), a.getId().toString());
				}
				request.getSession().setAttribute("listadoPD", listaPD);
				return mapping.findForward("successVoluntario");
			}
			return mapping.findForward("fail");
		}
		return mapping.findForward("fail");
	}
}