
package action;

import hibernate.HibernateSessionFactory;
import hibernate.VistaAsociacion;

import java.util.Collection;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.apache.struts.action.Action;
import org.apache.struts.action.ActionErrors;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;
import org.hibernate.Criteria;
import org.hibernate.criterion.Restrictions;
import org.hibernate.exception.JDBCConnectionException;

import util.ConstantesProyecto;

import form.ListadoAsociacionForm;

public class ListadoAsociacionAction extends Action {

	private static Log log = LogFactory.getLog(ListadoAsociacionAction.class);

	public ActionForward execute(ActionMapping mapping, ActionForm form,
			HttpServletRequest request, HttpServletResponse response) {
		
		ListadoAsociacionForm listadoAsoForm = (ListadoAsociacionForm) form;
		// errores
		ActionErrors mensajes = new ActionErrors();
		
		try {
			
			if (this.isCancelled(request)) {
				return mapping.findForward("cancel");
			}
			// boton nuevo
	        if (request.getParameter(ConstantesProyecto.PARAMETER_NUEVO) != null) {
	            // volver
	            return mapping.findForward("nuevo");
	        }
			// criteria
			Criteria c = HibernateSessionFactory.getSession().createCriteria(
					VistaAsociacion.class);

			if ((listadoAsoForm.getNombre() != null)
					&& (!listadoAsoForm.getNombre().equals(""))) {

				c.add(Restrictions.ilike("nombre",
						"%"	+ listadoAsoForm.getNombre() + "%"));	
			} 
			
			// Recogemos la lista
			Collection<VistaAsociacion> listaAsociacion = c.list();
			request.getSession().setAttribute("listadoAsociacion", listaAsociacion);

			return mapping.findForward("success");
			
		} catch (JDBCConnectionException e) {
			// Error de conexion a la BD
			throw e;
		} catch (Exception e) {
			e.printStackTrace();
			log.error("Se ha producido un error al listar los servicios");
			return mapping.findForward("fail");
		}
	}
}