
package action;

import java.util.Collection;
import java.util.Iterator;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.apache.struts.action.Action;
import org.apache.struts.action.ActionErrors;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;
import org.hibernate.Criteria;
import org.hibernate.criterion.Restrictions;

import hibernate.Asociacion;
import hibernate.AsociacionDAO;
import hibernate.Auxiliar;
import hibernate.Persona;
import hibernate.PersonaDependiente;
import hibernate.Usuario;
import hibernate.VistaPd;
import hibernate.HibernateSessionFactory;
import hibernate.VistaPdDAO;
import form.ListadoCuestionarioForm;
import util.ConstantesProyecto;

public class ListadoCuestionarioAction extends Action {

	private static Log log = LogFactory.getLog(ListadoCuestionarioAction.class);

	@Override
	public ActionForward execute(ActionMapping mapping, ActionForm form,
			HttpServletRequest request, HttpServletResponse response) {
		
		ListadoCuestionarioForm listadocuestionarioForm = (ListadoCuestionarioForm) form;
		// errores
		ActionErrors mensajes = new ActionErrors();
		
		try {
			
			if (this.isCancelled(request)) {
				return mapping.findForward("cancel");
			}
			
			HttpSession session = request.getSession(false);
			if (session != null && session.getAttribute("usuario") != null) {
				Usuario u = (Usuario)session.getAttribute("usuario");
				
				AsociacionDAO asoDAO = new AsociacionDAO();
				Collection<Asociacion> l = asoDAO.findAll();
				Iterator<Asociacion> i = l.iterator();
						
				// Solo admitimos un Coordinador por Asociaci�n
				boolean esta = false;
				Asociacion miAso = new Asociacion();
				while ((i.hasNext()) && (!esta)) {
					Asociacion aso = (Asociacion)i.next();
					Persona p = aso.getPersona();
					if (p != null) {
						if (p.getId().equals(u.getPersona().getId())) {
							// Hemos encontrado la Asociaci�n del coordinador logeado
							miAso = aso;
							esta = true;
							request.setAttribute("id", miAso.getId().toString());
						}
					}
				}
				// Criteria
				
				// criteria
				Criteria c = HibernateSessionFactory.getSession().createCriteria(
						VistaPd.class);

				if ((listadocuestionarioForm.getNombrePD() != null)
						&& (!listadocuestionarioForm.getNombrePD().equals(""))) {

					c.add(Restrictions.or(Restrictions.ilike("nombre",
							"%"	+ listadocuestionarioForm.getNombrePD() + "%"),
							Restrictions.or(
								Restrictions.ilike("apellido1", "%"
													+ listadocuestionarioForm.getNombrePD() + "%"),
								Restrictions.ilike("apellido2", "%"
													+ listadocuestionarioForm.getNombrePD() + "%"))));	
				} 
				
				// lista de voluntarios
				Collection<PersonaDependiente> listaPD = c.list();
				
				// Cargamos Personas Dependientes		
				VistaPdDAO pdDAO = new VistaPdDAO();
				if (u.getPerfil().getId().toString().equals(ConstantesProyecto.PERFIL_VOLUNTARIO)) {
					Auxiliar vol = (Auxiliar)u.getAuxiliars().toArray()[0];
					Collection<VistaPdDAO> listaPDVol = pdDAO.findAllVoluntario(
							vol.getId().toString());
					listaPDVol.retainAll(listaPD);
					request.getSession().setAttribute("listadoPDVol", listaPDVol);
					return mapping.findForward("successVoluntario");
				} else if (u.getPerfil().getId().toString().equals(ConstantesProyecto.PERFIL_COORDINADOR)) {
					Collection<VistaPdDAO> listaPDCoord = pdDAO.findAllAsociacion(miAso.getId().toString());
					listaPDCoord.retainAll(listaPD);
					request.getSession().setAttribute("listadoPD", listaPDCoord);
					return mapping.findForward("successCoordinador");
				} else {
					return mapping.findForward("fail");
				}
				
			}
			return mapping.findForward("fail");
		} catch (Exception e) {
			e.printStackTrace();
			log.error("Se ha producido un error al listar las personas dependientes");
			return mapping.findForward("fail");
		}
	}
}