
package action;

import java.util.Collection;
import java.util.Iterator;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.apache.struts.action.Action;
import org.apache.struts.action.ActionErrors;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;
import org.hibernate.Criteria;
import org.hibernate.JDBCException;
import org.hibernate.criterion.Restrictions;
import org.hibernate.exception.JDBCConnectionException;

import hibernate.Asociacion;
import hibernate.AsociacionDAO;
import hibernate.Persona;
import hibernate.PersonaDependiente;
import hibernate.PersonaDependienteDAO;
import hibernate.Usuario;
import hibernate.VistaPd;
import hibernate.HibernateSessionFactory;
import hibernate.VistaPdDAO;
import form.ListadoPDForm;
import util.ConstantesProyecto;

public class ListadoPDAction extends Action {

	private static Log log = LogFactory.getLog(ListadoPDAction.class);

	@Override
	public ActionForward execute(ActionMapping mapping, ActionForm form,
			HttpServletRequest request, HttpServletResponse response) {
		
		ListadoPDForm listadoPDForm = (ListadoPDForm) form;
		// errores
		ActionErrors mensajes = new ActionErrors();
		
		try {
			
			if (this.isCancelled(request)) {
				return mapping.findForward("cancel");
			}
			
			HttpSession session = request.getSession(false);
			if (session != null && session.getAttribute("usuario") != null) {
				Usuario u = (Usuario)session.getAttribute("usuario");
				log.debug("El usuario Loggeado es " + u.getLogin());
				
				AsociacionDAO asoDAO = new AsociacionDAO();
				Collection<Asociacion> l = asoDAO.findAll();
				Iterator<Asociacion> i = l.iterator();
						
				// Solo admitimos un Coordinador por Asociaci�n
				boolean esta = false;
				Asociacion miAso = new Asociacion();
				while ((i.hasNext()) && (!esta)) {
					Asociacion aso = (Asociacion)i.next();
					Persona p = aso.getPersona();
					if (p != null) {
						if (p.getId().equals(u.getPersona().getId())) {
							// Hemos encontrado la Asociaci�n del coordinador logeado
							miAso = aso;
							esta = true;
							request.setAttribute("id", miAso.getId().toString());
						}
					}
				}
				// Cargamos Personas Dependientes		
				listadoPDForm.setNombreAsociacion(miAso.getNombre());
				// boton nuevo
		        if (request.getParameter(ConstantesProyecto.PARAMETER_NUEVO) != null) {
		            // nueva
		            return mapping.findForward("nuevo");
		        }
				// criteria
				Criteria c = HibernateSessionFactory.getSession().createCriteria(
						VistaPd.class);
	
				if ((listadoPDForm.getNombre() != null)
						&& (!listadoPDForm.getNombre().equals(""))) {
	
					c.add(Restrictions.eq("idAsociacion", miAso.getId()));
					Collection<PersonaDependiente> listaPD2 = c.list();
					c.add(Restrictions.or(Restrictions.ilike("nombre",
							"%"	+ listadoPDForm.getNombre() + "%"),
							Restrictions.or(
								Restrictions.ilike("apellido1", "%"
													+ listadoPDForm.getNombre() + "%"),
								Restrictions.ilike("apellido2", "%"
													+ listadoPDForm.getNombre() + "%"))));	
					Collection<PersonaDependiente> listaPD = c.list();
					// Y la mandamos
					request.getSession().setAttribute("listadoPD", listaPD);
				} else {
					// lista de todos los voluntarios de la asociacion
					VistaPdDAO pdDAO = new VistaPdDAO();
					Collection<VistaPdDAO> listaPD = pdDAO.findAllAsociacion(miAso.getId().toString());
					request.getSession().setAttribute("listadoPD", listaPD);
				}
				
				
				
				
				return mapping.findForward("success");
			}
			return mapping.findForward("fail");
			
		} catch (JDBCConnectionException e) {
			// Error de conexion a la BD
			throw e;
		} catch (Exception e) {
			e.printStackTrace();
			log.error("Se ha producido un error al listar las personas dependientes");
			return mapping.findForward("fail");
		}
	}
}