
package action;

import java.util.Collection;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.apache.struts.action.Action;
import org.apache.struts.action.ActionErrors;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;
import org.apache.struts.action.ActionMessage;
import org.hibernate.Criteria;
import org.hibernate.criterion.Restrictions;

import hibernate.VistaUsuarios;
import hibernate.HibernateSessionFactory;
import form.ListadoUsuarioForm;
import util.ConstantesProyecto;

public class ListadoUsuarioAction extends Action {

	private static Log logs = LogFactory.getLog(ListadoUsuarioAction.class);

	@Override
	public ActionForward execute(ActionMapping mapping, ActionForm form,
			HttpServletRequest request, HttpServletResponse response) {

		ListadoUsuarioForm listadoUsuarioForm = (ListadoUsuarioForm) form;
		// Errores
		ActionErrors mensajes = new ActionErrors();

		try {
			// boton nuevo
			if (request.getParameter(ConstantesProyecto.PARAMETER_NUEVO) != null) {
				// Volver
				return mapping.findForward("nuevo");
			}

			// criteria
			Criteria c = HibernateSessionFactory.getSession().createCriteria(
					VistaUsuarios.class);
			// nombre de usuario
			if (listadoUsuarioForm.getUsuario() != null) {
				logs.debug("nombre de usuario: " + "%"
						+ listadoUsuarioForm.getUsuario() + "%");
				c.add(Restrictions.ilike("login", "%"
						+ listadoUsuarioForm.getUsuario() + "%"));
			}
			
			// lista de usuarios
			Collection<VistaUsuarios> listaUsuarios = c.list();

			request.getSession().setAttribute("listadoUsuario", listaUsuarios);
			logs
					.info("Se ha creado la lista de usuarios satisfactoriamente con "
							+ listaUsuarios.size() + " usuarios");
			return mapping.findForward("success");
		} catch (Exception e) {
			e.printStackTrace();
			// usuario no existe
			mensajes.add("mensaje_error", new ActionMessage(
					"usuario.listado.error.listado"));
			this.saveErrors(request, mensajes);
			// error
			return mapping.findForward("fail");

		}
	}
}