
package action;

import hibernate.Asociacion;
import hibernate.AsociacionDAO;
import hibernate.HibernateSessionFactory;
import hibernate.Persona;
import hibernate.Usuario;
import hibernate.VistaVoluntarios;

import java.util.Collection;
import java.util.Iterator;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.apache.struts.action.Action;
import org.apache.struts.action.ActionErrors;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;
import org.hibernate.Criteria;
import org.hibernate.criterion.Restrictions;

import util.ConstantesProyecto;

import form.ListadoVoluntarioForm;


public class ListarConsultasAction extends Action {

	// Gestor de logs
	private static Log logs = LogFactory.getLog(ListarConsultasAction.class);

	@Override
	public ActionForward execute(ActionMapping mapping, ActionForm form,
			HttpServletRequest request, HttpServletResponse response) {
		
		ActionErrors mensajes = new ActionErrors();
		
		try {
			
			if (this.isCancelled(request)) {
				return mapping.findForward("volver");
			}
			// boton nuevo
	        if (request.getParameter(ConstantesProyecto.PARAMETER_NUEVO) != null) {
	            // Devolvemos nuevo
	            return mapping.findForward("nuevo");
	        }
	        HttpSession session = request.getSession(false);
			if (session != null && session.getAttribute("usuario") != null) {
				Usuario u = (Usuario)session.getAttribute("usuario");
				logs.debug("El usuario Loggeado es " + u.getLogin());
				
				AsociacionDAO asoDAO = new AsociacionDAO();
				Collection<Asociacion> l = asoDAO.findAll();
				Iterator<Asociacion> i = l.iterator();
						
				// Solo admitimos un Coordinador por Asociacion
				boolean esta = false;
				Asociacion miAso = new Asociacion();
				while ((i.hasNext()) && (!esta)) {
					Asociacion aso = (Asociacion)i.next();
					Persona p = aso.getPersona();
					if (p != null) {
						if (p.getId().equals(u.getPersona().getId())) {
							// Hemos encontrado la Asociacion del coordinador logeado
							miAso = aso;
							esta = true;
							request.setAttribute("id", miAso.getId().toString());
						}
					}
				}
				String id_aso = miAso.getId().toString();
			}
			// criteria
			Criteria c = HibernateSessionFactory.getSession().createCriteria(
					VistaVoluntarios.class);

			// lista de voluntarios
			Collection<VistaVoluntarios> listaVoluntario = c.list();
			request.getSession().setAttribute("listadoVoluntarios", listaVoluntario);
			
			return mapping.findForward("success");
			
		} catch (Exception e) {
			
			return mapping.findForward("fail");	
		}
			
	}
}
