
package action;

import java.util.Collection;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.apache.struts.action.Action;
import org.apache.struts.action.ActionErrors;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;
import org.hibernate.Criteria;
import org.hibernate.JDBCException;
import org.hibernate.criterion.Restrictions;
import org.hibernate.exception.JDBCConnectionException;

import hibernate.PersonaDependiente;
import hibernate.VistaInformePd;
import hibernate.HibernateSessionFactory;
import form.InformesForm;

public class ListarInformeListaPDAction extends Action {

	private static Log logs = LogFactory.getLog(ListarInformeListaPDAction.class);

	@Override
	public ActionForward execute(ActionMapping mapping, ActionForm form,
			HttpServletRequest request, HttpServletResponse response) {
		
		InformesForm listadoInformeForm = (InformesForm) form;
		// Errores
		ActionErrors mensajes = new ActionErrors();
		
		try {
			if (this.isCancelled(request)) {
				return mapping.findForward("cancel");
			}
			// criteria
			Criteria c = HibernateSessionFactory.getSession().createCriteria(
					VistaInformePd.class);
			// Por nombre
			if ((listadoInformeForm.getNombre() != null)
					&& (!listadoInformeForm.getNombre().equals(""))) {

				c.add(Restrictions.or(Restrictions.ilike("nombre",
						"%"	+ listadoInformeForm.getNombre() + "%"),
							Restrictions.ilike("apellidos", "%"
												+ listadoInformeForm.getNombre() + "%")));	
			 }else { 
	            	if (logs.isDebugEnabled()) logs.debug("No filtramos por nombre");
	         } 
			
			// lista de voluntarios
			Collection<PersonaDependiente> listaPD = c.list();
			request.getSession().setAttribute("listadoPD", listaPD);
			
			return mapping.findForward("success");
			
		} catch (JDBCConnectionException e) {
			// Error de conexion a la BD
			throw e;
		} catch (Exception e) {
			e.printStackTrace();
			logs.error("Se ha producido un error al listar los beneficiarios");
			return mapping.findForward("fail");
		}
	}
}