
package action;

import java.util.List;

import hibernate.Usuario;
import hibernate.UsuarioDAO;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import org.apache.struts.action.Action;
import org.apache.struts.action.ActionErrors;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;
import org.apache.struts.action.ActionMessage;

import util.EncryptionToolbox;

import form.LoginForm;


public class LoginAction extends Action {

	private static Log logs = LogFactory.getLog(LoginAction.class);
	
	
	public ActionForward execute(ActionMapping mapping, ActionForm form,
			HttpServletRequest request, HttpServletResponse response) {
		
		try {
			LoginForm loginForm = (LoginForm) form;
			UsuarioDAO userDAO = new UsuarioDAO();
			
			// Errores
			ActionErrors mensajes = new ActionErrors();
			
			List<Usuario> listaUsuarios = userDAO.findByLogin(loginForm.getUsuario());

			if ((listaUsuarios.size() == 0) || (listaUsuarios.size() > 1)) {
				logs.warn("El usuario que se intenta autentificar no existe");
				// Usuario no existe
				mensajes.add("mensaje_error", new ActionMessage(
					"logon.usuario.incorrecto"));
				this.saveErrors(request, mensajes);
				// DError
				return mapping.findForward("fail");
			} else {
				// Usuario
				if (listaUsuarios.get(0) instanceof Usuario) {
					Usuario usuario = listaUsuarios.get(0);
					// Comprobamos  clave
					java.lang.String code;
					code = EncryptionToolbox.md5(loginForm.getClave()); 
					if (usuario.getClave().equals(EncryptionToolbox.md5(loginForm.getClave()))) {
						logs.info("El usuario " + usuario.getLogin()
								+ " se ha autentificado.");
						// usuario y clave correctas
						request.getSession().setAttribute("usuario",
								usuario);
						// Entramos
						return mapping.findForward("success");
					} else {
						logs.warn("La clave introducida no coincide con la del sistema");
						// usuario no existe
						mensajes.add("mensaje_error", new ActionMessage(
								"logon.usuario.incorrecto"));
						// Error
						this.saveErrors(request, mensajes);
						return mapping.findForward("fail");
					}
				} else {
					logs.error("No se puede instanciar el usuario");
					// El usuario no existe
					mensajes.add("mensaje_error", new ActionMessage(
							"logon.usuario.incorrecto"));
					this.saveErrors(request, mensajes);
					return mapping.findForward("fail");
				}
			}
		} catch (Exception e) {
			e.printStackTrace();
			return mapping.findForward("fail");
		}
	}
}