
package action;

import java.sql.Timestamp;
import java.util.Date;

import form.ConsultaForm;
import hibernate.AuxiliarDAO;
import hibernate.Consulta;
import hibernate.ConsultaDAO;
import hibernate.HibernateSessionFactory;
import hibernate.Persona;
import hibernate.PersonaDAO;
import hibernate.PersonaDependiente;
import hibernate.PersonaDependienteDAO;
import hibernate.Usuario;

import util.CorreoEnvio;
import util.GestionCorreoElectronico;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.apache.struts.action.Action;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;
import org.apache.struts.action.ActionMessage;
import org.apache.struts.action.ActionMessages;
import org.hibernate.Session;
import org.hibernate.Transaction;

public class NuevaConsultaAction extends Action {

	private static Log log = LogFactory.getLog(NuevaConsultaAction.class);

	public ActionForward execute(ActionMapping mapping, ActionForm form,
			HttpServletRequest request, HttpServletResponse response) {
		
		ConsultaForm cform = (ConsultaForm) form;
		// mensajes
		ActionMessages mensaje = new ActionMessages();
		
		try {
			if (request.getParameter("volver") != null) {
				return mapping.findForward("volver");
			}
			
			HttpSession session = request.getSession(false);
			Usuario u = null;
			if (session != null && session.getAttribute("usuario") != null) {
				u = (Usuario)session.getAttribute("usuario");
				log.debug("El usuario Loggeado es " + u.getLogin());

				// Clases Auxiliares
				ConsultaDAO cDAO = new ConsultaDAO();
				PersonaDependienteDAO pdDAO = new PersonaDependienteDAO();
				PersonaDAO pDAO = new PersonaDAO();
				AuxiliarDAO volDAO = new AuxiliarDAO();
				Persona p = u.getPersona();
				PersonaDependiente pd = (PersonaDependiente)pdDAO.findByProperty("persona",p).get(0);
				// Consulta, Voluntarios y PD
				Consulta c = new Consulta();
				c.setPregunta(cform.getPregunta());
				c.setFecAlta(new Timestamp(new Date().getTime()));
				c.setPersonaDependiente(pd);
				c.setAuxiliar(pd.getAuxiliar());
				// Mandamos mail
					try{
						String strEmailFrom= pd.getAuxiliar().getUsuario().getPersona().getEmail();
						if (!strEmailFrom.trim().equals("")){
							// preparamos mail
							CorreoEnvio correo = new CorreoEnvio();
							correo.setAsunto("Consulta " + new Timestamp(new Date().getTime()));
							correo.setContenido("<b>CiberVoluntariado</b><br><br>Hola " + 
									pd.getAuxiliar().getUsuario().getPersona().getNombre() + "<br>" +
									pd.getPersona().getNombre_apellidos() + " le ha enviado la siguiente consulta: <br>" +
									"<i>" + c.getPregunta() + "</i><br>" +
									"<br>Para responder, por favor, identifiquese en la aplicación y/o envíe un mail a la dirección <i>" + 
									pd.getPersona().getEmail() + "</i><br> Gracias.");
							correo.setEmail_from(pd.getPersona().getEmail());
							correo.setEmail_to(pd.getAuxiliar().getUsuario().getPersona().getEmail());
							correo.setCabecera("CiberVoluntariado");
							GestionCorreoElectronico.EnvioCorreo(correo);
							
							// Introducimos el mensaje
							mensaje.add("mensaje", new ActionMessage("consulta.nueva"));
							this.saveMessages(request, mensaje);
							log.debug("Se ha enviado el mail correctamente");
						}
				    } catch (Exception e){
				    	log.warn("Error inesperado enviando mail");
						e.printStackTrace();
						return mapping.findForward("fail");	
				    }
				// Grabamos la consulta
				// Abrimos Sesion
				Session sesion = HibernateSessionFactory.getSession();			
				Transaction tx = sesion.beginTransaction();
				// Guardamos 
				cDAO.save(c);
				// Cerramos Sesion
				tx.commit();
				sesion.close();		
				return mapping.findForward("success");
			}
			return mapping.findForward("fail");	
		} catch (Exception e) {
			log.warn("Error inesperado en el proceso de realizar consultas");
			e.printStackTrace();
			return mapping.findForward("fail");	
		}
	}
}