
package action;

import java.sql.Timestamp;
import java.util.Collection;
import java.util.Date;
import java.util.Iterator;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.apache.struts.action.Action;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;
import org.apache.struts.action.ActionMessage;
import org.apache.struts.action.ActionMessages;
import org.hibernate.Session;
import org.hibernate.Transaction;

import hibernate.Asociacion;
import hibernate.AsociacionDAO;
import hibernate.Auxiliar;
import hibernate.AuxiliarDAO;
import hibernate.LocalidadDAO;
import hibernate.PerfilDAO;
import hibernate.PersonaDependiente;
import hibernate.PersonaDependienteDAO;
import hibernate.Persona;
import hibernate.PersonaDAO;
import hibernate.HibernateSessionFactory;
import hibernate.Usuario;
import hibernate.UsuarioDAO;
import form.PDForm;
import util.ConstantesProyecto;
import util.DatesToolbox;
import util.EncryptionToolbox;

public class PDAction extends Action {

	private static Log log = LogFactory.getLog(PDAction.class);

	public ActionForward execute(ActionMapping mapping, ActionForm form,
			HttpServletRequest request, HttpServletResponse response) {
		
		PDForm PDForm = (PDForm) form;
		// Mensajes
		ActionMessages mensajes = new ActionMessages();
		
		try {
			
			if (request.getParameter("guardar") != null) {
				if ((PDForm.getId() != null) && (!PDForm.getId().toString().equals(""))) {
					// Editando
					mensajes.add(ActionMessages.GLOBAL_MESSAGE,new ActionMessage("cibervoluntariado.aceptar",
							ConstantesProyecto.MSM_ACEPTAR_MODIFICACION_PD 
							+ PDForm.getNombre() + " " + PDForm.getApellido1()));
					this.saveMessages((HttpSession) request.getSession(), mensajes);
					return mapping.findForward("aceptar");
				}
			}
			
			// Detectamos Asociación
			HttpSession session = request.getSession(false);
			if (session != null && session.getAttribute("usuario") != null) {
				Usuario u = (Usuario)session.getAttribute("usuario");
				log.debug("El usuario Loggeado es " + u.getLogin());
				
				AsociacionDAO asoDAO = new AsociacionDAO();
				Collection<Asociacion> l = asoDAO.findAll();
				Iterator<Asociacion> i = l.iterator();
						
				// Solo admitimos un Coordinador por Asociaci�n
				boolean esta = false;
				Asociacion miAso = new Asociacion();
				while ((i.hasNext()) && (!esta)) {
					Asociacion aso = (Asociacion)i.next();
					Persona p = aso.getPersona();
					if (p != null) {
						if (p.getId().equals(u.getPersona().getId())) {
							// Hemos encontrado la Asociaci�n del coordinador logeado
							miAso = aso;
							esta = true;
							request.setAttribute("id", miAso.getId().toString());
						}
					}
				}
				
				// Clases Auxiliares
				PersonaDependiente ben = new PersonaDependiente();
				PersonaDependienteDAO benDAO = new PersonaDependienteDAO();
				
				Persona persona = new Persona();
				PersonaDAO personaDAO = new PersonaDAO();
				LocalidadDAO locDAO = new LocalidadDAO();
				Auxiliar aux = new Auxiliar();
				AuxiliarDAO auxDAO = new AuxiliarDAO();
				
				boolean dniExistente = false;
				
				// Volver
				if (request.getParameter("volver") != null)  {
					return mapping.findForward("volver");
				}
				
				// Persona
				if ((request.getParameter("id") != null) && (!request.getParameter("id").toString().equals(""))) {
					ben = benDAO.findById(Integer.parseInt(request.getParameter("id").toString()));
					if (!dniExistente) {
						persona = personaDAO.findById(ben.getPersona().getId());
					}
					
					PDForm.setId(ben.getId().toString());
					PDForm.setId_persona(persona.getId().toString());
					
					if ((PDForm.getDni()!=null) && (!PDForm.getDni().equals("")))
						persona.setDni(PDForm.getDni());
	
					if ((PDForm.getNombre()!=null) && (!PDForm.getNombre().equals("")))
						persona.setNombre(PDForm.getNombre());
					else
						persona.setNombre(null);
					if ((PDForm.getApellido1()!=null) && (!PDForm.getApellido1().equals("")))
						persona.setApellido1(PDForm.getApellido1());
					else
						persona.setApellido1(null);
					if ((PDForm.getApellido2()!=null) && (!PDForm.getApellido2().equals("")))
						persona.setApellido2(PDForm.getApellido2());
					else
						persona.setApellido2(null);
					if ((PDForm.getDireccion()!=null) && (!PDForm.getDireccion().equals("")))
						persona.setDireccion(PDForm.getDireccion());
					else 
						persona.setDireccion(null);
					if ((PDForm.getFecha_nacimiento()!=null) && (!PDForm.getFecha_nacimiento().equals("")))
						persona.setFechaNacimiento(DatesToolbox.getDBDateFromSpanish(PDForm.getFecha_nacimiento()));
					else
						persona.setFechaNacimiento(null);
					if ((PDForm.getTelefono()!=null) && (!PDForm.getTelefono().equals("")))
						persona.setTelefono(PDForm.getTelefono());
					else 
						persona.setTelefono(null);
					
					if (!PDForm.getLocalidad().toString().equals("")) {
						persona.setLocalidad(locDAO.findById(Integer.parseInt(PDForm.getLocalidad())));
					} else {
						persona.setLocalidad(locDAO.findById(18));
					}
					if (!PDForm.getEmail().toString().equals("")) {
						persona.setEmail(PDForm.getEmail());
					} else {
						persona.setEmail(null);
					}
					
					// sesion			
					Session sesion = HibernateSessionFactory.getSession();			
					Transaction tx = sesion.beginTransaction();
					
					// Grabamos
					personaDAO.merge(persona);
					ben.setPersona(persona);
					
					// PD
					ben.setAsociacion(miAso);
					if ((PDForm.getCentro_de_salud()!=null) && (!PDForm.getCentro_de_salud().equals(""))) {
						ben.setCentroSalud(PDForm.getCentro_de_salud());
					} else {
						ben.setCentroSalud(null);
					}
					if ((PDForm.getMedico_de_cabecera()!=null) && (!PDForm.getMedico_de_cabecera().equals(""))) {
						ben.setMedicoCabecera(PDForm.getMedico_de_cabecera());
					} else {
						ben.setMedicoCabecera(null);
					}
					if ((PDForm.getCausa_baja()!=null) && (!PDForm.getCausa_baja().equals("")))
						ben.setCausaBaja(PDForm.getCausa_baja());
					else
						ben.setCausaBaja(null);
					if ((PDForm.getDiscapacidad()!=null) && (!PDForm.getDiscapacidad().equals("")))
						ben.setDiscapacidad(Integer.parseInt(PDForm.getDiscapacidad()));
					else
						ben.setDiscapacidad(null);
					if ((PDForm.getSexo()!=null) && (!PDForm.getSexo().equals("")))
						if (PDForm.getSexo().equals("H"))
							ben.setSexo("H");
						else if (PDForm.getSexo().equals("M"))
							ben.setSexo("M");
						else
							ben.setSexo(null);
					else
						ben.setSexo(null);
					if ((PDForm.getEstado_civil()!=null) && (!PDForm.getEstado_civil().equals("")))
						ben.setEstadoCivil(PDForm.getEstado_civil());
					else
						ben.setEstadoCivil(null);
					
					if (PDForm.getPuede_firmar() != null) {
						if (PDForm.getPuede_firmar().equals("on")) {
							ben.setPuedeFirmar(true);
						} else {
							ben.setPuedeFirmar(false);
						}
					} else {
						ben.setPuedeFirmar(false);
					}
					
					benDAO.merge(ben);
					
					// mensaje
					mensajes.add("mensaje", new ActionMessage("PD.editado", persona.getNombre_apellidos()));
					this.saveMessages(request, mensajes);
					// Guardamos 
					tx.commit();
					sesion.close();
					
				}	else {
					
					// Nueva Persona Dependiente
					if (!dniExistente) {
						persona = new Persona();
						if ((PDForm.getDni()!=null) && (!PDForm.getDni().equals("")))
							persona.setDni(PDForm.getDni());
	
						if ((PDForm.getNombre()!=null) && (!PDForm.getNombre().equals("")))
							persona.setNombre(PDForm.getNombre());
						else
							persona.setNombre(null);
						if ((PDForm.getApellido1()!=null) && (!PDForm.getApellido1().equals("")))
							persona.setApellido1(PDForm.getApellido1());
						else
							persona.setApellido1(null);
						if ((PDForm.getApellido2()!=null) && (!PDForm.getApellido2().equals("")))
							persona.setApellido2(PDForm.getApellido2());
						else
							persona.setApellido2(null);
						if ((PDForm.getDireccion()!=null) && (!PDForm.getDireccion().equals("")))
							persona.setDireccion(PDForm.getDireccion());
						else 
							persona.setDireccion(null);
						if ((PDForm.getFecha_nacimiento()!=null) && (!PDForm.getFecha_nacimiento().equals("")))
							persona.setFechaNacimiento(DatesToolbox.getDBDateFromSpanish(PDForm.getFecha_nacimiento()));
						else
							persona.setFechaNacimiento(null);
						if ((PDForm.getTelefono()!=null) && (!PDForm.getTelefono().equals("")))
							persona.setTelefono(PDForm.getTelefono());
						else 
							persona.setTelefono(null);
						
						if (!PDForm.getLocalidad().toString().equals("")) {
							persona.setLocalidad(locDAO.findById(Integer.parseInt(PDForm.getLocalidad())));
						} else {
							persona.setLocalidad(locDAO.findById(1));
						}
						if (!PDForm.getEmail().toString().equals("")) {
							persona.setEmail(PDForm.getEmail());
						} else {
							persona.setEmail(null);
						}
						
						
						// sesion			
						Session sesion = HibernateSessionFactory.getSession();			
						Transaction tx = sesion.beginTransaction();
						
						// Grabamos
						persona.setFechaAlta(new Timestamp(new Date().getTime()));
						if (dniExistente) 
							personaDAO.merge(persona);
						else
							personaDAO.save(persona);
						
						ben.setPersona(persona);
						
						// pd
						ben.setAsociacion(miAso);
						if ((PDForm.getCentro_de_salud()!=null) && (!PDForm.getCentro_de_salud().equals(""))) {
							ben.setCentroSalud(PDForm.getCentro_de_salud());
						} else {
							ben.setCentroSalud(null);
						}
						if ((PDForm.getMedico_de_cabecera()!=null) && (!PDForm.getMedico_de_cabecera().equals(""))) {
							ben.setMedicoCabecera(PDForm.getMedico_de_cabecera());
						} else {
							ben.setMedicoCabecera(null);
						}
						if ((PDForm.getCausa_baja()!=null) && (!PDForm.getCausa_baja().equals("")))
							ben.setCausaBaja(PDForm.getCausa_baja());
						else
							ben.setCausaBaja(null);
						if ((PDForm.getDiscapacidad()!=null) && (!PDForm.getDiscapacidad().equals("")))
							ben.setDiscapacidad(Integer.parseInt(PDForm.getDiscapacidad()));
						else
							ben.setDiscapacidad(null);
						if ((PDForm.getSexo()!=null) && (!PDForm.getSexo().equals("")))
							if (PDForm.getSexo().equals("H"))
								ben.setSexo("H");
							else if (PDForm.getSexo().equals("M"))
								ben.setSexo("M");
							else
								ben.setSexo(null);
						else
							ben.setSexo(null);
						if ((PDForm.getEstado_civil()!=null) && (!PDForm.getEstado_civil().equals("")))
							ben.setEstadoCivil(PDForm.getEstado_civil());
						else
							ben.setEstadoCivil(null);
						
						if (PDForm.getPuede_firmar() != null) {
							if (PDForm.getPuede_firmar().equals("on")) {
								ben.setPuedeFirmar(true);
							} else {
								ben.setPuedeFirmar(false);
							}
						} else {
							ben.setPuedeFirmar(false);
						}
						ben.setFecAltaBeneficiario(new Timestamp(new Date().getTime()));
						benDAO.save(ben);
						
						// Usuario
						Usuario usuario = new Usuario();
						PerfilDAO perfilDAO = new PerfilDAO();
						UsuarioDAO usuarioDAO = new UsuarioDAO();
						
						usuario.setFecAlta(new Timestamp(new Date().getTime()));
						usuario.setFecBaja(null);
						usuario.setPerfil(perfilDAO.findById(4));
						
						usuario.setPersona(persona);
						if (PDForm.getUsuarioPD() != null)
							usuario.setLogin(PDForm.getUsuarioPD());
	
						if ((!PDForm.getClavePD().equals(""))) {
							usuario.setClave(EncryptionToolbox.md5(PDForm.getClavePD()));
						}
						
						usuarioDAO.save(usuario);
						
						// Guardamos 
						tx.commit();
						sesion.close();
						// mensaje
						mensajes.add("mensaje", new ActionMessage("PD.nuevo", persona.getNombre()));
						this.saveMessages(request, mensajes);
					} else {

					}
				}

				log.debug("Persona Dependiente EDITADA");
				return mapping.findForward("success");
			}
			return mapping.findForward("fail");

		} catch (Exception e) {
			log.warn("Error editando persona dependiente");
			e.printStackTrace();
			return mapping.findForward("fail");	
		}
	}
}