
package action;

import java.util.ArrayList;
import java.util.Collection;
import java.util.Iterator;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.apache.struts.action.Action;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;

import form.AsociacionForm;
import hibernate.Asociacion;
import hibernate.AsociacionDAO;
import hibernate.Auxiliar;
import hibernate.AuxiliarDAO;
import hibernate.Localidad;
import hibernate.LocalidadDAO;
import hibernate.Persona;
import hibernate.Usuario;
import hibernate.UsuarioDAO;

public class PreparaAsociacionAction extends Action {

	private static Log logs = LogFactory.getLog(PreparaAsociacionAction.class);

	@Override
	public ActionForward execute(ActionMapping mapping, ActionForm form,
			HttpServletRequest request, HttpServletResponse response)
			throws Exception {

		try {
			
			AsociacionForm asoForm = (AsociacionForm) form;
			
			// localidades
			LocalidadDAO locDAO = new LocalidadDAO();
			Collection<Localidad> listaLocalidades = locDAO.findAll();
			request.getSession().setAttribute("listadoLocalidades",
					listaLocalidades);
			
			AuxiliarDAO auxDAO = new AuxiliarDAO();
			
			UsuarioDAO userDAO = new UsuarioDAO();
			Collection<Usuario> listaCoordinadores = userDAO.findAllCoordinadores();
			AsociacionDAO asoDAO = new AsociacionDAO();
			Collection<Asociacion> l = asoDAO.findAll();
			Iterator<Asociacion> i = l.iterator();
			// Solo admitimos un Coordinador por Asociaci�n
			boolean encontrado = false;
			while (i.hasNext()) {
				Persona p = i.next().getPersona();
				if (p != null) {
					Iterator<Usuario> i2 = listaCoordinadores.iterator();
					while ((i2.hasNext()) && (!encontrado)) {
						Usuario u = i2.next();
						if ((p.getId() == u.getPersona().getId()))
							// listaCoordinadores.remove(u);
						encontrado = true;
					}
				}
			}
			request.getSession().setAttribute("listadoCoordinadores",
					listaCoordinadores);
			if ((request.getParameter("id") != null)
					&& (!request.getParameter("id").equals("0"))) {
				//  Asociaci�n
				Asociacion miAso = new Asociacion();
				miAso = asoDAO.findById(Integer.parseInt(request.getParameter("id")));
				Collection<Auxiliar> listadoVolNoAsignados = auxDAO.findAllNoAsignados(miAso.getLocalidad().getId());
				Collection<Auxiliar> listadoVolAsignados = new ArrayList<Auxiliar>();
				request.getSession().setAttribute("listadoVoluntariosNoAsignados",
						listadoVolNoAsignados);
				request.getSession().setAttribute("listadoVoluntariosAsignados",
						listadoVolAsignados);
				
				
				// Datos Asociacion
				asoForm.setId(miAso.getId().toString());
				asoForm.setNombre(miAso.getNombre());
				asoForm.setTelefono(miAso.getTelefono());
				asoForm.setDescripcion(miAso.getDescripcion());
				asoForm.setDireccion(miAso.getDireccion());
				asoForm.setLocalidad(miAso.getLocalidad().getId().toString());
				Usuario coord = (Usuario) miAso.getPersona().getUsuarios().toArray()[0];
				asoForm.setId_coordinador(coord.getId().toString());
				return mapping.findForward("success");
			} else  {
				// Nueva Asociacion
				
				return mapping.findForward("success");
			}
	

		} catch (Exception e) {
			e.printStackTrace();
			throw e;
		}
	}

}