
package action;

import java.util.ArrayList;
import java.util.Collection;
import java.util.Iterator;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.apache.struts.action.Action;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;


import form.AsociacionForm;
import hibernate.Asociacion;
import hibernate.AsociacionDAO;
import hibernate.Auxiliar;
import hibernate.AuxiliarDAO;
import hibernate.Localidad;
import hibernate.LocalidadDAO;
import hibernate.Persona;
import hibernate.Usuario;
import hibernate.UsuarioDAO;

public class PreparaAsociacionEditarAction extends Action {

	private static Log logs = LogFactory.getLog(PreparaAsociacionEditarAction.class);

	@Override
	public ActionForward execute(ActionMapping mapping, ActionForm form,
			HttpServletRequest request, HttpServletResponse response)
			throws Exception {

		try {
			
			AsociacionForm asoForm = (AsociacionForm) form;
			
			// localidades
			LocalidadDAO locDAO = new LocalidadDAO();
			Collection<Localidad> listaLocalidades = locDAO.findAll();
			request.getSession().setAttribute("listadoLocalidades",
					listaLocalidades);
			
			// Asociacion
			UsuarioDAO userDAO = new UsuarioDAO();
			Collection<Usuario> listaCoordinadores = userDAO.findAllCoordinadores();
			// Capturamos el usuario loggeado para conocer su asociacion
			HttpSession session = request.getSession(false);
			if (session != null && session.getAttribute("usuario") != null) {
				Usuario u = (Usuario)session.getAttribute("usuario");
				logs.debug("El usuario Loggeado es " + u.getLogin());
				
				AsociacionDAO asoDAO = new AsociacionDAO();
				Collection<Asociacion> l = asoDAO.findAll();
				Iterator<Asociacion> i = l.iterator();
						
				// Solo admitimos un Coordinador por Asociaci�n
				boolean esta = false;
				Asociacion miAso = new Asociacion();
				while ((i.hasNext()) && (!esta)) {
					Asociacion aso = (Asociacion)i.next();
					Persona p = aso.getPersona();
					if (p != null) {
						if (p.getId().equals(u.getPersona().getId())) {
							// Hemos encontrado la Asociaci�n del coordinador logeado
							miAso = aso;
							esta = true;
							request.setAttribute("id", miAso.getId().toString());
						}
					}
				}
				// Cargamos VOLUNTARIOS
				AuxiliarDAO auxDAO = new AuxiliarDAO();
				Collection<Auxiliar> listadoVolNoAsignados = auxDAO.findAllNoAsignados(miAso.getLocalidad().getId());
				Collection<Auxiliar> listadoVolAsignadosAux = auxDAO.findAllAsociacion( miAso.getId().toString());
				Collection<Usuario> users = userDAO.findAll();
				Collection<Auxiliar> listadoVolAsignados = new ArrayList<Auxiliar>();
				Iterator<Auxiliar> itaux = listadoVolAsignadosAux.iterator();
				while(itaux.hasNext()) {
					Auxiliar aux = itaux.next();
					if (users.contains(aux.getUsuario())) {
						listadoVolAsignados.add(aux);
					}
				}
				
				request.getSession().setAttribute("listadoVoluntariosNoAsignados",
						listadoVolNoAsignados);
				request.getSession().setAttribute("listadoVoluntariosAsignados",
						listadoVolAsignados);
				// Lista de Coordinadores
				Iterator<Asociacion> i1 = l.iterator();
				// Solo admitimos un Coordinador por Asociacion 
				while (i1.hasNext()) {
					Asociacion a = i1.next();
					Persona p = a.getPersona();
					boolean encontrado = false;
					if (p != null) {
						Iterator<Usuario> i2 = listaCoordinadores.iterator();
						while ((i2.hasNext()) && (!encontrado)) {
							Usuario u2 = i2.next();
							if ((p.getId() == u2.getPersona().getId())) {
								encontrado = true;
								listaCoordinadores.remove(u2);
							}
						}
					}
				}
				listaCoordinadores.add(u);
				request.getSession().setAttribute("listadoCoordinadores",
						listaCoordinadores);
				// Datos propios de la Asociacion
				asoForm.setId(miAso.getId().toString());
				asoForm.setNombre(miAso.getNombre());
				asoForm.setTelefono(miAso.getTelefono());
				asoForm.setDescripcion(miAso.getDescripcion());
				asoForm.setDireccion(miAso.getDireccion());
				asoForm.setLocalidad(miAso.getLocalidad().getId().toString());
				asoForm.setId_coordinador(u.getId().toString());
				
				return mapping.findForward("success");
			}
			
			return mapping.findForward("fail");
			
		} catch (Exception e) {
			e.printStackTrace();
			throw e;
		}
	}

}