
package action;

import hibernate.Asociacion;
import hibernate.AsociacionDAO;
import hibernate.Persona;
import hibernate.PersonaDependiente;
import hibernate.PersonaDependienteDAO;
import hibernate.Servicio;
import hibernate.ServicioDAO;
import hibernate.Usuario;

import java.util.Collection;
import java.util.Iterator;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.apache.struts.action.Action;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;


public class PreparaEstadisticaMediaHorasAction extends Action {

	private static Log logs = LogFactory
			.getLog(PreparaEstadisticaMediaHorasAction.class);

	@Override
	public ActionForward execute(ActionMapping mapping, ActionForm form,
			HttpServletRequest request, HttpServletResponse response)
			throws Exception {
		
		PersonaDependienteDAO pdDAO = new PersonaDependienteDAO();
		ServicioDAO servicioDAO = new ServicioDAO();

		double totalHoras = 0;
		double totalHorasAsociacion = 0;
		double dMediaHoras = 0;
		double dMediaHorasAsociacon = 0;

		try {
			Asociacion miAso = new Asociacion();
			HttpSession session = request.getSession(false);
			if (session != null && session.getAttribute("usuario") != null) {
				Usuario u = (Usuario)session.getAttribute("usuario");
				logs.debug("El usuario Loggeado es " + u.getLogin());
				
				AsociacionDAO asoDAO = new AsociacionDAO();
				Collection<Asociacion> l = asoDAO.findAll();
				Iterator<Asociacion> i = l.iterator();
						
				// Solo admitimos un Coordinador por Asociacion
				boolean esta = false;
				
				while ((i.hasNext()) && (!esta)) {
					Asociacion aso = (Asociacion)i.next();
					Persona p = aso.getPersona();
					if (p != null) {
						if (p.getId().equals(u.getPersona().getId())) {
							// Hemos encontrado la Asociacion del coordinador logeado
							miAso = aso;
							esta = true;
							request.setAttribute("id", miAso.getId().toString());
						}
					}
				}
			}
			
			// Servicios
			Iterator<Servicio> itServicio = servicioDAO.findAll().iterator();
			while (itServicio.hasNext()) {

				try {
					Servicio servicio = (Servicio) itServicio.next();
					// total de horas
					PersonaDependiente per = pdDAO.findById(servicio.getPersonaDependiente().getId());
					if (per.getAsociacion().getId() == miAso.getId())
						totalHorasAsociacion += (servicio.getHoraByHoraFin().getId() - servicio.getHoraByHoraInicio().getId());
					totalHoras += (servicio.getHoraByHoraFin().getId() - servicio.getHoraByHoraInicio().getId());
				} catch (Exception e) {
					logs.debug("Error Accediendo a los Servicios");
					e.printStackTrace();
					throw e;
				}
			}

			// Numero total de pd
			dMediaHorasAsociacon = totalHorasAsociacion / pdDAO.findAllAsociacion(miAso.getId()).size();
			dMediaHoras = totalHoras / pdDAO.findAll().size();
			request.setAttribute("mediaHorasAsociacion", dMediaHorasAsociacon);
			request.setAttribute("mediaHoras", dMediaHoras);
			request.setAttribute("totalPD", pdDAO.findAllAsociacion(miAso.getId()).size());
			return mapping.findForward("success");

		} catch (Exception e) {
			logs.error("Error inesperado en el modulo de estadísticas");
			e.printStackTrace();
			throw e;
		}
	}
}