
package action;

import hibernate.Asociacion;
import hibernate.AsociacionDAO;
import hibernate.Auxiliar;
import hibernate.Persona;
import hibernate.Usuario;
import hibernate.VistaVoluntariosDAO;

import java.util.Collection;
import java.util.Iterator;
import java.util.Set;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.apache.struts.action.Action;
import org.apache.struts.action.ActionErrors;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;
import org.hibernate.exception.JDBCConnectionException;

import util.ConstantesProyecto;

import form.ListadoAgendaForm;

public class PreparaListadoAgendaAction extends Action {

	private static Log logs = LogFactory.getLog(PreparaListadoAgendaAction.class);
	

	@Override
	public ActionForward execute(ActionMapping mapping, ActionForm form,
			HttpServletRequest request, HttpServletResponse response) {
		
		ListadoAgendaForm listadoAgendaForm = (ListadoAgendaForm) form;
		// Error
		ActionErrors mensajes = new ActionErrors();
		
		try {
			
			HttpSession session = request.getSession(false);
			if (session != null && session.getAttribute("usuario") != null) {
				Usuario u = (Usuario)session.getAttribute("usuario");
				logs.debug("El usuario Loggeado es " + u.getLogin());
				
				// Cargamos Voluntarios o Personas Dependientes segun el perfil
				if (ConstantesProyecto.PERFIL_COORDINADOR.equals(u.getPerfil().getId().toString())) {
					// Es coordinador
					AsociacionDAO asoDAO = new AsociacionDAO();
					Collection<Asociacion> l = asoDAO.findAll();
					Iterator<Asociacion> i = l.iterator();
					boolean esta = false;
					Asociacion miAso = new Asociacion();
					while ((i.hasNext()) && (!esta)) {
						Asociacion aso = (Asociacion)i.next();
						Persona p = aso.getPersona();
						if (p != null) {
							if (p.getId().equals(u.getPersona().getId())) {
								// Hemos encontrado la Asociaci�n del coordinador logeado
								miAso = aso;
								esta = true;
								request.setAttribute("id", miAso.getId().toString());
							}
						}
					}
					listadoAgendaForm.setNombreAsociacion(miAso.getNombre());
					VistaVoluntariosDAO vistaVolDAO = new VistaVoluntariosDAO();
					Collection<Auxiliar> listaVoluntarios = vistaVolDAO.findAllAsociacion(miAso.getId().toString());
					request.getSession().setAttribute("listadoVoluntarios", listaVoluntarios);
					return mapping.findForward("successCoordinador");
				} else if (ConstantesProyecto.PERFIL_VOLUNTARIO.equals(u.getPerfil().getId().toString())) {
					// Es voluntario
					Set<Auxiliar> vols = u.getAuxiliars();
					Auxiliar a = (Auxiliar)vols.toArray()[0];
					listadoAgendaForm.setIdVoluntario(a.getId().toString());
					return mapping.findForward("successVoluntario");
				}
			}
			return mapping.findForward("fail");
			
		} catch (JDBCConnectionException e) {
			// Error de conexion a la BD
			throw e;
		} catch (Exception e) {
			e.printStackTrace();
			logs.error("Se ha producido un error al listar los voluntarios");
			return mapping.findForward("fail");
		}
	}
}