
package action;

import hibernate.Asociacion;
import hibernate.AsociacionDAO;
import hibernate.Auxiliar;
import hibernate.AuxiliarDAO;
import hibernate.Consulta;
import hibernate.ConsultaDAO;
import hibernate.Persona;
import hibernate.PersonaDAO;
import hibernate.PersonaDependiente;
import hibernate.PersonaDependienteDAO;
import hibernate.Usuario;
import hibernate.UsuarioDAO;

import java.util.Collection;
import java.util.Iterator;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.apache.struts.action.Action;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;

import form.ConsultaForm;

public class PreparaListadoConsultasAction extends Action {

	private static Log log = LogFactory.getLog(PreparaListadoConsultasAction.class);

	public ActionForward execute(ActionMapping mapping, ActionForm form,
			HttpServletRequest request, HttpServletResponse response) {
		
		ConsultaForm cform = (ConsultaForm) form;
		
		try {
			
			HttpSession session = request.getSession(false);
			Usuario u = null;
			if (session != null && session.getAttribute("usuario") != null) {
				u = (Usuario)session.getAttribute("usuario");
				log.debug("El usuario Loggeado es " + u.getLogin());
				
				AsociacionDAO asoDAO = new AsociacionDAO();
				Collection<Asociacion> l = asoDAO.findAll();
				Iterator<Asociacion> i = l.iterator();
						
				// Solo admitimos un Coordinador por Asociaci�n
				boolean esta = false;
				Asociacion miAso = new Asociacion();
				while ((i.hasNext()) && (!esta)) {
					Asociacion aso = (Asociacion)i.next();
					Persona p = aso.getPersona();
					if (p != null) {
						if (p.getId().equals(u.getPersona().getId())) {
							// Hemos encontrado la Asociaci�n del coordinador logeado
							miAso = aso;
							esta = true;
							request.setAttribute("id", miAso.getId().toString());
						}
					}
				}
			
				ConsultaDAO conDAO = new ConsultaDAO();
				PersonaDAO perDAO = new PersonaDAO();
				UsuarioDAO userDAO = new UsuarioDAO();
				AuxiliarDAO volDAO = new AuxiliarDAO(); 
				PersonaDependienteDAO pdDAO = new PersonaDependienteDAO();
				cform.setNombreAsociacion(miAso.getNombre());
				Auxiliar vol = new Auxiliar();
				if (u != null) {
					// Voluntario
					if (u.getPerfil().getId() == 2) {
						Usuario user = userDAO.findById(u.getId());
						vol = (Auxiliar)volDAO.findByProperty("usuario", user).get(0);
						Collection<Consulta> listaConsultas = conDAO.findAllVol(vol.getId().toString());
						request.getSession().setAttribute("listadoConsultas", listaConsultas);
						return mapping.findForward("successVol");
					// Asociado
					} else if (u.getPerfil().getId() == 4) {
						PersonaDependiente pd1 = (PersonaDependiente)pdDAO.findByProperty("persona", u.getPersona()).toArray()[0];
						Collection<Consulta> listaConsultasNoRes = conDAO.findAllAso(pd1.getId().toString());
						Collection<Consulta> listaConsultasRes = conDAO.findAllAsoRes(pd1.getId().toString());
						cform.setId_vol(pd1.getAuxiliar().getId().toString());
						cform.setNombreVol(pd1.getAuxiliar().getUsuario().getPersona().getNombre_apellidos());
						request.getSession().setAttribute("listadoConsultasRespondidas", listaConsultasRes);
						request.getSession().setAttribute("listadoConsultasNoRespondidas", listaConsultasNoRes);
						return mapping.findForward("successAso");
					}
				}
			}			
			return mapping.findForward("success");
		} catch (Exception e) {
			log.warn("Error inesperado en el proceso de realizar consultas");
			e.printStackTrace();
			return mapping.findForward("fail");	
		}
	}
}