
package action;

import form.ListadoCuestionarioForm;
import hibernate.Asociacion;
import hibernate.AsociacionDAO;
import hibernate.Auxiliar;
import hibernate.Persona;
import hibernate.Usuario;
import hibernate.VistaPdDAO;

import java.util.Collection;
import java.util.Iterator;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.apache.struts.action.Action;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;

import util.ConstantesProyecto;

public class PreparaListadoCuestionarioAction extends Action {

	private static Log logs = LogFactory
			.getLog(PreparaListadoCuestionarioAction.class);

	@Override
	public ActionForward execute(ActionMapping mapping, ActionForm form,
			HttpServletRequest request, HttpServletResponse response)
			throws Exception {
		
		try {
			ListadoCuestionarioForm listadoCuestionarioForm = (ListadoCuestionarioForm) form;
			listadoCuestionarioForm.reset(mapping, request);
			
			HttpSession session = request.getSession(false);
			if (session != null && session.getAttribute("usuario") != null) {
				Usuario u = (Usuario)session.getAttribute("usuario");
				logs.debug("El usuario Loggeado es " + u.getLogin());
				
				AsociacionDAO asoDAO = new AsociacionDAO();
				Collection<Asociacion> l = asoDAO.findAll();
				Iterator<Asociacion> i = l.iterator();
						
				// Solo admitimos un Coordinador por Asociaci�n
				boolean esta = false;
				Asociacion miAso = new Asociacion();
				while ((i.hasNext()) && (!esta)) {
					Asociacion aso = (Asociacion)i.next();
					Persona p = aso.getPersona();
					if (p != null) {
						if (p.getId().equals(u.getPersona().getId())) {
							// Hemos encontrado la Asociaci�n del coordinador logeado
							miAso = aso;
							esta = true;
							request.setAttribute("id", miAso.getId().toString());
						}
					}
				}
				listadoCuestionarioForm.setNombreAsociacion(miAso.getNombre());
				// Cargamos Personas Dependientes		
				VistaPdDAO pdDAO = new VistaPdDAO();
				if (u.getPerfil().getId().toString().equals(ConstantesProyecto.PERFIL_VOLUNTARIO)) {
					Auxiliar vol = (Auxiliar)u.getAuxiliars().toArray()[0];
					Collection<VistaPdDAO> listaPDVol = pdDAO.findAllVoluntario(
							vol.getId().toString());
					request.getSession().setAttribute("listadoPDVol", listaPDVol);
					return mapping.findForward("successVoluntario");
				} else if (u.getPerfil().getId().toString().equals(ConstantesProyecto.PERFIL_COORDINADOR)) {
					Collection<VistaPdDAO> listaPD = pdDAO.findAllAsociacion(miAso.getId().toString());
					request.getSession().setAttribute("listadoPD", listaPD);
					return mapping.findForward("successCoordinador");
				} else {
					return mapping.findForward("fail");
				}
				
			}
			return mapping.findForward("fail");
		} catch (Exception e) {
			logs.error("Error cargando cuestionarios");
			e.printStackTrace();
			throw e;
		}
	}
}