
package action;

import hibernate.Persona;
import hibernate.PersonaDependiente;
import hibernate.PersonaDependienteDAO;
import hibernate.Servicio;
import hibernate.ServicioDAO;

import java.util.Iterator;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.apache.struts.action.Action;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;


public class PreparaMediaHorasIndividualAction extends Action {

	private static Log logs = LogFactory
			.getLog(PreparaMediaHorasIndividualAction.class);

	@Override
	public ActionForward execute(ActionMapping mapping, ActionForm form,
			HttpServletRequest request, HttpServletResponse response)
			throws Exception {

		// error
		PersonaDependienteDAO pdDAO = new PersonaDependienteDAO();
		ServicioDAO serDAO = new ServicioDAO();
		PersonaDependiente pd;
		Persona persona;
		
		double dMediaHorasDiarias = 0;

		try {
			if (request.getParameter("id") != null) {
				int idBeneficiario = Integer.parseInt(request
						.getParameter("id"));
				pd = pdDAO.findById(idBeneficiario);
				persona = pd.getPersona();
				double totalHorasPD = 0;
				
				Iterator<Servicio> itServicios = serDAO.findAll().iterator();
				while (itServicios.hasNext()) {
						
						Servicio servicio = (Servicio) itServicios.next();
						if (pd.getId() == servicio.getPersonaDependiente().getId())
							totalHorasPD += (servicio.getHoraByHoraFin().getId() 
									- servicio.getHoraByHoraInicio().getId());
				}
				dMediaHorasDiarias = totalHorasPD / 5;
				// datos
				request.setAttribute("mediaHoras", dMediaHorasDiarias);
				request.setAttribute("pd", pd);
				request.setAttribute("persona", persona);

				return mapping.findForward("success");
			} 
			return mapping.findForward("fail");
			
		} catch (Exception e) {
			logs.error("Error generando estadísticas");
			e.printStackTrace();
			throw e;
		}
	}
}