
package action;

import java.text.SimpleDateFormat;
import java.util.Collection;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.apache.struts.action.Action;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;

import hibernate.PersonaDependiente;
import hibernate.PersonaDependienteDAO;

import hibernate.Localidad;
import hibernate.LocalidadDAO;
import form.PDForm;


public class PreparaPDAction extends Action {

	private static Log log = LogFactory
			.getLog(PreparaPDAction.class);

	@Override
	public ActionForward execute(ActionMapping mapping, ActionForm form,
			HttpServletRequest request, HttpServletResponse response) {

		PDForm PDForm = (PDForm) form;

		try {
			
			// localidades
			LocalidadDAO locDAO = new LocalidadDAO();
			Collection<Localidad> listaLocalidades = locDAO.findAll();
			request.getSession().setAttribute("listadoLocalidades",
					listaLocalidades);

			PersonaDependiente pd = new PersonaDependiente();
			PersonaDependienteDAO pdDAO = new PersonaDependienteDAO();

			String id_pd = null;

			if ((request.getParameter("id") != null)
					&& (!(request.getParameter("id").toString().equals("")))) {
				id_pd = request.getParameter("id").toString();
			} else if ((request.getAttribute("id") != null)
					&& (!(request.getAttribute("id").toString().equals("")))) {
				id_pd = request.getAttribute("id").toString();
			}
			if (id_pd != null) {
				// datos PD
				pd = pdDAO.findById(Integer.parseInt(id_pd));
				PDForm.setNombre(pd.getPersona()
						.getNombre());
				PDForm.setApellido1(pd.getPersona()
						.getApellido1());
				PDForm.setId(pd.getId().toString());
				PDForm.setId_persona(pd.getPersona()
						.getId().toString());
				if (pd.getPersona().getFechaNacimiento() != null) {
					SimpleDateFormat sdf = new SimpleDateFormat("dd/MM/yyyy");
					PDForm.setFecha_nacimiento(sdf.format(pd.getPersona().getFechaNacimiento()));
				}
				PDForm.setDni(pd.getPersona().getDni());
				PDForm.setApellido2(pd.getPersona()
						.getApellido2());
				PDForm.setCausa_baja(pd.getCausaBaja());
				PDForm.setEmail(pd.getPersona().getEmail());
				PDForm.setCentro_de_salud(pd.getCentroSalud());
				PDForm.setDireccion(pd.getPersona()
						.getDireccion());
				if (pd.getDiscapacidad() != null)
					PDForm.setDiscapacidad(pd.getDiscapacidad()
							.toString());
				PDForm.setEstado_civil(pd.getEstadoCivil());
				if ((pd.getPersona().getLocalidad() != null)
						&& (!pd.getPersona().getLocalidad().getId()
								.equals("")))
					PDForm.setLocalidad(pd.getPersona()
							.getLocalidad().getId().toString());
				PDForm.setMedico_de_cabecera(pd
						.getMedicoCabecera());
				if ((pd.getPuedeFirmar() != null) && (pd.getPuedeFirmar()))
					PDForm.setPuede_firmar("on");
				else
					PDForm.setPuede_firmar("off");
				PDForm.setSexo(pd.getSexo());
				PDForm.setTelefono(pd.getPersona()
						.getTelefono());

			}	else {
				PDForm.clean(mapping, request);
			}
			
			return mapping.findForward("success");
		} catch (Exception e) {
			log
					.warn("Error creando persona dependiente");
			e.printStackTrace();
			return mapping.findForward("fail");
		}
	}
}