
package action;

import hibernate.CuestionarioEstadoEconomico;
import hibernate.CuestionarioEstadoFamiliar;
import hibernate.CuestionarioEstadoFisico;
import hibernate.CuestionarioEstadoPsiquico;
import hibernate.PersonaDependiente;
import hibernate.PersonaDependienteDAO;
import hibernate.RespuestaEstadoEconomico;
import hibernate.RespuestaEstadoFamiliar;
import hibernate.RespuestaEstadoFisico;
import hibernate.RespuestaEstadoPsiquico;

import java.util.Iterator;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.apache.struts.action.Action;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;

import form.ResultadoForm;


public class PreparaResultadoAction extends Action {

	private static Log log = LogFactory.getLog(PreparaResultadoAction.class);
	
	public boolean respondido(Object[] a, String tipo) {
		boolean res = false;
		RespuestaEstadoFisico auxf = null;
		RespuestaEstadoPsiquico auxp = null;
		RespuestaEstadoFamiliar auxfa = null;
		RespuestaEstadoEconomico auxe = null;
		for (int i=0;i<a.length;i++) {
			if (tipo.equals("f")) {
				auxf = (RespuestaEstadoFisico)a[i];
			} else if (tipo.equals("p")) {
				auxp = (RespuestaEstadoPsiquico)a[i];
			} else if (tipo.equals("fa")) {
				auxfa = (RespuestaEstadoFamiliar)a[i];
			} else if (tipo.equals("e")) {
				auxe = (RespuestaEstadoEconomico)a[i];
			}
			if ((auxf.getPuntuacion()!=null) && (auxp.getPuntuacion()!=null) && 
					(auxfa.getPuntuacion()!=null) && (auxe.getPuntuacion()!=null)) {
				res = true;
			}
		}
		return res;
	}
	
	public ActionForward execute(ActionMapping mapping, ActionForm form,
			HttpServletRequest request, HttpServletResponse response) {

		ResultadoForm rForm = (ResultadoForm) form;
		
		try {
			
			if ((request.getParameter("id") != null) && 
					(!"".equals(request.getParameter("id").toString()))) {
				PersonaDependienteDAO pdDAO = new PersonaDependienteDAO();
				PersonaDependiente pd = pdDAO.findById(Integer.parseInt(request.getParameter("id").toString()));
				rForm.setNombre(pd.getPersona().getNombre_apellidos());
				
				// Cuestionario Físico
				Integer pfisicas = 0;
				if (pd.getCuestionarioEstadoFisico() != null) {
					CuestionarioEstadoFisico cef = pd.getCuestionarioEstadoFisico();
					if (cef.getRespuestaEstadoFisicos() != null) {
						// if (respondido(cef.getRespuestaEstadoFisicos().toArray(),"f")) {
							Iterator<RespuestaEstadoFisico> itf = cef.getRespuestaEstadoFisicos().iterator();
							while (itf.hasNext()) {
								RespuestaEstadoFisico elem = itf.next();
								if ((elem.getPuntuacion() != null) && (!"".equals(elem.getPuntuacion().toString()))) {
									pfisicas += elem.getPuntuacion();
									rForm.setEvaluadofisico(true);
								}
							}
						// } else {
						// 	rForm.setEvaluadofisico(false);
						// }
					}
				}
				rForm.setPuntuacionfisicas(pfisicas.toString());
				// Cuestionario Psiquico
				Integer ppsiquicas = 0;
				if (pd.getCuestionarioEstadoPsiquico() != null) {
					CuestionarioEstadoPsiquico cep = pd.getCuestionarioEstadoPsiquico();
					if (cep.getRespuestaEstadoPsiquicos() != null) {
					//	if (respondido(cep.getRespuestaEstadoPsiquicos().toArray(),"p")) {
							Iterator<RespuestaEstadoPsiquico> itp = cep.getRespuestaEstadoPsiquicos().iterator();
							while (itp.hasNext()) {
								RespuestaEstadoPsiquico elem = itp.next();
								if ((elem.getPuntuacion() != null) && (!"".equals(elem.getPuntuacion().toString()))) {
									ppsiquicas += elem.getPuntuacion();
									rForm.setEvaluadopsiquico(true);
								}
							}
//						} else {
//							rForm.setEvaluadopsiquico(false);
//						}
					}
				}
				rForm.setPuntuacionpsiquicas(ppsiquicas.toString());
				
				// Cuestionario Familiar
				Integer pfamiliar = 0;
				if (pd.getCuestionarioEstadoFamiliar() != null) {
					CuestionarioEstadoFamiliar cef = pd.getCuestionarioEstadoFamiliar();
					if (cef.getRespuestaEstadoFamiliars() != null) {
					//	if (respondido(cef.getRespuestaEstadoFamiliars().toArray(),"fa")) {
							Iterator<RespuestaEstadoFamiliar> itfa = cef.getRespuestaEstadoFamiliars().iterator();
							while (itfa.hasNext()) {
								RespuestaEstadoFamiliar elem = itfa.next();
								if ((elem.getPuntuacion() != null) && (!"".equals(elem.getPuntuacion().toString()))) {
									pfamiliar+= elem.getPuntuacion();
									rForm.setEvaluadofamiliar(true);
								}
							}
//						} else {
//							rForm.setEvaluadofamiliar(false);
//						}
					}
				}
				rForm.setPuntuacionfamiliares(pfamiliar.toString());
				
				// Cuestionario Económico
				Integer peconomico = 0;
				if (pd.getCuestionarioEstadoEconomico() != null) {
					CuestionarioEstadoEconomico cee = pd.getCuestionarioEstadoEconomico();
					if (cee.getRespuestaEstadoEconomicos() != null) {
						// if (respondido(cee.getRespuestaEstadoEconomicos().toArray(),"e")) {
							Iterator<RespuestaEstadoEconomico> ite = cee.getRespuestaEstadoEconomicos().iterator();
							while (ite.hasNext()) {
								RespuestaEstadoEconomico elem = ite.next();
								if ((elem.getPuntuacion() != null) && (!"".equals(elem.getPuntuacion().toString()))) {
									peconomico += elem.getPuntuacion();	
									rForm.setEvaluadoeconomico(true);
								}
							}
//						} else {
//							rForm.setEvaluadoeconomico(false);
//						}
					}
				}
				rForm.setPuntuacioneconomicas(peconomico.toString());
				return mapping.findForward("success");
			}
			return mapping.findForward("fail");
			
		} catch (Exception e) {
			log.warn("Error inesperado preparando los resultados de los cuestionarios");
			e.printStackTrace();
			return mapping.findForward("fail");	
		}
	}
}