
package action;

import hibernate.Dia;
import hibernate.DiaDAO;
import hibernate.Hora;
import hibernate.HoraDAO;
import hibernate.LocalidadDAO;
import hibernate.PersonaDependiente;
import hibernate.PersonaDependienteDAO;
import hibernate.SubtipoEvento;
import hibernate.SubtipoEventoDAO;
import hibernate.TipoEvento;
import hibernate.TipoEventoDAO;

import java.util.Collection;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.apache.struts.action.Action;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;

import form.TareaForm;

public class PreparaTareaAction extends Action {

	private static Log log = LogFactory
			.getLog(PreparaTareaAction.class);

	public ActionForward execute(ActionMapping mapping, ActionForm form,
			HttpServletRequest request, HttpServletResponse response) {

		TareaForm tareaForm = (TareaForm) form;
		
		try {
			
			if ((request.getParameter("idVoluntario")!=null) &&
					(!"".equals(request.getParameter("idVoluntario").toString()))) {
				
				// Preparamos tarea
				LocalidadDAO locDAO = new LocalidadDAO();
				DiaDAO diaDAO = new DiaDAO(); 
				HoraDAO horaDAO = new HoraDAO();
				TipoEventoDAO teDAO = new TipoEventoDAO();
				SubtipoEventoDAO steDAO = new SubtipoEventoDAO();
				PersonaDependienteDAO pdDAO = new PersonaDependienteDAO();
				
				// Dias
				Collection<Dia> listaDias = diaDAO.findAll();
				request.getSession().setAttribute("listadoDias",
						listaDias);
				// Horas
				Collection<Hora> listaHorasInicio = horaDAO.findAll();
				request.getSession().setAttribute("listadoHoraInicio",
						listaHorasInicio);
				Collection<Hora> listaHorasFin = horaDAO.findAll();
				request.getSession().setAttribute("listadoHoraFin",
						listaHorasFin);
				// Evento
				Collection<TipoEvento> listaEvento = teDAO.findAll();
				request.getSession().setAttribute("listadoEventos",
						listaEvento);
				if ((request.getParameter("tarea")!=null) &&
						(!"".equals(request.getParameter("tarea").toString()))) {
					
					tareaForm.setTarea(request.getParameter("tarea").toString());
					// SubEvento
					Collection<SubtipoEvento> listaSubEventos = steDAO.findAllTarea(request.getParameter("tarea").toString());
					request.getSession().setAttribute("listadoSubEventos",
							listaSubEventos);
					tareaForm.setSelect(true);
				} else {
					tareaForm.setSelect(false);
					tareaForm.setSubtarea("");
					Collection<SubtipoEvento> listaSubEventos = steDAO.findAll();
					request.getSession().setAttribute("listadoSubEventos",
							listaSubEventos);
				}
				
				// Personas Dependientes del Voluntario
				Collection<PersonaDependiente> listaPD = pdDAO.findAllAsignados(request.getParameter("idVoluntario").toString());
				request.getSession().setAttribute("listadoPD",
						listaPD);
				
				request.setAttribute("idVoluntario", request.getParameter("idVoluntario"));
				return mapping.findForward("success");
			} else {
				return mapping.findForward("fail")
	;		}
			
		} catch (Exception e) {
			log.warn("Error inesperado en el proceso de preparacion del formulario de tramitacion de servicio");
			e.printStackTrace();
			return mapping.findForward("fail");
		}
	}
}
