
package action;

import hibernate.Asociacion;
import hibernate.AsociacionDAO;
import hibernate.Auxiliar;
import hibernate.AuxiliarDAO;
import hibernate.Localidad;
import hibernate.LocalidadDAO;
import hibernate.Persona;
import hibernate.PersonaDependiente;
import hibernate.PersonaDependienteDAO;
import hibernate.Usuario;

import java.text.SimpleDateFormat;
import java.util.Collection;
import java.util.Iterator;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.apache.struts.action.Action;
import org.apache.struts.action.ActionErrors;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;

import form.VoluntarioForm;

public class PreparaVoluntarioAction extends Action {

	private static Log log = LogFactory.getLog(PreparaVoluntarioAction.class);

	public ActionForward execute(ActionMapping mapping, ActionForm form,
			HttpServletRequest request, HttpServletResponse response) {
		
		VoluntarioForm voluntarioForm = (VoluntarioForm) form;
		voluntarioForm.clean(mapping, request);
		
		// errores
		ActionErrors mensajes = new ActionErrors();

		try {

			PersonaDependienteDAO pdDAO = new PersonaDependienteDAO();
			LocalidadDAO locDAO = new LocalidadDAO();
			
			Collection<Localidad> listaLocalidades = locDAO.findAll();
			request.getSession().setAttribute("listadoLocalidades", listaLocalidades);
			
			// editando
			if ((request.getParameter("id") != null) && (!request.getParameter("id").toString().equals(""))) {

				// Asociacion
				HttpSession session = request.getSession(false);
				Asociacion id_aso = null;
				if (session != null && session.getAttribute("usuario") != null) {
					Usuario u = (Usuario)session.getAttribute("usuario");
					log.debug("El usuario Loggeado es " + u.getLogin());
					
					AsociacionDAO asoDAO = new AsociacionDAO();
					Collection<Asociacion> l = asoDAO.findAll();
					Iterator<Asociacion> i = l.iterator();
							
					// Solo admitimos un Coordinador por Asociaci�n
					boolean esta = false;
					Asociacion miAso = new Asociacion();
					
					while ((i.hasNext()) && (!esta)) {
						Asociacion aso = (Asociacion)i.next();
						Persona p = aso.getPersona();
						if (p != null) {
							if (p.getId().equals(u.getPersona().getId())) {
								// Hemos encontrado la Asociaci�n del coordinador logeado
								miAso = aso;
								esta = true;
								request.setAttribute("id", miAso.getId().toString());
								id_aso = miAso;
							}
						}
					}
				}
				// Listados de pacientes
				Collection<PersonaDependiente> listaPDNoAsignados = pdDAO.findAllDesasignados(id_aso.getId().toString());
				Collection<PersonaDependiente> listaPDAsignados = pdDAO.findAllAsignados(request.getParameter("id").toString());
				request.getSession().setAttribute("listadoPDAsignados", listaPDAsignados);
				request.getSession().setAttribute("listadoPDNoAsignados", listaPDNoAsignados);
				// Datos del Voluntario
				AuxiliarDAO auxDAO = new AuxiliarDAO();
				Auxiliar aux = auxDAO.findById(Integer.parseInt(request.getParameter("id").toString()));
				voluntarioForm.setApellido1(aux.getUsuario().getPersona().getApellido1());
				voluntarioForm.setApellido2(aux.getUsuario().getPersona().getApellido2());
				voluntarioForm.setNombre(aux.getUsuario().getPersona().getNombre());
				voluntarioForm.setDni(aux.getUsuario().getPersona().getDni());
				voluntarioForm.setDireccion(aux.getUsuario().getPersona().getDireccion());
				voluntarioForm.setEmail(aux.getUsuario().getPersona().getEmail());
				if ((aux.getUsuario().getPersona().getFechaNacimiento() != null) && 
						(!aux.getUsuario().getPersona().getFechaNacimiento().toString().equals(""))) {
					SimpleDateFormat sdf = new SimpleDateFormat("dd/MM/yyyy");
					voluntarioForm.setFecha_nacimiento(sdf.format(aux.getUsuario().getPersona().getFechaNacimiento()));
				} else {
					voluntarioForm.setFecha_nacimiento("");
				}
				voluntarioForm.setTelefono(aux.getUsuario().getPersona().getTelefono());
				if ((aux.getDisponible() != null) && (aux.getDisponible()))
					voluntarioForm.setRadio_disponible("Si");
				else
					voluntarioForm.setRadio_disponible("No");
				if ((aux.getUsuario().getPersona().getLocalidad() != null) && 
						(!aux.getUsuario().getPersona().getLocalidad().toString().equals("")))
					voluntarioForm.setLocalidad(aux.getUsuario().getPersona().getLocalidad().getId().toString());
				else
					voluntarioForm.setLocalidad(null);
				voluntarioForm.setId(aux.getId().toString());
				voluntarioForm.setId_persona(aux.getUsuario().getPersona().getId().toString());
				voluntarioForm.setId_usuario(aux.getUsuario().getId().toString());
			}
			
			if ((request.getParameter("id") != null) && (!request.getParameter("id").toString().equals(""))) 
				return mapping.findForward("successEditar");
			else
				return mapping.findForward("success");
			
		} catch(Exception e) {
			e.printStackTrace();
			log.error("Se ha producido un error al acceder a la BBDD");
			return mapping.findForward("fail");
		}
	}
}