
package action;

import java.util.HashMap;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.apache.struts.action.ActionErrors;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;
import org.apache.struts.action.ActionMessage;
import org.apache.struts.actions.DispatchAction;

import hibernate.HibernateSessionFactory;
import util.ConstantesProyecto;
import util.GenerarInforme;
import util.GestionFicheros;


public class ProcesaInformesAction extends DispatchAction {

	private static Log logs = LogFactory.getLog(ProcesaInformesAction.class);

	
	public ActionForward informe(ActionMapping mapping, ActionForm form,
			HttpServletRequest request, HttpServletResponse response) {

		ActionErrors mensajes = new ActionErrors();
		
		try{	
			
			if ((request.getParameter("id") != null) && 
				(Integer.parseInt(request.getParameter("id").toString() )>0)) {
					
				Integer idPD = (Integer)Integer.parseInt(request.getParameter("id").toString());
					 
				byte[] bContenido=null; String strExt =ConstantesProyecto.GLOBAL_EXT_PDF;
					
				String nombreJasperInforme= "";
				String tituloInforme= "";
				String nombreFile = "";
					
				if ((request.getParameter(ConstantesProyecto.PARAMETER_INFORME_BASICO) != null)) {
					nombreJasperInforme =  ConstantesProyecto.PATH_JASPER_INFORME_BASICO;
					tituloInforme= ConstantesProyecto.TITULO_INFORME_BASICO;
					nombreFile = ConstantesProyecto.NOMBRE_INFORME_BASICO;
				}
					
				HashMap parameters = new HashMap();
				parameters.put(ConstantesProyecto.PARAMETER_ID_PD,idPD);
				String imagen= request.getSession().getServletContext().getRealPath(ConstantesProyecto.PARAMETER_PATH_IMG_CABECERA); 
				parameters.put(ConstantesProyecto.PARAMETER_PATH_IMG_INFORME,imagen);
				String strPathfile=  request.getSession().getServletContext().getRealPath(nombreJasperInforme);
					 
				if (tituloInforme!="")  parameters.put(ConstantesProyecto.PARAMETER_TITULO_INFORME,tituloInforme);
					 
				if (request.getParameter(ConstantesProyecto.GLOBAL_INFORME_PDF) != null) {
					// PDF
					try {						
					  	bContenido= GenerarInforme.GenerarInformePDF(strPathfile,tituloInforme,HibernateSessionFactory.getSession(),parameters);
					}catch (Exception e) {
						e.printStackTrace();
						return mapping.findForward("fail");
					}
				}				
				// crear informe 
			
			 	String strCabecera = GestionFicheros.obtenerCabeceraFichero(strExt);
	 			response.setContentType (strCabecera);
			    response.setHeader ("Content-disposition", "inline; filename=" + nombreFile +"."+ strExt);		  
			    response.setHeader ("Cache-Control", "max-age=30");		 
			    response.setHeader ("Pragma", "No-cache");		 
			    response.setDateHeader ("Expires", 0);		
			    response.setContentLength (bContenido.length);			      
			    response.getOutputStream().write(bContenido,0,bContenido.length);		    	
			    response.getOutputStream().flush ();	
			    response.getOutputStream().close ();
			      
				  return null;
				
			} else {
				if (logs.isErrorEnabled()) logs.error("El número de asociado  no consta en nuestra BD");		
				mensajes.add("mensaje_error" ,new ActionMessage("informes.error"));
				return mapping.findForward("fail");
				
			}
		} catch (Exception e) {
			HibernateSessionFactory.getSession().close();	
			e.printStackTrace();
			if (logs.isErrorEnabled()) logs.error("Se ha producido un error al generar el informe de los PDs en PDF");		
			mensajes.add("mensaje_error" ,new ActionMessage("informes.error"));							
			this.saveErrors(request, mensajes);
			return mapping.findForward("fail");
		} finally {
			HibernateSessionFactory.getSession().close();		
		}	

	}
	
	public ActionForward informeLista(ActionMapping mapping, ActionForm form,
			HttpServletRequest request, HttpServletResponse response) {
		
	
		ActionErrors mensajes = new ActionErrors();		
		try{	

					 byte[] bContenido=null; String strExt =ConstantesProyecto.GLOBAL_EXT_PDF;
					 
					String nombreJasperInforme= ConstantesProyecto.PATH_JASPER_INFORME_PD_ESTADO;
					String tituloInforme= ConstantesProyecto.TITULO_INFORME_PD_ESTADO;
					String nombreFile = ConstantesProyecto.NOMBRE_INFORME_PD_ESTADO;

					 HashMap parameters = new HashMap();
					 String imagen= request.getSession().getServletContext().getRealPath(ConstantesProyecto.PARAMETER_PATH_IMG_CABECERA); 
					 parameters.put(ConstantesProyecto.PARAMETER_PATH_IMG_INFORME,imagen);
					 String strPathfile=  request.getSession().getServletContext().getRealPath(nombreJasperInforme);
					 if (tituloInforme!="")  parameters.put(ConstantesProyecto.PARAMETER_TITULO_INFORME,tituloInforme);
					 
					 if (request.getParameter(ConstantesProyecto.GLOBAL_INFORME_PDF) != null || request.getParameter(ConstantesProyecto.GLOBAL_INFORME_PDF + ".x")!=null)  {
						
						// PDF
						try {						
						  	bContenido= GenerarInforme.GenerarInformePDF(strPathfile,tituloInforme,HibernateSessionFactory.getSession(),parameters);
						}catch (Exception e) {
							e.printStackTrace();
							if (logs.isErrorEnabled()) logs.error("Se ha producido un error al generar el informe de los PDs en PDF");		
							mensajes.add("mensaje_error" ,new ActionMessage("informes.error"));							
							this.saveErrors(request, mensajes);
							return mapping.findForward("fail");
						}
					}	
					 
				  // creamos informe 
			
			 	  String strCabecera=GestionFicheros.obtenerCabeceraFichero(strExt);
	 			  response.setContentType (strCabecera);
			      response.setHeader ("Content-disposition", "inline; filename=" + nombreFile +"."+ strExt);		  
			      response.setHeader ("Cache-Control", "max-age=30");		 
			      response.setHeader ("Pragma", "No-cache");		 
			      response.setDateHeader ("Expires", 0);		
			      response.setContentLength (bContenido.length);			      
			      response.getOutputStream().write(bContenido,0,bContenido.length);		    	
			      response.getOutputStream().flush ();	
			      response.getOutputStream().close ();
			      
				  return null;

		} catch (Exception e) {
			HibernateSessionFactory.getSession().close();	
			e.printStackTrace();
			return mapping.findForward("fail");
		} finally {
			HibernateSessionFactory.getSession().close();		
		}	

	}
	
}	
	
