
package action;

import java.sql.Timestamp;
import java.util.Date;

import form.ConsultaForm;

import hibernate.Consulta;
import hibernate.ConsultaDAO;
import hibernate.HibernateSessionFactory;
import hibernate.PersonaDependiente;

import util.CorreoEnvio;
import util.GestionCorreoElectronico;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.apache.struts.action.Action;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;
import org.apache.struts.action.ActionMessage;
import org.apache.struts.action.ActionMessages;
import org.hibernate.Session;
import org.hibernate.Transaction;

public class ResponderConsultaAction extends Action {

	private static Log log = LogFactory.getLog(ResponderConsultaAction.class);

	public ActionForward execute(ActionMapping mapping, ActionForm form,
			HttpServletRequest request, HttpServletResponse response) {
		
		ConsultaForm cform = (ConsultaForm) form;
		// mensajes
		ActionMessages mensaje = new ActionMessages();
		
		try {
			if (request.getParameter("volver") != null) {
				return mapping.findForward("volver");
			}
			if (request.getParameter("id") != null) {
				ConsultaDAO cDAO = new ConsultaDAO();
				// Buscamos Consulta, Voluntarios y PD
				Consulta c = cDAO.findById(Integer.parseInt(request.getParameter("id").toString()));
				PersonaDependiente pd = c.getPersonaDependiente();
				c.setRespuesta(cform.getRespuesta());
				c.setFecRespuesta(new Timestamp(new Date().getTime()));
				// Mandamos mail
				try{
					String strEmailFrom= pd.getAuxiliar().getUsuario().getPersona().getEmail();
					if (!strEmailFrom.trim().equals("")){
						// preparamos mail
						CorreoEnvio correo = new CorreoEnvio();
						correo.setAsunto("Respuesta a Consulta " + new Timestamp(new Date().getTime()));
						correo.setContenido("<b>CiberVoluntariado</b><br><br>Hola " + 
								pd.getPersona().getNombre() + ", su Voluntario " +
								pd.getAuxiliar().getUsuario().getPersona().getNombre_apellidos() + "<br>" +
								" ha respondido a su consulta: <i>"+ c.getPregunta() + "</i><br><br>" +
								"<b>RESPUESTA: </b>" + c.getRespuesta() +
								"<br><br>Para realizar más consultas, por favor, identifiquese en la aplicación");
						correo.setEmail_from(pd.getAuxiliar().getUsuario().getPersona().getEmail());
						correo.setEmail_to(pd.getPersona().getEmail());
						correo.setCabecera("CiberVoluntariado");
						GestionCorreoElectronico.EnvioCorreo(correo);
						
						// Introducimos el mensaje
						mensaje.add("mensaje", new ActionMessage("consulta.respondida"));
						this.saveMessages(request, mensaje);
						log.debug("Se ha enviado el mail correctamente");
					}
			    } catch (Exception e){
			    	log.warn("Error inesperado enviando mail");
					e.printStackTrace();
					return mapping.findForward("fail");	
			    }

				Session sesion = HibernateSessionFactory.getSession();			
				Transaction tx = sesion.beginTransaction();
				// Guardamos 
				cDAO.merge(c);

				tx.commit();
				sesion.close();		
			}
			return mapping.findForward("success");
		} catch (Exception e) {
			log.warn("Error inesperado en el proceso de realizar consultas");
			e.printStackTrace();
			return mapping.findForward("fail");	
		}
	}
}