
package action;


import hibernate.AuxiliarDAO;
import hibernate.DiaDAO;
import hibernate.HibernateSessionFactory;
import hibernate.HoraDAO;
import hibernate.PersonaDependienteDAO;
import hibernate.Servicio;
import hibernate.ServicioDAO;
import hibernate.SubtipoEventoDAO;
import hibernate.TipoEventoDAO;
import hibernate.Usuario;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.apache.struts.action.Action;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;
import org.apache.struts.action.ActionMessages;
import org.hibernate.Session;
import org.hibernate.Transaction;

import util.CorreoEnvio;
import util.GestionCorreoElectronico;

import form.TareaForm;


public class TareaAction extends Action {

	private static Log log = LogFactory.getLog(TareaAction.class);
	/** 
	 * Method execute
	 * @param mapping
	 * @param form
	 * @param request
	 * @param response
	 * @return ActionForward
	 */
	public ActionForward execute(ActionMapping mapping, ActionForm form,
			HttpServletRequest request, HttpServletResponse response) {
		
		TareaForm tareaForm = (TareaForm) form;
		// mensajes
		ActionMessages mensaje = new ActionMessages();
		
		try {
			if (request.getParameter("volver") != null) {
				return mapping.findForward("volver");
			} else if (request.getParameter("grabar") != null) {
				
				HttpSession session = request.getSession(false);
				Usuario u = null;
				if (session != null && session.getAttribute("usuario") != null) {
					u = (Usuario)session.getAttribute("usuario");
				}
				
				ServicioDAO serDAO = new ServicioDAO();
				Servicio ser = new Servicio();
				DiaDAO diaDAO = new DiaDAO();
				HoraDAO horaDAO = new HoraDAO();
				AuxiliarDAO auxDAO = new AuxiliarDAO();
				TipoEventoDAO teDAO = new TipoEventoDAO();
				SubtipoEventoDAO steDAO = new SubtipoEventoDAO();
				PersonaDependienteDAO pdDAO = new PersonaDependienteDAO();
				
				ser.setDia(diaDAO.findById(Integer.parseInt(tareaForm.getDia())));
				ser.setHoraByHoraFin(horaDAO.findById(Integer.parseInt(tareaForm.getHoraFin())));
				ser.setHoraByHoraInicio(horaDAO.findById(Integer.parseInt(tareaForm.getHoraInicio())));
				ser.setAuxiliar(auxDAO.findById(Integer.parseInt(tareaForm.getIdVoluntario())));
				ser.setTipoEvento(teDAO.findById(Integer.parseInt(tareaForm.getTarea())));
				ser.setSubtipoEvento(steDAO.findById(Integer.parseInt(tareaForm.getSubtarea())));
				ser.setPersonaDependiente(pdDAO.findById(Integer.parseInt(tareaForm.getPd())));
				ser.setNotas(tareaForm.getNotas());
				
				Session sesion = HibernateSessionFactory.getSession();
				Transaction tx = sesion.beginTransaction();
				serDAO.save(ser);
				tx.commit();
				sesion.close();
				
				// Mandamos mail
				try{
						// preparamos mail
						CorreoEnvio correo = new CorreoEnvio();
						correo.setAsunto("Nueva Tarea");
						correo.setContenido("<b>" + ser.getAuxiliar().getAsociacion().getNombre() +"</b><br><br>Hola, " + 
								ser.getAuxiliar().getUsuario().getPersona().getNombre() + "<br>" +
								"El próximo " + ser.getDia().getDescripcion() + " de " + ser.getHoraByHoraInicio().getIntervalo() + 
								" a " + ser.getHoraByHoraFin().getIntervalo() + " deberá atender a " + 
								ser.getPersonaDependiente().getPersona().getNombre_apellidos() + "<br>" +
								"su tarea será: " + ser.getTipoEvento().getDescripcion() + " (" + ser.getSubtipoEvento().getDescripcion() + ") <br><br>" +
								"<b>DATOS</b><br>" +
								"Dirección: " + ser.getPersonaDependiente().getPersona().getDireccion() +
								"<br>Teléfono de contacto: " + ser.getPersonaDependiente().getPersona().getTelefono() +
								"<br>Notas del Coordinador: " + ser.getNotas() +
								"<br><br>Para cualquier duda, por favor, identifiquese en la aplicación o envíe un mail a " + 
								u.getPersona().getEmail() + "<br>Gracias.");
						correo.setEmail_from(u.getPersona().getEmail());
						correo.setEmail_to(ser.getAuxiliar().getUsuario().getPersona().getEmail());
						correo.setCabecera("CiberVoluntariado");
						GestionCorreoElectronico.EnvioCorreo(correo);
						log.debug("Se ha enviado el mail correctamente");
			    } catch (Exception e){
			    	log.warn("Error inesperado enviando mail");
					e.printStackTrace();
					return mapping.findForward("fail");	
			    }
				
				return mapping.findForward("success");
			}
				if (tareaForm.getSelect()) {
					request.setAttribute("idVoluntario", tareaForm.getIdVoluntario());
					tareaForm.setSelect(true);
					request.setAttribute("select", true);
					return mapping.findForward("recargar");
				}
			return mapping.findForward("fail");
		} catch (Exception e) {
			// Se ha producido un error
			e.printStackTrace();
			log.error("Se ha producido un error al grabar la tarea");
			return mapping.findForward("fail");
		}
	}
}