
package action;

import java.sql.Timestamp;
import java.util.Date;
import java.util.Iterator;
import java.util.List;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.apache.struts.action.Action;
import org.apache.struts.action.ActionErrors;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;
import org.apache.struts.action.ActionMessage;
import org.apache.struts.action.ActionMessages;
import org.hibernate.Session;
import org.hibernate.Transaction;

import hibernate.Auxiliar;
import hibernate.AuxiliarDAO;
import hibernate.Localidad;
import hibernate.LocalidadDAO;
import hibernate.Perfil;
import hibernate.PerfilDAO;
import hibernate.Persona;
import hibernate.PersonaDAO;
import hibernate.Usuario;
import hibernate.UsuarioDAO;

import hibernate.HibernateSessionFactory;

import util.DatesToolbox;
import util.EncryptionToolbox;
import form.UsuarioForm;


public class UsuarioAction extends Action {

		private static Log log = LogFactory.getLog(UsuarioAction.class);


		@Override
		public ActionForward execute(ActionMapping mapping, ActionForm form,
				HttpServletRequest request, HttpServletResponse response) {

			UsuarioForm usuarioForm = (UsuarioForm) form;

			// errores
			ActionErrors errores = new ActionErrors();
			// mensajes
			ActionMessages mensajes = new ActionMessages();
			Session sesion = HibernateSessionFactory.getSession();
			Transaction tx = sesion.beginTransaction();
			
			try {

				Usuario usuario;
				Perfil perfil = new Perfil();
				UsuarioDAO usuarioDAO = new UsuarioDAO();
				PerfilDAO perfilDAO = new PerfilDAO();
				Persona persona;
				PersonaDAO personaDAO = new PersonaDAO();

				// Volver
				if (request.getParameter("volver") != null) {
					// volver
					return mapping.findForward("volver");
				}
				
				boolean savePersona = true;
				
				// existe DNI
				List listaPersonas = personaDAO.findByDni(usuarioForm.getDni());
				// encontrado  DNI
				if (listaPersonas.size() == 1) {
					// persona
					persona = (Persona) listaPersonas.get(0);
					// esta borrada
					if (persona.getFechaBaja() != null) {
						// persona
						persona.setFechaBaja(null);
						persona.setFechaAlta(new Timestamp(new Date().getTime()));
						savePersona = false;
					} else {
						// editando
						// persona.setFechaAlta(new Timestamp(new Date().getTime()));
						savePersona = false;
					}
				} else {
					// nueva persona
					persona = new Persona();
					persona.setFechaAlta(new Timestamp(new Date().getTime()));
				}

				// save = true -> nuevo
				boolean save = true;
				// existe usuario
				List listaUsuarios = usuarioDAO.findByLoginCompleto(usuarioForm
						.getUsuario());
				// se ha encontrado usuario
				if (listaUsuarios.size() >= 1) {
					// Cargar
					usuario = (Usuario) listaUsuarios.get(0);
					// usuario borrado
					if (usuario.getFecBaja() != null) {
						// carga
						log	.debug("El usuario " + usuario.getLogin()
							+ " ya existe, y esta borrado, se recupera y se va a editar");
						usuario.setFecBaja(null);
						usuario.setFecAlta(new Timestamp(new Date().getTime()));
						save = false;
					} else {
						log.debug("El usuario " + usuario.getLogin()
								+ " ya existe y se va a editar");
						save = false;
					}
				} else {
					boolean encontrado = false;
					if (listaUsuarios.size() > 1) {
						usuario = (Usuario) listaUsuarios.get(0);
						Iterator<Usuario> it = listaUsuarios.iterator();
						while ((it.hasNext()) && (!encontrado)) {
							Usuario elem = (Usuario) it.next();
							if (elem.getId() == usuarioForm.getId()) {
								usuario = elem;
								encontrado = true;
								usuario.setFecAlta(new Timestamp(new Date().getTime()));
								usuario.setFecBaja(null);
								save = false;
							}
						}
						if (!encontrado) {
							usuario.setFecAlta(new Timestamp(new Date().getTime()));
							usuario.setFecBaja(null);
							save = false;
						}
					} else {
						// nuevo usuario
						log.debug("No existe ningun usuario con ese nombre, se crea uno nuevo");
						usuario = new Usuario();
						usuario.setFecAlta(new Timestamp(new Date().getTime()));
					}
				}

				Localidad loc = new Localidad();
				LocalidadDAO locDAO = new LocalidadDAO();
				
				if ((usuarioForm.getLocalidad() != null) && (!usuarioForm.getLocalidad().toString().equals(""))) {
					String id_loc = usuarioForm.getLocalidad();
					loc = locDAO.findById(Integer.parseInt(id_loc));
				}

				// datos usuario
				// Persona
				// DNI
				if (usuarioForm.getDni() != "") {
					persona.setDni(usuarioForm.getDni());
				} else {
					persona.setDni(null);
				}
				persona.setNombre(usuarioForm.getNombre());
				persona.setApellido1(usuarioForm.getApellido1());
				persona.setApellido2(usuarioForm.getApellido2());
				persona.setDireccion(usuarioForm.getDireccion());
				persona.setCodigoPostal(usuarioForm.getCodigo_postal());
				persona.setTelefono(usuarioForm.getTelefono());
				persona.setMovil(usuarioForm.getMovil());
				persona.setEmail(usuarioForm.getEmail());
				if ((usuarioForm.getFecha_nacimiento() == "")
						|| (usuarioForm.getFecha_nacimiento() == null)) {
					persona.setFechaNacimiento(null);
				} else {
					persona
							.setFechaNacimiento(DatesToolbox
									.getDBDateFromSpanish(usuarioForm
											.getFecha_nacimiento()));
				}
				persona.setFechaAlta(new Timestamp(new Date().getTime()));
				persona.setLocalidad(loc);

				// Grabamos
				if (savePersona)
					personaDAO.save(persona);
				else
					personaDAO.merge(persona);

				// usuario
				usuario.setPersona(persona);
				usuario.setLogin(usuarioForm.getUsuario());

				if ((save) || (!usuarioForm.getClave().equals(""))) {
					usuario.setClave(EncryptionToolbox.md5(usuarioForm.getClave()));
				}

				usuario.setFecAlta(new Timestamp(new Date().getTime()));
				
				
				perfil = perfilDAO.findById(Integer.parseInt(usuarioForm
						.getPerfil()));
				usuario.setPerfil(perfil);

				// Grabamos
				if (save) {
					usuarioDAO.save(usuario);
					// Commit
					if (usuario.getPerfil().getId() == 2) {

						AuxiliarDAO auxDAO = new AuxiliarDAO();
						Auxiliar aux = new Auxiliar();
						aux.setDisponible(true);
						aux.setUsuario(usuario);
						aux.setAsociacion(null);
						auxDAO.save(aux);
					}
					tx.commit();
					log.info("creado usuario");
					sesion.close();

					mensajes.add(ActionMessages.GLOBAL_MESSAGE,
							new ActionMessage("usuario.formulario.creado", usuario
									.getLogin()));
					this.saveMessages(request, mensajes);

					return mapping.findForward("success");
				} else {
					// Commit
					usuarioDAO.merge(usuario);
					tx.commit();
					log.info("Se han introducido los datos del usuario satisfactoriamente");
					sesion.close();
					
					mensajes.add(ActionMessages.GLOBAL_MESSAGE,
							new ActionMessage("usuario.formulario.modificado",
									usuario.getLogin()));
					this.saveMessages(request, mensajes);

					log.debug("Datos del Usuario insertados correctamente");
					return mapping.findForward("success");
				}

			} catch (Exception e) {
				// Error
				e.printStackTrace();
				tx.rollback();
				sesion.close();
				log.error("error al grabar el usuario");
				errores.add("errores", new ActionMessage(
						"usuario.error.grabar.generico"));
				this.saveErrors(request, errores);
				return mapping.findForward("fail");
			}
		}
	}