
package action;

import form.VoluntarioForm;
import hibernate.Auxiliar;
import hibernate.AuxiliarDAO;
import hibernate.LocalidadDAO;
import hibernate.Perfil;
import hibernate.Persona;
import hibernate.PersonaDAO;
import hibernate.PersonaDependiente;
import hibernate.PersonaDependienteDAO;
import hibernate.Usuario;
import hibernate.UsuarioDAO;

import java.sql.Timestamp;
import java.util.Date;
import java.util.Iterator;
import java.util.List;
import java.util.Set;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.apache.struts.action.Action;
import org.apache.struts.action.ActionErrors;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;
import org.apache.struts.action.ActionMessage;
import org.apache.struts.action.ActionMessages;
import org.hibernate.Session;
import org.hibernate.Transaction;

import util.DatesToolbox;
import util.EncryptionToolbox;
import hibernate.HibernateSessionFactory;


public class VoluntarioExternoAction extends Action {

	private static Log log = LogFactory.getLog(VoluntarioAction.class);

	public ActionForward execute(ActionMapping mapping, ActionForm form,
			HttpServletRequest request, HttpServletResponse response) {
		
		VoluntarioForm voluntarioForm = (VoluntarioForm) form;
		
		// Errores
		ActionErrors mensaje_error = new ActionErrors();
		// Mensajes
		ActionMessages mensajes = new ActionMessages();
		
		try {

			PersonaDependiente pd;
			PersonaDependienteDAO pdDAO = new PersonaDependienteDAO();;

			Persona persona = new Persona();
			PersonaDAO personaDAO = new PersonaDAO();
			LocalidadDAO locDAO = new LocalidadDAO();
			Usuario user = new Usuario();
			UsuarioDAO userDAO = new UsuarioDAO();
			Auxiliar aux = new Auxiliar();
			AuxiliarDAO auxDAO = new AuxiliarDAO();
			
			Boolean deBaja = false;
			
			// Volver 
			if  (request.getParameter("volver") != null)  {
					return mapping.findForward("volver");
			}

			
			// Sesion			
			Session sesion = HibernateSessionFactory.getSession();			
			Transaction tx = sesion.beginTransaction();
	
			if ((voluntarioForm.getId() == null) || 
					(voluntarioForm.getId().equals(""))) {
				
				// existe DNI??
				List<Persona> listaPersonas = personaDAO.findByDni(voluntarioForm.getDni());
				// encontrado DNI
				if (listaPersonas.size() == 1) {
					// Persona
					persona = (Persona) listaPersonas.get(0);
					// Si esta borrada
					if (persona.getFechaBaja() != null) {
						// carga persona
						deBaja = true;
						persona.setFechaBaja(null);
						persona.setFechaAlta(new Timestamp(new Date().getTime()));
						// Modificamos usuario y voluntario
						Set<Usuario> users = persona.getUsuarios();
						user = (Usuario)users.toArray()[0];
						user.setFecBaja(null);
						List<Auxiliar> auxiliares = auxDAO.findAll();
						Iterator<Auxiliar> it2 = auxiliares.iterator();
						Boolean encontrado = false;
						while ((it2.hasNext()) && (!encontrado)) {
							Auxiliar elem = it2.next();
							if (elem.getUsuario().getPersona().getId() == persona.getId()) {
								encontrado = true;
								aux = elem;
							}
						}
					} else {
						mensajes.add("mensaje",
								new ActionMessage("voluntario.error.dni.repetido", persona
										.getNombre_apellidos()));
						this.saveMessages(request, mensajes);
						return mapping.findForward("dniRepetido");	
					}
				} else {
					// nueva persona
					persona = new Persona();
					persona.setFechaAlta(new Timestamp(new Date().getTime()));
				}
				if ((voluntarioForm.getDni()!=null) && (!voluntarioForm.getDni().equals("")))
					persona.setDni(voluntarioForm.getDni());
				persona.setFechaAlta(new Timestamp(new Date().getTime()));
				if ((voluntarioForm.getNombre()!=null) && (!voluntarioForm.getNombre().equals("")))
					persona.setNombre(voluntarioForm.getNombre());
				else
					persona.setNombre(null);
				if ((voluntarioForm.getApellido1()!=null) && (!voluntarioForm.getApellido1().equals("")))
					persona.setApellido1(voluntarioForm.getApellido1());
				else
					persona.setApellido1(null);
				if ((voluntarioForm.getApellido2()!=null) && (!voluntarioForm.getApellido2().equals("")))
					persona.setApellido2(voluntarioForm.getApellido2());
				else
					persona.setApellido2(null);
				if ((voluntarioForm.getDireccion()!=null) && (!voluntarioForm.getDireccion().equals("")))
					persona.setDireccion(voluntarioForm.getDireccion());
				else 
					persona.setDireccion(null);
				if ((voluntarioForm.getTelefono()!=null) && (!voluntarioForm.getTelefono().equals("")))
					persona.setTelefono(voluntarioForm.getTelefono());
				else 
					persona.setTelefono(null);
				
				if (!voluntarioForm.getLocalidad().toString().equals("")) {
					persona.setLocalidad(locDAO.findById(Integer.parseInt(voluntarioForm.getLocalidad())));
				} else {
					persona.setLocalidad(locDAO.findById(18));
				}
				if ((voluntarioForm.getFecha_nacimiento()!=null) && (!voluntarioForm.getFecha_nacimiento().toString().equals(""))) {
					persona.setFechaNacimiento(DatesToolbox.getDBDateFromSpanish(voluntarioForm.getFecha_nacimiento()));
				} else {
					persona.setFechaNacimiento(null);
				}
				// Usuario
				if ((voluntarioForm.getLogin()!=null) && (!voluntarioForm.getLogin().equals("")))
					user.setLogin(voluntarioForm.getLogin());
				else 
					user.setLogin(null);
				
				if ((voluntarioForm.getClave1()!=null) && (!voluntarioForm.getClave1().equals("")))
					user.setClave(EncryptionToolbox.md5(voluntarioForm.getClave1()));
				else 
					user.setClave(null);
				
				user.setFecAlta(new Timestamp(new Date().getTime()));
				
				// Grabamos
				if (deBaja)
					personaDAO.merge(persona);
				else
					personaDAO.save(persona);
				
				user.setPersona(persona);
				// Perfil de Voluntario
				user.setPerfil(new Perfil(2));
				
				// Grabamos Usuario
				if (deBaja)
					userDAO.merge(user);
				else
					userDAO.save(user);
				
				// Asignamos el usuario al voluntario
				aux.setUsuario(user);

				if ((voluntarioForm.getRadio_disponible() != null) && (voluntarioForm.getRadio_disponible().toString().equals("Si"))) {
					// disponible
					aux.setDisponible(true);
				} else {
					// No disponible
					aux.setDisponible(false);
				}
				
				// Asociacion				
				aux.setAsociacion(null);
				
				// Grabamos el voluntario
				if (deBaja)
					auxDAO.merge(aux);
				else
					auxDAO.save(aux);
				
				voluntarioForm.setId(aux.getId().toString());
				voluntarioForm.setId_persona(persona.getId().toString());
				voluntarioForm.setId_usuario(user.getId().toString());

				voluntarioForm.setId_asociacion(null);

				tx.commit();
				sesion.close();
	
				mensajes.add("mensajes",new ActionMessage("voluntario.creado", persona.getNombre_apellidos()));
				this.saveMessages(request, mensajes);
				log.debug("Voluntario creado correctamente");
				return mapping.findForward("success");
				
				
			} else {
				return mapping.findForward("fail");
			}			
		
		} catch (Exception e) {
			log.warn("Error inesperado en el proceso de grabacion del Voluntario");
			e.printStackTrace();
			return mapping.findForward("fail");	
		}
	}
}