package form;

import hibernate.Usuario;
import hibernate.UsuarioDAO;

import java.util.Iterator;
import java.util.List;

import javax.servlet.http.HttpServletRequest;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.apache.struts.action.ActionErrors;
import org.apache.struts.action.ActionMapping;
import org.apache.struts.action.ActionMessage;
import org.apache.struts.validator.ValidatorForm;

import util.ConstantesProyecto;
import util.Validaciones;

public class AsociacionExternaForm extends ValidatorForm {
	/*
	 * Generated Methods
	 */

	
	/** id property */
	private String id;
	
	/** nombre property */
	private String nombre;
	
	/** descripcion property */
	private String descripcion;
	
	/** localidad property */
	private String localidad;
	
	/** direccion property */
	private String direccion;
	
	/** telefono property */
	private String telefono;
	
	/** id_coordinador property */
	private String id_coordinador;
	
	/** fec_alta property */
	private String fec_alta;
	
	/** fec_baja property */
	private String fec_baja;
	
	/** 
	 * COORDINADOR
	 */
	
	/** clave property */
	private String claveCoord;

	/** clave2 property */
	private String clave2Coord;

	/** fecha_nacimiento property */
	private String fecha_nacimientoCoord;

	/** nombre property */
	private String nombreCoord;

	/** usuario property */
	private String usuarioCoord;

	/** codigo_postal property */
	private String codigo_postalCoord;

	/** movil property */
	private String movilCoord;

	/** perfil property */
	private String perfilCoord;

	/** email property */
	private String emailCoord;

	/** apellido2 property */
	private String apellido2Coord;

	/** direccion property */
	private String direccionCoord;

	/** telefono property */
	private String telefonoCoord;

	/** apellido1 property */
	private String apellido1Coord;

	/** dni property */
	private String dniCoord;

	/** localidad property */
	private String localidadCoord;
	
	
	// Gestor de logs
	private static Log logs = LogFactory.getLog(AsociacionForm.class);
	
	public ActionErrors validate(ActionMapping mapping,
			HttpServletRequest request) {
		// TODO Auto-generated method stub
		// Lista de errores
		ActionErrors mensajes = new ActionErrors();
		// Validamos direccion
		if (request.getParameter("volver") == null) {
			if (this.getDireccion().length() > 128) {
				mensajes.add("direccion", new ActionMessage("auxiliar.error.direccion.grande"));
			} else if (Validaciones.libreCaracteresEspeciales(this.getDireccion()) != null)
				mensajes.add("direccion", new ActionMessage("error.caracteresespeciales"));
			// Validamos Nombre
			if (this.getNombre().length() > 128) {
				mensajes.add("nombre", new ActionMessage("auxiliar.error.nombre.grande"));
			} else if (this.getNombre().equals("")) {
				mensajes.add("nombre", new ActionMessage("auxiliar.error.nombre.vacio"));			
			} else if (Validaciones.libreCaracteresEspeciales(this.getNombre()) != null)
				mensajes.add("nombre", new ActionMessage("error.caracteresespeciales"));
			// Validamos dscripcion
			if (this.getDireccion().length() > 1024) {
				mensajes.add("descripcion", new ActionMessage("asociacion.error.direccion.grande"));
			} else if (Validaciones.libreCaracteresEspeciales(this.getDireccion()) != null)
				mensajes.add("descripcion", new ActionMessage("error.caracteresespeciales"));
			if (this.getTelefono() != null)
				if (this.getTelefono().length() > 50) {
					mensajes.add("telefono", new ActionMessage(
							"auxiliar.error.telefono.grande"));
				} else if ((!this.getTelefono().equals("")) && (!Validaciones.esTLFValido(this.getTelefono()))) {
					mensajes.add("telefono", new ActionMessage(
							"auxiliar.error.telefono.formato"));
				} else if (Validaciones.libreCaracteresEspeciales(this.getTelefono()) != null)
					mensajes.add("telefono", new ActionMessage("error.caracteresespeciales"));
		
		
			/** 
			 * COORDINADOR 
			 * 
			 * */
			
			UsuarioDAO usuarioDAO = new UsuarioDAO();
			
			if (this.getNombreCoord().equals("")) {
				logs.warn("No existe nombre");
				mensajes.add("nombreCoord", new ActionMessage(
						"usuario.error.nombre.vacio"));
			} else if (this.getNombreCoord().length() > 50) {
				logs.warn("El nombre es demasiado grande");
				mensajes.add("nombreCoord", new ActionMessage(
						"usuario.error.nombre.grande"));
			} else if (Validaciones.libreCaracteresEspeciales(this.getNombreCoord()) != null) {
				logs.warn("Contiene caracteres especiales");
				mensajes.add("nombreCoord", new ActionMessage(
						"formulario.caracteres_especiales", Validaciones
								.libreCaracteresEspeciales(this.getNombreCoord())));
			}
			// Comprobamos apellidos
			// Apellido1
			if (this.getApellido1Coord().equals("")) {
				logs.warn("No existe primer apellido");
				mensajes.add("apellido1Coord", new ActionMessage(
						"usuario.error.apellido1.vacio"));
			} else if (this.getApellido1Coord().length() > 50) {
				logs.warn("El primer apellido es demasiado grande");
				mensajes.add("apellido1Coord", new ActionMessage(
						"usuario.error.apellido1.grande"));
			} else if (Validaciones.libreCaracteresEspeciales(this.getApellido1Coord()) != null) {
				logs.warn("Contiene caracteres especiales");
				mensajes.add("apellido1Coord", new ActionMessage(
						"formulario.caracteres_especiales", Validaciones
								.libreCaracteresEspeciales(this.getApellido1Coord())));
			}
			// Apellido2
			if (this.getApellido2Coord().length() > 50) {
				logs.warn("El segundo apellido es demasiado grande");
				mensajes.add("apellido2Coord", new ActionMessage(
						"usuario.error.apellido2.grande"));
			} else if (Validaciones.libreCaracteresEspeciales(this.getApellido2Coord()) != null) {
				logs.warn("Contiene caracteres especiales");
				mensajes.add("apellido2Coord", new ActionMessage(
						"formulario.caracteres_especiales", Validaciones
								.libreCaracteresEspeciales(this.getApellido2Coord())));
			}
			// Comprobamos DNI
			if (this.getDniCoord().equals("")) {
				logs.warn("No existe DNI");
				mensajes.add("dniCoord", new ActionMessage("usuario.error.dni.formato"));
			} else if ((this.getDniCoord().length() != 9)
					|| (!Validaciones.esDniValido(this.getDniCoord()))) {
				mensajes.add("dniCoord", new ActionMessage("usuario.error.dni.formato"));
			}
			// Usuario
			if (this.getUsuarioCoord().equals("")) {
				logs.warn("No existe nombre de usuario");
				mensajes.add("usuarioCoord", new ActionMessage(
						"usuario.error.usuario.vacio"));
			} else if (this.getUsuarioCoord().length() > 50) {
				logs.warn("El nombre de usuario es demasiado grande");
				mensajes.add("usuarioCoord", new ActionMessage(
						"usuario.error.usuario.grande"));
			} else if (Validaciones.libreCaracteresEspeciales(this.getUsuarioCoord()) != null) {
				logs.warn("Contiene caracteres especiales");
				mensajes.add("usuarioCoord", new ActionMessage(
						"formulario.caracteres_especiales", Validaciones
								.libreCaracteresEspeciales(this.getUsuarioCoord())));
			} else if (usuarioDAO.findByLogin(this.getUsuarioCoord()).size() > 0) {
				List<Usuario> users = (List<Usuario>) usuarioDAO.findByLogin(this.getUsuarioCoord());
				Iterator<Usuario> it = users.iterator();
				while (it.hasNext()) {
					Usuario elem = it.next();
					if ((elem.getLogin().equals(this.getUsuarioCoord())) && 
							(!elem.getId().toString().equals(this.getId().toString())) && 
							(elem.getFecBaja() == null)) {
						logs.warn("El nombre de usuario ya existe");
						mensajes.add("usuarioCoord", new ActionMessage("usuario.error.grabar.existe"));
					}
				}
			}
			// Clave
				// Estamos introduciendo nuevo usuario
				if (this.getClaveCoord().equals("")) {
					logs.warn("No existe clave para el usuario ");
					mensajes.add("claveCoord", new ActionMessage(
							"usuario.error.clave.vacio"));
				} else if (this.getClaveCoord().length() > 50) {
					logs.warn("La clave del usuario es demasiado grande ");
					mensajes.add("claveCoord", new ActionMessage(
							"usuario.error.clave.grande"));
				} else if (Validaciones.libreCaracteresEspeciales(this.getClaveCoord()) != null) {
					logs.warn("Contiene caracteres especiales ");
					mensajes.add("claveCoord", new ActionMessage(
							"formulario.caracteres_especiales", Validaciones
									.libreCaracteresEspeciales(this.getClaveCoord())));
				} else if (this.getClaveCoord().length() < ConstantesProyecto.GLOBAL_MIN_LENGHT_KEY) {
					logs.warn("La clave es demasiado chica ");
					mensajes.add("claveCoord", new ActionMessage(
							"formulario.clave.chica",
							ConstantesProyecto.GLOBAL_MIN_LENGHT_KEY));
				} else if (this.getClaveCoord().length() > ConstantesProyecto.GLOBAL_MAX_LENGHT_KEY) {
					logs.warn("La clave es demasiado grande ");
					mensajes.add("claveCoord", new ActionMessage(
							"formulario.clave.grande",
							ConstantesProyecto.GLOBAL_MAX_LENGHT_KEY));
				}
				// Confirmamos clave comparandola con el campo clave2
				if (!this.getClaveCoord().equals(this.getClave2Coord())) {
					logs.warn("Confirme la clave del usuario ");
					mensajes.add("claveCoord", new ActionMessage(
							"usuario.error.clave.noconfirmada"));
				}
			// Fecha de nacimiento en el formato correcto
			if (!this.getFecha_nacimientoCoord().equals("")) {
				if (!Validaciones.esFechaValida(this.getFecha_nacimientoCoord())) {
					logs.warn((new ActionMessage(
							"usuario.error.fechanacimiento.formato")).toString());
					mensajes.add("fecha_nacimientoCoord", new ActionMessage(
							"usuario.error.fechanacimiento.formato"));
				}
			}
			// Validacion para direccion
			if (this.getDireccionCoord().length() > 0) {
				if (this.getDireccionCoord().length() > 50) {
					logs.warn("La direccion del usuario es demasiado grande");
					mensajes.add("direccionCoord", new ActionMessage(
							"usuario.error.direccion.grande"));
				} else if (Validaciones.libreCaracteresEspeciales(this
						.getDireccionCoord()) != null) {
					logs.warn("Contiene caracteres especiales");
					mensajes.add("direccionCoord",
							new ActionMessage("formulario.caracteres_especiales",
									Validaciones.libreCaracteresEspeciales(this
											.getDireccion())));
				}
			}
			// Validacion para telefono
			if (this.getTelefonoCoord().length() > 0) {
				if (this.getTelefonoCoord().length() > 50) {
					logs.warn("El telefono del usuario es demasiado grande");
					mensajes.add("telefonoCoord", new ActionMessage(
							"usuario.error.telefono.grande"));
				} else if (!Validaciones.esTLFValido(this.getTelefonoCoord())) {
					logs.warn("El formato de teléfono no es correcto");
					mensajes.add("telefonoCoord", new ActionMessage(
							"formulario.telefono"));
				} else if (Validaciones.libreCaracteresEspeciales(this
						.getTelefonoCoord()) != null) {
					logs.warn("Contiene caracteres especiales");
					mensajes
							.add("telefonoCoord", new ActionMessage(
									"formulario.caracteres_especiales",
									Validaciones.libreCaracteresEspeciales(this
											.getTelefono())));
				}
			}
			// Validacion para movil
			if (this.getMovilCoord().length() > 0) {
				if (this.getMovilCoord().length() > 50) {
					logs.warn("El movil del usuario es demasiado grande");
					mensajes.add("movilCoord", new ActionMessage(
							"usuario.error.movil.grande"));
				} else if (!Validaciones.esTLFValido(this.getMovilCoord())) {
					logs.warn("El formato de movil no es correcto");
					mensajes.add("movilCoord", new ActionMessage("formulario.movil"));
				} else if (Validaciones.libreCaracteresEspeciales(this.getMovilCoord()) != null) {
					logs.warn("Contiene caracteres especiales");
					mensajes.add("movilCoord", new ActionMessage(
							"formulario.caracteres_especiales", Validaciones
									.libreCaracteresEspeciales(this.getMovilCoord())));
				}
			}
			// Validacion para codigo postal
			if (this.getCodigo_postalCoord().length() > 0) {
				if (this.getCodigo_postalCoord().length() > 5) {
					logs.warn("El codigo postal es demasiado grande");
					mensajes.add("codigo_postalCoord", new ActionMessage(
							"usuario.error.codigopostal.grande"));
				} else if (!Validaciones.esCPValido(this.getCodigo_postalCoord())) {
					logs.warn("El formato de CP no es correcto");
					mensajes.add("codigo_postalCoord", new ActionMessage(
							"formulario.codigo_postal"));
				} else if (Validaciones.libreCaracteresEspeciales(this
						.getCodigo_postalCoord()) != null) {
					logs.warn("Contiene caracteres especiales");
					mensajes.add("codigo_postalCoord", new ActionMessage(
							"formulario.caracteres_especiales", Validaciones
									.libreCaracteresEspeciales(this
											.getCodigo_postalCoord())));
				}
			}
			// Validacion para email
			if (this.getEmailCoord().length() > 0) {
				if (this.getEmailCoord().length() > 50) {
					logs.warn("El e-mail del usuario es demasiado grande");
					mensajes.add("emailCoord", new ActionMessage(
							"usuario.error.email.grande"));
				} else if (!Validaciones.esEmailValido(this.getEmailCoord())) {
					logs.warn("El formato de email no es correcto");
					mensajes.add("emailCoord", new ActionMessage("formulario.email"));
				} else if (Validaciones.libreCaracteresEspeciales(this.getEmailCoord()) != null) {
					logs.warn("Contiene caracteres especiales");
					mensajes.add("emailCoord", new ActionMessage(
							"formulario.caracteres_especiales", Validaciones
									.libreCaracteresEspeciales(this.getEmailCoord())));
				}
			}
		}	
		return mensajes;
	}

	/** 
	 * Method reset
	 * @param mapping
	 * @param request
	 */
	public void reset(ActionMapping mapping, HttpServletRequest request) {
		// TODO Auto-generated method stub
		this.setDescripcion("");
		this.setId(null);
		this.setNombre("");
		this.setLocalidad(null);
		this.setTelefono("");
		this.setDireccion("");
		// Coordinador
		this.setApellido1Coord("");
		this.setApellido2Coord("");
		this.setClave2Coord("");
		this.setClaveCoord("");
		this.setCodigo_postalCoord("");
		this.setDireccionCoord("");
		this.setDniCoord("");
		this.setEmailCoord("");
		this.setFecha_nacimientoCoord("");
		this.setId_coordinador(null);
		this.setLocalidadCoord(null);
		this.setMovilCoord("");
		this.setNombreCoord("");
		this.setTelefonoCoord("");
		this.setUsuarioCoord("");
		
	}

	public String getId() {
		return id;
	}

	public void setId(String id) {
		this.id = id;
	}

	public String getNombre() {
		return nombre;
	}

	public void setNombre(String nombre) {
		this.nombre = nombre;
	}

	public String getDescripcion() {
		return descripcion;
	}

	public void setDescripcion(String descripcion) {
		this.descripcion = descripcion;
	}

	public String getLocalidad() {
		return localidad;
	}

	public void setLocalidad(String localidad) {
		this.localidad = localidad;
	}

	public String getDireccion() {
		return direccion;
	}

	public void setDireccion(String direccion) {
		this.direccion = direccion;
	}

	public String getTelefono() {
		return telefono;
	}

	public void setTelefono(String telefono) {
		this.telefono = telefono;
	}

	public String getId_coordinador() {
		return id_coordinador;
	}

	public void setId_coordinador(String id_coordinador) {
		this.id_coordinador = id_coordinador;
	}

	public String getFec_alta() {
		return fec_alta;
	}

	public void setFec_alta(String fec_alta) {
		this.fec_alta = fec_alta;
	}

	public String getFec_baja() {
		return fec_baja;
	}

	public void setFec_baja(String fec_baja) {
		this.fec_baja = fec_baja;
	}

	public String getClaveCoord() {
		return claveCoord;
	}

	public void setClaveCoord(String claveCoord) {
		this.claveCoord = claveCoord;
	}

	public String getClave2Coord() {
		return clave2Coord;
	}

	public void setClave2Coord(String clave2Coord) {
		this.clave2Coord = clave2Coord;
	}

	public String getFecha_nacimientoCoord() {
		return fecha_nacimientoCoord;
	}

	public void setFecha_nacimientoCoord(String fecha_nacimientoCoord) {
		this.fecha_nacimientoCoord = fecha_nacimientoCoord;
	}

	public String getNombreCoord() {
		return nombreCoord;
	}

	public void setNombreCoord(String nombreCoord) {
		this.nombreCoord = nombreCoord;
	}

	public String getUsuarioCoord() {
		return usuarioCoord;
	}

	public void setUsuarioCoord(String usuarioCoord) {
		this.usuarioCoord = usuarioCoord;
	}

	public String getCodigo_postalCoord() {
		return codigo_postalCoord;
	}

	public void setCodigo_postalCoord(String codigo_postalCoord) {
		this.codigo_postalCoord = codigo_postalCoord;
	}

	public String getMovilCoord() {
		return movilCoord;
	}

	public void setMovilCoord(String movilCoord) {
		this.movilCoord = movilCoord;
	}

	public String getPerfilCoord() {
		return perfilCoord;
	}

	public void setPerfilCoord(String perfilCoord) {
		this.perfilCoord = perfilCoord;
	}

	public String getEmailCoord() {
		return emailCoord;
	}

	public void setEmailCoord(String emailCoord) {
		this.emailCoord = emailCoord;
	}

	public String getApellido2Coord() {
		return apellido2Coord;
	}

	public void setApellido2Coord(String apellido2Coord) {
		this.apellido2Coord = apellido2Coord;
	}

	public String getDireccionCoord() {
		return direccionCoord;
	}

	public void setDireccionCoord(String direccionCoord) {
		this.direccionCoord = direccionCoord;
	}

	public String getTelefonoCoord() {
		return telefonoCoord;
	}

	public void setTelefonoCoord(String telefonoCoord) {
		this.telefonoCoord = telefonoCoord;
	}

	public String getApellido1Coord() {
		return apellido1Coord;
	}

	public void setApellido1Coord(String apellido1Coord) {
		this.apellido1Coord = apellido1Coord;
	}

	public String getDniCoord() {
		return dniCoord;
	}

	public void setDniCoord(String dniCoord) {
		this.dniCoord = dniCoord;
	}

	public String getLocalidadCoord() {
		return localidadCoord;
	}

	public void setLocalidadCoord(String localidadCoord) {
		this.localidadCoord = localidadCoord;
	}
}