package form;

import javax.servlet.http.HttpServletRequest;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.apache.struts.action.ActionErrors;
import org.apache.struts.action.ActionMapping;
import org.apache.struts.action.ActionMessage;
import org.apache.struts.validator.ValidatorForm;

import util.Validaciones;

public class AsociacionForm extends ValidatorForm {
	/*
	 * Generated Methods
	 */
	
	/** voluntarios_asignados property */
	private String[] voluntarios_asignados;

	/** voluntarios_no_asignados property */
	private String[] voluntarios_no_asignados;
	
	/** id property */
	private String id;
	
	/** nombre property */
	private String nombre;
	
	/** descripcion property */
	private String descripcion;
	
	/** localidad property */
	private String localidad;
	
	/** direccion property */
	private String direccion;
	
	/** telefono property */
	private String telefono;
	
	/** id_coordinador property */
	private String id_coordinador;
	
	/** fec_alta property */
	private String fec_alta;
	
	/** fec_baja property */
	private String fec_baja;
	
	/** 
	 * COORDINADOR
	 */
	
	/** clave property */
	private String claveCoord;

	/** clave2 property */
	private String clave2Coord;

	/** fecha_nacimiento property */
	private String fecha_nacimientoCoord;

	/** nombre property */
	private String nombreCoord;

	/** usuario property */
	private String usuarioCoord;

	/** codigo_postal property */
	private String codigo_postalCoord;

	/** movil property */
	private String movilCoord;

	/** perfil property */
	private String perfilCoord;

	/** email property */
	private String emailCoord;

	/** apellido2 property */
	private String apellido2Coord;

	/** direccion property */
	private String direccionCoord;

	/** telefono property */
	private String telefonoCoord;

	/** apellido1 property */
	private String apellido1Coord;

	/** dni property */
	private String dniCoord;

	/** localidad property */
	private String localidadCoord;
	
	
	// Gestor de logs
	private static Log logs = LogFactory.getLog(AsociacionForm.class);
	
	public ActionErrors validate(ActionMapping mapping,
			HttpServletRequest request) {
		// TODO Auto-generated method stub
		// Lista de errores
		ActionErrors mensajes = new ActionErrors();
		// Validamos direccion
		if (request.getParameter("volver") == null) {
			if (this.getDireccion().length() > 128) {
				mensajes.add("direccion", new ActionMessage("auxiliar.error.direccion.grande"));
			} else if (Validaciones.libreCaracteresEspeciales(this.getDireccion()) != null)
				mensajes.add("direccion", new ActionMessage("error.caracteresespeciales"));
			// Validamos Nombre
			if (this.getNombre().length() > 128) {
				mensajes.add("nombre", new ActionMessage("auxiliar.error.nombre.grande"));
			} else if (this.getNombre().equals("")) {
				mensajes.add("nombre", new ActionMessage("auxiliar.error.nombre.vacio"));			
			} else if (Validaciones.libreCaracteresEspeciales(this.getNombre()) != null)
				mensajes.add("nombre", new ActionMessage("error.caracteresespeciales"));
			// Validamos dscripcion
			if (this.getDireccion().length() > 1024) {
				mensajes.add("descripcion", new ActionMessage("asociacion.error.direccion.grande"));
			} else if (Validaciones.libreCaracteresEspeciales(this.getDireccion()) != null)
				mensajes.add("descripcion", new ActionMessage("error.caracteresespeciales"));
			if (this.getTelefono() != null)
				if (this.getTelefono().length() > 50) {
					mensajes.add("telefono", new ActionMessage(
							"auxiliar.error.telefono.grande"));
				} else if ((!this.getTelefono().equals("")) && (!Validaciones.esTLFValido(this.getTelefono()))) {
					mensajes.add("telefono", new ActionMessage(
							"auxiliar.error.telefono.formato"));
				} else if (Validaciones.libreCaracteresEspeciales(this.getTelefono()) != null)
					mensajes.add("telefono", new ActionMessage("error.caracteresespeciales"));
		}	
		return mensajes;
	}

	/** 
	 * Method reset
	 * @param mapping
	 * @param request
	 */
	public void reset(ActionMapping mapping, HttpServletRequest request) {
		this.setDescripcion("");
		this.setId(null);
		this.setNombre("");
		this.setLocalidad(null);
		this.setId_coordinador(null);
		this.setTelefono("");
		this.setDireccion("");
	}

	public String getId() {
		return id;
	}

	public void setId(String id) {
		this.id = id;
	}

	public String getNombre() {
		return nombre;
	}

	public void setNombre(String nombre) {
		this.nombre = nombre;
	}

	public String getDescripcion() {
		return descripcion;
	}

	public void setDescripcion(String descripcion) {
		this.descripcion = descripcion;
	}

	public String getLocalidad() {
		return localidad;
	}

	public void setLocalidad(String localidad) {
		this.localidad = localidad;
	}

	public String getDireccion() {
		return direccion;
	}

	public void setDireccion(String direccion) {
		this.direccion = direccion;
	}

	public String getTelefono() {
		return telefono;
	}

	public void setTelefono(String telefono) {
		this.telefono = telefono;
	}

	public String[] getVoluntarios_asignados() {
		return voluntarios_asignados;
	}

	public void setVoluntarios_asignados(String[] voluntarios_asignados) {
		this.voluntarios_asignados = voluntarios_asignados;
	}

	public String[] getVoluntarios_no_asignados() {
		return voluntarios_no_asignados;
	}

	public void setVoluntarios_no_asignados(String[] voluntarios_no_asignados) {
		this.voluntarios_no_asignados = voluntarios_no_asignados;
	}

	public String getId_coordinador() {
		return id_coordinador;
	}

	public void setId_coordinador(String id_coordinador) {
		this.id_coordinador = id_coordinador;
	}

	public String getFec_alta() {
		return fec_alta;
	}

	public void setFec_alta(String fec_alta) {
		this.fec_alta = fec_alta;
	}

	public String getFec_baja() {
		return fec_baja;
	}

	public void setFec_baja(String fec_baja) {
		this.fec_baja = fec_baja;
	}

	public String getClaveCoord() {
		return claveCoord;
	}

	public void setClaveCoord(String claveCoord) {
		this.claveCoord = claveCoord;
	}

	public String getClave2Coord() {
		return clave2Coord;
	}

	public void setClave2Coord(String clave2Coord) {
		this.clave2Coord = clave2Coord;
	}

	public String getFecha_nacimientoCoord() {
		return fecha_nacimientoCoord;
	}

	public void setFecha_nacimientoCoord(String fecha_nacimientoCoord) {
		this.fecha_nacimientoCoord = fecha_nacimientoCoord;
	}

	public String getNombreCoord() {
		return nombreCoord;
	}

	public void setNombreCoord(String nombreCoord) {
		this.nombreCoord = nombreCoord;
	}

	public String getUsuarioCoord() {
		return usuarioCoord;
	}

	public void setUsuarioCoord(String usuarioCoord) {
		this.usuarioCoord = usuarioCoord;
	}

	public String getCodigo_postalCoord() {
		return codigo_postalCoord;
	}

	public void setCodigo_postalCoord(String codigo_postalCoord) {
		this.codigo_postalCoord = codigo_postalCoord;
	}

	public String getMovilCoord() {
		return movilCoord;
	}

	public void setMovilCoord(String movilCoord) {
		this.movilCoord = movilCoord;
	}

	public String getPerfilCoord() {
		return perfilCoord;
	}

	public void setPerfilCoord(String perfilCoord) {
		this.perfilCoord = perfilCoord;
	}

	public String getEmailCoord() {
		return emailCoord;
	}

	public void setEmailCoord(String emailCoord) {
		this.emailCoord = emailCoord;
	}

	public String getApellido2Coord() {
		return apellido2Coord;
	}

	public void setApellido2Coord(String apellido2Coord) {
		this.apellido2Coord = apellido2Coord;
	}

	public String getDireccionCoord() {
		return direccionCoord;
	}

	public void setDireccionCoord(String direccionCoord) {
		this.direccionCoord = direccionCoord;
	}

	public String getTelefonoCoord() {
		return telefonoCoord;
	}

	public void setTelefonoCoord(String telefonoCoord) {
		this.telefonoCoord = telefonoCoord;
	}

	public String getApellido1Coord() {
		return apellido1Coord;
	}

	public void setApellido1Coord(String apellido1Coord) {
		this.apellido1Coord = apellido1Coord;
	}

	public String getDniCoord() {
		return dniCoord;
	}

	public void setDniCoord(String dniCoord) {
		this.dniCoord = dniCoord;
	}

	public String getLocalidadCoord() {
		return localidadCoord;
	}

	public void setLocalidadCoord(String localidadCoord) {
		this.localidadCoord = localidadCoord;
	}
}