
package form;

import javax.servlet.http.HttpServletRequest;
import org.apache.struts.action.ActionErrors;
import org.apache.struts.action.ActionMapping;
import org.apache.struts.action.ActionMessage;
import org.apache.struts.validator.ValidatorForm;

import util.Validaciones;

public class ClaveForm extends ValidatorForm {

	/** email property */
	private String email;
	
	/** usuario property */
	private String usuario;


	public ActionErrors validate(ActionMapping mapping,
			HttpServletRequest request) {
		
		// Lista de errores
		ActionErrors mensajes = new ActionErrors();
		if (request.getParameter("volver") == null) {
			if (this.getEmail().equals("")) {
				mensajes.add("email", new ActionMessage("error.email.vacia"));
			} else if (Validaciones.libreCaracteresEspeciales(this.getEmail()) != null) {
				mensajes.add("email", new ActionMessage(
						"formulario.caracteres_especiales", Validaciones
						.libreCaracteresEspeciales(this.getEmail())));
			}
			
			if (this.getUsuario().equals("")) {
				mensajes.add("usuario", new ActionMessage("error.usuario.vacia"));
			} else if (Validaciones.libreCaracteresEspeciales(this.getUsuario()) != null) {
				mensajes.add("usuario", new ActionMessage(
						"formulario.caracteres_especiales", Validaciones
						.libreCaracteresEspeciales(this.getUsuario())));
			}
		}
		return mensajes;
	}

	/** 
	 * Method reset
	 * @param mapping
	 * @param request
	 */
	@Override
	public void reset(ActionMapping mapping, HttpServletRequest request) {
		this.setEmail("");
		this.setUsuario("");
	}

	
	public String getEmail() {
		return email;
	}

	public void setEmail(String email) {
		this.email = email;
	}

	public String getUsuario() {
		return usuario;
	}

	public void setUsuario(String usuario) {
		this.usuario = usuario;
	}
}