package form;

import javax.servlet.http.HttpServletRequest;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.apache.struts.action.ActionErrors;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionMapping;
import org.apache.struts.action.ActionMessage;

import util.Validaciones;

public class ListadoAsociacionForm extends ActionForm {
	/** nombre property */
	private String nombre;

	/*
	 * Generated Methods
	 */

	private static Log logs = LogFactory.getLog(ListadoAsociacionForm.class);
	
	@Override
	public ActionErrors validate(ActionMapping mapping,
			HttpServletRequest request) {
		
		// errores
		ActionErrors mensajes = new ActionErrors();
		
		// Caracteres especiales
		try {
			if (Validaciones.libreCaracteresEspeciales(this.getNombre()) != null) {
				logs.warn("Contiene caracteres especiales");
				mensajes.add("nombre", new ActionMessage("formulario.caracteres_especiales",
					Validaciones.libreCaracteresEspeciales(this.getNombre())));
			}
			// errores
			return mensajes;
		} catch (Exception e) {
			e.printStackTrace();
			logs.error("Se ha producido un error al listar los servicios");
			return mensajes;
		}
	}

	
	@Override
	public void reset(ActionMapping mapping, HttpServletRequest request) {
		this.setNombre("");
	}

	/** 
	 * Returns the nombre.
	 * @return String
	 */
	public String getNombre() {
		return nombre;
	}
	
	/** 
	 * Set the nombre.
	 * @param nombre The nombre to set
	 */
	public void setNombre(String nombre) {
		this.nombre = nombre;
	}
}