package form;

import javax.servlet.http.HttpServletRequest;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.apache.struts.action.ActionErrors;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionMapping;
import org.apache.struts.action.ActionMessage;

import util.Validaciones;


public class ListadoCuestionarioForm extends ActionForm {
	
	/** nombre property */
	private String nombrePD;
	
	private String nombreAsociacion;

	// Gestor de logs
	private static Log logs = LogFactory.getLog(ListadoCuestionarioForm.class);
	
	/** 
	 * Method validate
	 * @param mapping
	 * @param request
	 * @return ActionErrors
	 */
	@Override
	public ActionErrors validate(ActionMapping mapping,
			HttpServletRequest request) {
		
		// errores
		ActionErrors mensajes = new ActionErrors();
		
		// caracteres especiales
		try {
			if (Validaciones.libreCaracteresEspeciales(this.getNombrePD()) != null) {
				logs.warn("Contiene caracteres especiales");
				mensajes.add("nombrePD", new ActionMessage("formulario.caracteres_especiales",
					Validaciones.libreCaracteresEspeciales(this.getNombrePD())));
			}
			// Devolvemos los errores
			return mensajes;
		} catch (Exception e) {
			e.printStackTrace();
			logs.error("Se ha producido un error al listar los cuestionarios");
			return mensajes;
		}
	}

	/** 
	 * Method reset
	 * @param mapping
	 * @param request
	 */
	@Override
	public void reset(ActionMapping mapping, HttpServletRequest request) {
		this.setNombrePD("");
	}

	/** 
	 * Returns the nombre.
	 * @return String
	 */
	public String getNombrePD() {
		return nombrePD;
	}
	
	/** 
	 * Set the nombre.
	 * @param nombre The nombre to set
	 */
	public void setNombrePD(String nombre) {
		this.nombrePD = nombre;
	}

	public String getNombreAsociacion() {
		return nombreAsociacion;
	}

	public void setNombreAsociacion(String nombreAsociacion) {
		this.nombreAsociacion = nombreAsociacion;
	}
}