
package form;

import java.util.Iterator;
import java.util.List;

import javax.servlet.http.HttpServletRequest;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.apache.struts.action.ActionErrors;
import org.apache.struts.action.ActionMapping;
import org.apache.struts.action.ActionMessage;
import org.apache.struts.validator.ValidatorForm;

import hibernate.Usuario;
import hibernate.UsuarioDAO;
import util.ConstantesProyecto;
import util.Validaciones;

public class MiUsuarioForm extends ValidatorForm {

	private static Log log = LogFactory.getLog(MiUsuarioForm.class);

	/** id property */
	private Integer id;

	/** clave property */
	private String clave1;

	/** clave2 property */
	private String clave2;

	/** fecha_nacimiento property */
	private String fecha_nacimiento;

	/** nombre property */
	private String nombre;

	/** usuario property */
	private String usuario;

	/** codigo_postal property */
	private String codigo_postal;

	/** movil property */
	private String movil;

	/** perfil property */
	private String perfil;

	/** email property */
	private String email;

	/** apellido2 property */
	private String apellido2;

	/** direccion property */
	private String direccion;

	/** telefono property */
	private String telefono;

	/** apellido1 property */
	private String apellido1;

	/** dni property */
	private String dni;

	/** localidad property */
	private String localidad;
	
	/** localidad property */
	private String aceptar;

	/*
	 * Generated Methods
	 */

	public String getAceptar() {
		return aceptar;
	}

	public void setAceptar(String aceptar) {
		this.aceptar = aceptar;
	}

	/**
	 * Method validate
	 * 
	 * @param mapping
	 * @param request
	 * @return ActionErrors
	 */
	@Override
	public ActionErrors validate(ActionMapping mapping,
			HttpServletRequest request) {

		// Lista de errores
		ActionErrors mensajes = new ActionErrors();
		// Usuarios
		UsuarioDAO usuarioDAO = new UsuarioDAO();
		Usuario usuario = usuarioDAO.findById((this.getId()));
		
		if (request.getParameter("volver") == null) {
			// Comprobamos el nombre
			if (this.getNombre().equals("")) {
				log.warn("No existe nombre");
				mensajes.add("nombre", new ActionMessage(
						"usuario.error.nombre.vacio"));
			} else if (this.getNombre().length() > 50) {
				log.warn("El nombre es demasiado grande");
				mensajes.add("nombre", new ActionMessage(
						"usuario.error.nombre.grande"));
			} else if (Validaciones.libreCaracteresEspeciales(this.getNombre()) != null) {
				log.warn("Contiene caracteres especiales");
				mensajes.add("nombre", new ActionMessage(
						"formulario.caracteres_especiales", Validaciones
								.libreCaracteresEspeciales(this.getNombre())));
			}
			// Comprobamos apellidos
			// Apellido1
			if (this.getApellido1().equals("")) {
				log.warn("No existe primer apellido");
				mensajes.add("apellido1", new ActionMessage(
						"usuario.error.apellido1.vacio"));
			} else if (this.getApellido1().length() > 50) {
				log.warn("El primer apellido es demasiado grande");
				mensajes.add("apellido1", new ActionMessage(
						"usuario.error.apellido1.grande"));
			} else if (Validaciones.libreCaracteresEspeciales(this.getApellido1()) != null) {
				log.warn("Contiene caracteres especiales");
				mensajes.add("apellido1", new ActionMessage(
						"formulario.caracteres_especiales", Validaciones
								.libreCaracteresEspeciales(this.getApellido1())));
			}
			// Apellido2
			if (this.getApellido2().length() > 50) {
				log.warn("El segundo apellido es demasiado grande");
				mensajes.add("apellido2", new ActionMessage(
						"usuario.error.apellido2.grande"));
			} else if (Validaciones.libreCaracteresEspeciales(this.getApellido2()) != null) {
				log.warn("Contiene caracteres especiales");
				mensajes.add("apellido2", new ActionMessage(
						"formulario.caracteres_especiales", Validaciones
								.libreCaracteresEspeciales(this.getApellido2())));
			}
			// Comprobamos DNI
			if (this.getDni().equals("")) {
				log.warn("No existe DNI");
				mensajes.add("dni", new ActionMessage("usuario.error.dni.formato"));
			} else if ((this.getDni().length() != 9)
					|| (!Validaciones.esDniValido(this.getDni()))) {
				mensajes.add("dni", new ActionMessage("usuario.error.dni.formato"));
			}
			// Usuario
			if (this.getUsuario().equals("")) {
				log.warn("No existe nombre de usuario");
				mensajes.add("usuario1", new ActionMessage(
						"usuario.error.usuario.vacio"));
			} else if (this.getUsuario().length() > 50) {
				log.warn("El nombre de usuario es demasiado grande");
				mensajes.add("usuario", new ActionMessage(
						"usuario.error.usuario.grande"));
			} else if (Validaciones.libreCaracteresEspeciales(this.getUsuario()) != null) {
				log.warn("Contiene caracteres especiales");
				mensajes.add("usuario", new ActionMessage(
						"formulario.caracteres_especiales", Validaciones
								.libreCaracteresEspeciales(this.getUsuario())));
			} else if ((!this.getUsuario().equals(usuario.getLogin())) && 
						(usuarioDAO.findByLogin(this.getUsuario()).size() > 0)) {
				
				List<Usuario> users = (List<Usuario>) usuarioDAO.findByLogin(this.getUsuario());
				Iterator<Usuario> it = users.iterator();
				while (it.hasNext()) {
					Usuario elem = it.next();
					if ((elem.getLogin().equals(this.getUsuario())) && 
							(!elem.getId().toString().equals(this.getId().toString())) && 
							(elem.getFecBaja() == null)) {
						log.warn("El nombre de usuario ya existe");
						mensajes.add("usuario", new ActionMessage("usuario.error.grabar.existe"));
					}
				}
			}
			// Clave
			if ((this.getClave1() != null) && (this.getClave2() != null) && 
					(!"".equals(this.getClave1())) && (!"".equals(this.getClave2()))) {
				// Estamos introduciendo nuevo usuario
				if (this.getClave1().equals("")) {
					log.warn("No existe clave para el usuario ");
					mensajes.add("clave1", new ActionMessage(
							"usuario.error.clave.vacio"));
				} else if (this.getClave1().length() > 50) {
					log.warn("La clave del usuario es demasiado grande ");
					mensajes.add("clave1", new ActionMessage(
							"usuario.error.clave.grande"));
				} else if (Validaciones.libreCaracteresEspeciales(this.getClave1()) != null) {
					log.warn("Contiene caracteres especiales ");
					mensajes.add("clave1", new ActionMessage(
							"formulario.caracteres_especiales", Validaciones
									.libreCaracteresEspeciales(this.getClave1())));
				} else if (this.getClave1().length() < ConstantesProyecto.GLOBAL_MIN_LENGHT_KEY) {
					log.warn("La clave es demasiado chica ");
					mensajes.add("clave1", new ActionMessage(
							"formulario.clave.chica",
							ConstantesProyecto.GLOBAL_MIN_LENGHT_KEY));
				} else if (this.getClave1().length() > ConstantesProyecto.GLOBAL_MAX_LENGHT_KEY) {
					log.warn("La clave es demasiado grande ");
					mensajes.add("clave1", new ActionMessage(
							"formulario.clave.grande",
							ConstantesProyecto.GLOBAL_MAX_LENGHT_KEY));
				}
				// Confirmamos clave comparandola con el campo clave2
				if (!this.getClave1().equals(this.getClave2())) {
					log.warn("Confirme la clave del usuario ");
					mensajes.add("clave1", new ActionMessage(
							"usuario.error.clave.noconfirmada"));
				}
			} else {
				// Estamos actualizando un usuario existente
				if (!this.getClave1().equals("")) {
					if (this.getClave1().length() > 50) {
						log.warn("La clave del usuario es demasiado grande ");
						mensajes.add("clave1", new ActionMessage(
								"usuario.error.clave.grande"));
					} else if (Validaciones.libreCaracteresEspeciales(this
							.getClave1()) != null) {
						log.warn("Contiene caracteres especiales ");
						mensajes.add("clave1",
								new ActionMessage(
										"formulario.caracteres_especiales",
										Validaciones.libreCaracteresEspeciales(this
												.getClave1())));
					} else if (this.getClave1().length() < ConstantesProyecto.GLOBAL_MIN_LENGHT_KEY) {
						log.warn("La longitud de la clave es demasiado pequeña ");
						mensajes.add("clave1", new ActionMessage(
								"formulario.clave.chica",
								ConstantesProyecto.GLOBAL_MIN_LENGHT_KEY));
					} else if (this.getClave1().length() > ConstantesProyecto.GLOBAL_MAX_LENGHT_KEY) {
						log.warn("La clave es demasiado grande");
						mensajes.add("clave1", new ActionMessage(
								"formulario.clave.grande",
								ConstantesProyecto.GLOBAL_MAX_LENGHT_KEY));
					}
					// Confirmamos clave comparandola con el campo clave2
					if (!this.getClave1().equals(this.getClave2())) {
						log.warn("Confirme la clave del usuario");
						mensajes.add("clave1", new ActionMessage(
								"usuario.error.clave.noconfirmada"));
					}
				}
			}
			// Fecha de nacimiento en el formato correcto
			if (!this.getFecha_nacimiento().equals("")) {
				if (!Validaciones.esFechaValida(this.getFecha_nacimiento())) {
					log.warn((new ActionMessage(
							"usuario.error.fechanacimiento.formato")).toString());
					mensajes.add("fecha_nacimiento", new ActionMessage(
							"usuario.error.fechanacimiento.formato"));
				}
			}
			// Validacion para direccion
			if (this.getDireccion().length() > 0) {
				if (this.getDireccion().length() > 50) {
					log.warn("La direccion del usuario es demasiado grande");
					mensajes.add("direccion", new ActionMessage(
							"usuario.error.direccion.grande"));
				} else if (Validaciones.libreCaracteresEspeciales(this
						.getDireccion()) != null) {
					log.warn("Contiene caracteres especiales");
					mensajes.add("direccion",
							new ActionMessage("formulario.caracteres_especiales",
									Validaciones.libreCaracteresEspeciales(this
											.getDireccion())));
				}
			}
			// Validacion para telefono
			if (this.getTelefono().length() > 0) {
				if (this.getTelefono().length() > 50) {
					log.warn("El telefono del usuario es demasiado grande");
					mensajes.add("telefono", new ActionMessage(
							"usuario.error.telefono.grande"));
				} else if (!Validaciones.esTLFValido(this.getTelefono())) {
					log.warn("El formato de teléfono no es correcto");
					mensajes.add("telefono", new ActionMessage(
							"formulario.telefono"));
				} else if (Validaciones.libreCaracteresEspeciales(this
						.getTelefono()) != null) {
					log.warn("Contiene caracteres especiales");
					mensajes
							.add("telefono", new ActionMessage(
									"formulario.caracteres_especiales",
									Validaciones.libreCaracteresEspeciales(this
											.getTelefono())));
				}
			}
			// Validacion para movil
			if (this.getMovil().length() > 0) {
				if (this.getMovil().length() > 50) {
					log.warn("El movil del usuario es demasiado grande");
					mensajes.add("movil", new ActionMessage(
							"usuario.error.movil.grande"));
				} else if (!Validaciones.esTLFValido(this.getMovil())) {
					log.warn("El formato de movil no es correcto");
					mensajes.add("movil", new ActionMessage("formulario.movil"));
				} else if (Validaciones.libreCaracteresEspeciales(this.getMovil()) != null) {
					log.warn("Contiene caracteres especiales");
					mensajes.add("movil", new ActionMessage(
							"formulario.caracteres_especiales", Validaciones
									.libreCaracteresEspeciales(this.getMovil())));
				}
			}
			// Validacion para codigo postal
			if (this.getCodigo_postal().length() > 0) {
				if (this.getCodigo_postal().length() > 5) {
					log.warn("El codigo postal es demasiado grande");
					mensajes.add("codigo_postal", new ActionMessage(
							"usuario.error.codigopostal.grande"));
				} else if (!Validaciones.esCPValido(this.getCodigo_postal())) {
					log.warn("El formato de CP no es correcto");
					mensajes.add("codigo_postal", new ActionMessage(
							"formulario.codigo_postal"));
				} else if (Validaciones.libreCaracteresEspeciales(this
						.getCodigo_postal()) != null) {
					log.warn("Contiene caracteres especiales");
					mensajes.add("codigo_postal", new ActionMessage(
							"formulario.caracteres_especiales", Validaciones
									.libreCaracteresEspeciales(this
											.getCodigo_postal())));
				}
			}
			// Validacion para email
			if (this.getEmail().length() > 0) {
				if (this.getEmail().length() > 50) {
					log.warn("El e-mail del usuario es demasiado grande");
					mensajes.add("email", new ActionMessage(
							"usuario.error.email.grande"));
				} else if (!Validaciones.esEmailValido(this.getEmail())) {
					log.warn("El formato de email no es correcto");
					mensajes.add("email", new ActionMessage("formulario.email"));
				} else if (Validaciones.libreCaracteresEspeciales(this.getEmail()) != null) {
					log.warn("Contiene caracteres especiales");
					mensajes.add("email", new ActionMessage(
							"formulario.caracteres_especiales", Validaciones
									.libreCaracteresEspeciales(this.getEmail())));
				}
			}
		}
		// Devolvemos los mensajes de error
		return mensajes;
	}

	/**
	 * Method clean
	 * 
	 * @param mapping
	 * @param request
	 */
	
	public void clean(ActionMapping mapping, HttpServletRequest request) {
		this.setId(null);
		this.setNombre("");
		this.setApellido1("");
		this.setApellido2("");
		this.setCodigo_postal("");
		this.setClave1(null);
		this.setClave2(null);
		this.setDireccion("");
		this.setDni("");
		this.setEmail("");
		this.setFecha_nacimiento("");
		this.setLocalidad("");
		this.setMovil("");
		this.setPerfil("");
		this.setTelefono("");
		this.setUsuario("");
		this.setAceptar("0");
	}
	
	/**
	 * Method reset
	 * 
	 * @param mapping
	 * @param request
	 */
	@Override
	public void reset(ActionMapping mapping, HttpServletRequest request) {
	}

	/**
	 * Returns the clave
	 * 
	 * @return String
	 */
	public String getClave1() {
		return clave1;
	}

	/**
	 * Set the clave.
	 * 
	 * @param clave
	 *            The clave to set
	 */
	public void setClave1(String clave) {
		this.clave1 = clave;
	}

	/**
	 * Returns the fecha_nacimiento.
	 * 
	 * @return Timestamp
	 */
	public String getFecha_nacimiento() {
		return fecha_nacimiento;
	}

	/**
	 * Set the fecha_nacimiento.
	 * 
	 * @param fecha_nacimiento
	 *            The fecha_nacimiento to set
	 */
	public void setFecha_nacimiento(String fecha_nacimiento) {
		this.fecha_nacimiento = fecha_nacimiento;
	}

	/**
	 * Returns the nombre.
	 * 
	 * @return String
	 */
	public String getNombre() {
		return nombre;
	}

	/**
	 * Set the nombre.
	 * 
	 * @param nombre
	 *            The nombre to set
	 */
	public void setNombre(String nombre) {
		this.nombre = nombre;
	}

	/**
	 * Returns the usuario.
	 * 
	 * @return String
	 */
	public String getUsuario() {
		return usuario;
	}

	/**
	 * Set the usuario.
	 * 
	 * @param usuario
	 *            The usuario to set
	 */
	public void setUsuario(String usuario) {
		this.usuario = usuario;
	}

	/**
	 * Returns the codigo_postal.
	 * 
	 * @return String
	 */
	public String getCodigo_postal() {
		return codigo_postal;
	}

	/**
	 * Set the codigo_postal.
	 * 
	 * @param codigo_postal
	 *            The codigo_postal to set
	 */
	public void setCodigo_postal(String codigo_postal) {
		this.codigo_postal = codigo_postal;
	}

	/**
	 * Returns the movil.
	 * 
	 * @return String
	 */
	public String getMovil() {
		return movil;
	}

	/**
	 * Set the movil.
	 * 
	 * @param movil
	 *            The movil to set
	 */
	public void setMovil(String movil) {
		this.movil = movil;
	}

	/**
	 * Returns the perfil.
	 * 
	 * @return String
	 */
	public String getPerfil() {
		return perfil;
	}

	/**
	 * Set the perfil.
	 * 
	 * @param perfil
	 *            The perfil to set
	 */
	public void setPerfil(String perfil) {
		this.perfil = perfil;
	}

	/**
	 * Returns the email.
	 * 
	 * @return String
	 */
	public String getEmail() {
		return email;
	}

	/**
	 * Set the email.
	 * 
	 * @param email
	 *            The email to set
	 */
	public void setEmail(String email) {
		this.email = email;
	}

	/**
	 * Returns the apellido2.
	 * 
	 * @return String
	 */
	public String getApellido2() {
		return apellido2;
	}

	/**
	 * Set the apellido2.
	 * 
	 * @param apellido2
	 *            The apellido2 to set
	 */
	public void setApellido2(String apellido2) {
		this.apellido2 = apellido2;
	}

	/**
	 * Returns the direccion.
	 * 
	 * @return String
	 */
	public String getDireccion() {
		return direccion;
	}

	/**
	 * Set the direccion.
	 * 
	 * @param direccion
	 *            The direccion to set
	 */
	public void setDireccion(String direccion) {
		this.direccion = direccion;
	}

	/**
	 * Returns the telefono.
	 * 
	 * @return String
	 */
	public String getTelefono() {
		return telefono;
	}

	/**
	 * Set the telefono.
	 * 
	 * @param telefono
	 *            The telefono to set
	 */
	public void setTelefono(String telefono) {
		this.telefono = telefono;
	}

	/**
	 * Returns the apellido1.
	 * 
	 * @return String
	 */
	public String getApellido1() {
		return apellido1;
	}

	/**
	 * Set the apellido1.
	 * 
	 * @param apellido1
	 *            The apellido1 to set
	 */
	public void setApellido1(String apellido1) {
		this.apellido1 = apellido1;
	}

	/**
	 * @return the dni
	 */
	public String getDni() {
		return dni;
	}

	/**
	 * @param dni
	 *            the dni to set
	 */
	public void setDni(String dni) {
		this.dni = dni;
	}

	/**
	 * @return the localidad
	 */
	public String getLocalidad() {
		return localidad;
	}

	/**
	 * @param localidad
	 *            the localidad to set
	 */
	public void setLocalidad(String localidad) {
		this.localidad = localidad;
	}

	/**
	 * @return the clave2
	 */
	public String getClave2() {
		return clave2;
	}

	/**
	 * @param clave2
	 *            the clave2 to set
	 */
	public void setClave2(String clave2) {
		this.clave2 = clave2;
	}

	/**
	 * @return the id
	 */
	public Integer getId() {
		return id;
	}

	/**
	 * @param id
	 *            the id to set
	 */
	public void setId(Integer id) {
		this.id = id;
	}

}