
package form;

import hibernate.DiaDAO;
import hibernate.Servicio;
import hibernate.ServicioDAO;

import java.util.Iterator;
import java.util.List;

import javax.servlet.http.HttpServletRequest;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.apache.struts.action.ActionErrors;
import org.apache.struts.action.ActionMapping;
import org.apache.struts.action.ActionMessage;
import org.apache.struts.validator.ValidatorForm;


public class TareaForm extends ValidatorForm {

	private static Log logs = LogFactory.getLog(TareaForm.class);
	
	
	/** idVoluntario property */
	private String idVoluntario;
	
	private String horaInicio;

	private String horaFin;

	private String dia;

	private String pd;

	private String tarea;

	private String subtarea;
	
	private String tareaselect;
	
	private Boolean select;
	
	private String notas;
	

	public String getNotas() {
		return notas;
	}

	public void setNotas(String notas) {
		this.notas = notas;
	}

	public String getTareaselect() {
		return tareaselect;
	}

	public void setTareaselect(String tareaselect) {
		this.tareaselect = tareaselect;
	}

	/** 
	 * Method validate
	 * @param mapping
	 * @param request
	 * @return ActionErrors
	 */
	public ActionErrors validate(ActionMapping mapping,
			HttpServletRequest request) {
		// Lista de errores
		ActionErrors mensajes = new ActionErrors();
			
			// Tareas
		if (request.getParameter("volver") == null) {
			
			if ((this.getTarea() != null) && (!"".equals(this.getTarea()))) {
				Boolean b = this.getSelect();
				this.setSelect(true);
				if (b == this.getSelect()) {
					// No ha cambiado la tarea
					String t = request.getParameter("tarea").toString();
					// Dia
					if (this.getDia().equals("")) {
						mensajes.add("dia", new ActionMessage("servicio.error.diavacio"));
					}
					// Tareas
					if (this.getTarea().equals("") || (this.getSubtarea().equals(""))) {
						mensajes.add("subtarea", new ActionMessage("servicio.error.tareavacio"));
					}
					// PD
					if (this.getPd().equals("")) {
						mensajes.add("pd", new ActionMessage("servicio.error.pdvacio"));
					}
					
					// Horas
					if ((this.getHoraInicio().equals("")) || (this.getHoraFin().equals(""))) {
						mensajes.add("horaFin", new ActionMessage("servicio.error.horavacio"));
					} else if (((!this.getHoraInicio().equals("")) && (!this.getHoraFin().equals("")))) {
						// Intervalo Correcto	
						if (Integer.parseInt(this.getHoraFin()) < Integer.parseInt(this.getHoraInicio())) {
							mensajes.add("horaFin", new ActionMessage("servicio.error.intervaloincorrecto"));
							// Intervalo Valido
						} else {
							// Traemos todos los servicios del voluntario para ese d�a
							ServicioDAO serDAO = new ServicioDAO();
							List l = serDAO.findAllDia(this.getDia(),this.getIdVoluntario());
							// Comprobamos intervalo disponible
							if (l.size() > 0) {
								Iterator<Servicio> i = l.iterator();
								Boolean control = true;
								while (i.hasNext() && control) {
									Servicio s = i.next();
									Integer hi = s.getHoraByHoraInicio().getId();
									String di = s.getHoraByHoraInicio().getIntervalo();
									Integer hf = s.getHoraByHoraFin().getId();
									String df = s.getHoraByHoraFin().getIntervalo();
									DiaDAO diaDAO = new DiaDAO(); 
									String dia = diaDAO.findById(Integer.parseInt(this.getDia())).getDescripcion();
									if ((hi <= Integer.parseInt(this.getHoraInicio()))
											&& (hf > Integer.parseInt(this.getHoraInicio()))
											&& (hf >= Integer.parseInt(this.getHoraFin()))) {
										logs.debug("CASO 1");
										control = false;
										mensajes.add("horaFin", new ActionMessage("servicio.error.intervaloinvalido", 
												dia, di, df));
									} else if ((hi >= Integer.parseInt(this.getHoraInicio())) 
											&& (hf >= Integer.parseInt(this.getHoraFin())) 
											&& (hi < Integer.parseInt(this.getHoraFin()))) {
										logs.debug("CASO 2");
										control = false;
										mensajes.add("horaFin", new ActionMessage("servicio.error.intervaloinvalido", 
												dia, di, df));
									} else if ((hi < Integer.parseInt(this.getHoraInicio())) 
											&& (hf <= Integer.parseInt(this.getHoraFin())) 
											&& (hf > Integer.parseInt(this.getHoraInicio()))) {
										logs.debug("CASO 3");
										control = false;
										mensajes.add("horaFin", new ActionMessage("servicio.error.intervaloinvalido", 
												dia, di, df));
									} else if ((hi >= Integer.parseInt(this.getHoraInicio())) 
											&& (hf <= Integer.parseInt(this.getHoraFin()))) {
										logs.debug("CASO 4");
										control = false;
										mensajes.add("horaFin", new ActionMessage("servicio.error.intervaloinvalido", 
												dia, di, df));
									}
								}
							}
						}
					}
				} else {
					// Acaba de seleccionar nueva tarea
					
				}
			} else {
				// Dia
				if (this.getDia().equals("")) {
					mensajes.add("dia", new ActionMessage("servicio.error.diavacio"));
				}
				// Tareas
				if (this.getTarea().equals("") || (this.getSubtarea().equals(""))) {
					mensajes.add("subtarea", new ActionMessage("servicio.error.tareavacio"));
				}
				// PD
				if (this.getPd().equals("")) {
					mensajes.add("pd", new ActionMessage("servicio.error.pdvacio"));
				}
				
				// Horas
				if ((this.getHoraInicio().equals("")) || (this.getHoraFin().equals(""))) {
					mensajes.add("horaFin", new ActionMessage("servicio.error.horavacio"));
				} else if (((!this.getHoraInicio().equals("")) && (!this.getHoraFin().equals("")))) {
					// Intervalo Correcto	
					if (Integer.parseInt(this.getHoraFin()) < Integer.parseInt(this.getHoraInicio())) {
						mensajes.add("horaFin", new ActionMessage("servicio.error.intervaloincorrecto"));
						// Intervalo Valido
					} else {
						// Traemos todos los servicios del voluntario para ese d�a
						ServicioDAO serDAO = new ServicioDAO();
						List l = serDAO.findAllDia(this.getDia(),this.getIdVoluntario());
						// Comprobamos intervalo disponible
						if (l.size() > 0) {
							Iterator<Servicio> i = l.iterator();
							Boolean control = true;
							while (i.hasNext() && control) {
								Servicio s = i.next();
								Integer hi = s.getHoraByHoraInicio().getId();
								String di = s.getHoraByHoraInicio().getIntervalo();
								Integer hf = s.getHoraByHoraFin().getId();
								String df = s.getHoraByHoraFin().getIntervalo();
								DiaDAO diaDAO = new DiaDAO(); 
								String dia = diaDAO.findById(Integer.parseInt(this.getDia())).getDescripcion();
								if ((hi <= Integer.parseInt(this.getHoraInicio()))
										&& (hf > Integer.parseInt(this.getHoraInicio()))
										&& (hf >= Integer.parseInt(this.getHoraFin()))) {
									logs.debug("CASO 1");
									control = false;
									mensajes.add("horaFin", new ActionMessage("servicio.error.intervaloinvalido", 
											dia, di, df));
								} else if ((hi >= Integer.parseInt(this.getHoraInicio())) 
										&& (hf >= Integer.parseInt(this.getHoraFin())) 
										&& (hi < Integer.parseInt(this.getHoraFin()))) {
									logs.debug("CASO 2");
									control = false;
									mensajes.add("horaFin", new ActionMessage("servicio.error.intervaloinvalido", 
											dia, di, df));
								} else if ((hi < Integer.parseInt(this.getHoraInicio())) 
										&& (hf <= Integer.parseInt(this.getHoraFin())) 
										&& (hf > Integer.parseInt(this.getHoraInicio()))) {
									logs.debug("CASO 3");
									control = false;
									mensajes.add("horaFin", new ActionMessage("servicio.error.intervaloinvalido", 
											dia, di, df));
								} else if ((hi >= Integer.parseInt(this.getHoraInicio())) 
										&& (hf <= Integer.parseInt(this.getHoraFin()))) {
									logs.debug("CASO 4");
									control = false;
									mensajes.add("horaFin", new ActionMessage("servicio.error.intervaloinvalido", 
											dia, di, df));
								}
							}
						}
					}
				}
				this.setSubtarea("");
				request.setAttribute("subtarea", "");
			}
		}
		return mensajes;
	}

	/** 
	 * Method reset
	 * @param mapping
	 * @param request
	 */
	public void reset(ActionMapping mapping, HttpServletRequest request) {
		this.setDia("");
		this.setHoraFin("");
		this.setHoraInicio("");
		this.setSubtarea("");
		this.setTarea("");
		this.setPd("");
		this.setNotas("");
	}
	
	public void clean(ActionMapping mapping, HttpServletRequest request) {
		this.setDia("");
		this.setHoraFin("");
		this.setHoraInicio("");
		this.setSubtarea("");
		this.setTarea("");
		this.setPd("");
		this.setNotas("");
	}

	public String getIdVoluntario() {
		return idVoluntario;
	}

	public void setIdVoluntario(String idVoluntario) {
		this.idVoluntario = idVoluntario;
	}
	
	public String getHoraInicio() {
		return horaInicio;
	}

	public void setHoraInicio(String horaInicio) {
		this.horaInicio = horaInicio;
	}

	public String getHoraFin() {
		return horaFin;
	}

	public void setHoraFin(String horaFin) {
		this.horaFin = horaFin;
	}

	public String getDia() {
		return dia;
	}

	public void setDia(String dia) {
		this.dia = dia;
	}

	public String getPd() {
		return pd;
	}

	public void setPd(String pd) {
		this.pd = pd;
	}

	public String getTarea() {
		return tarea;
	}

	public void setTarea(String tarea) {
		this.tarea = tarea;
	}

	public String getSubtarea() {
		return subtarea;
	}

	public void setSubtarea(String subtarea) {
		this.subtarea = subtarea;
	}

	public Boolean getSelect() {
		return select;
	}

	public void setSelect(Boolean select) {
		this.select = select;
	}

}