/*
 * Generated by MyEclipse Struts
 * Template path: templates/java/JavaClass.vtl
 */
package form;

import hibernate.Persona;
import hibernate.PersonaDAO;
import hibernate.Usuario;
import hibernate.UsuarioDAO;

import java.util.HashSet;
import java.util.Iterator;
import java.util.Set;

import javax.servlet.http.HttpServletRequest;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.apache.struts.action.ActionErrors;
import org.apache.struts.action.ActionMapping;
import org.apache.struts.action.ActionMessage;
import org.apache.struts.validator.ValidatorForm;

import util.Validaciones;


public class VoluntarioForm extends ValidatorForm {


	/** PD_asignados property */
	private String[] PD_asignados;

	/** PD_no_asignados property */
	private String[] PD_no_asignados;

	/** nombre property */
	private String nombre;
	
	private String fecha_nacimiento;
	
	/** apellido1 property */
	private String apellido1;
	
	/** apellido2 property */
	private String apellido2;

	/** titulacion property */
	private String titulacion;

	/** radio_disponible property */
	private String radio_disponible;

	/** dni property */
	private String dni;

	/** direccion property */
	private String direccion;

	/** telefono property */
	private String telefono;
	
	/** id_persona property */
	private String id_persona;
	
	/** id_asociacion property */
	private String id_asociacion;
	
	private String id;
	
	private String id_usuario;
	
	private String login;
	
	private String clave1;
	
	private String clave2;
	
	private String fec_alta_usuario;
	
	private String fec_baja_usuario;
	
	private String localidad;
	
	private Boolean creando;
	
	/** email property */
	private String email;
	/*
	 * Generated Methods
	 */
	// Gestor de logs
	private static Log log = LogFactory.getLog(VoluntarioForm.class);
	/** 
	 * Method validate
	 * @param mapping
	 * @param request
	 * @return ActionErrors
	 */
	@Override
	public ActionErrors validate(ActionMapping mapping,
			HttpServletRequest request) {
		
		// errores
		ActionErrors mensajes = new ActionErrors();

		UsuarioDAO userDAO = new UsuarioDAO();
		PersonaDAO personaDAO = new PersonaDAO();		
		Set<Usuario> users = new HashSet(0); 
		users.addAll(userDAO.findAll());
		Set<Persona> personas = new HashSet(0);
		personas.addAll(personaDAO.findAll());
		
		if (request.getParameter("volver") == null) {
			
			if ((this.getId() == null) || (this.getId().toString().equals(""))) {
				// Usuario
				if (this.getLogin().equals("")) {
					mensajes.add("login", new ActionMessage("auxiliar.error.login.vacio"));			
				} else if (this.getLogin().length() > 256) {
					mensajes.add("login", new ActionMessage("auxiliar.error.login.grande"));
				} else if (Validaciones.libreCaracteresEspeciales(this.getLogin()) != null) {
					log.warn("Contiene caracteres especiales");
					mensajes.add("login", new ActionMessage("formulario.caracteres_especiales",
							Validaciones.libreCaracteresEspeciales(this.getLogin())));
				} else if (Validaciones.libreCaracteresEspeciales(this.getLogin()) != null) {
					log.warn("Contiene caracteres especiales");
					mensajes.add("login", new ActionMessage("formulario.caracteres_especiales",
							Validaciones.libreCaracteresEspeciales(this.getLogin())));
				} else {
					// el login elegido existía ???
					Boolean encontrado = false;
					Iterator<Usuario> it = users.iterator();
					while ((it.hasNext()) && (!encontrado)) {
						Usuario user = it.next();
						if ((user.getLogin().equals(this.getLogin())) && (!this.getId_usuario().equals(user.getId().toString()))) 
							encontrado = true;
					}
					if (encontrado)
						mensajes.add("login", new ActionMessage("auxiliar.error.login.existe"));
				}

					if ((this.getClave1().equals(""))) {
						log.warn("Clave vacia");
						mensajes.add("clave", new ActionMessage("auxiliar.error.clave.vacia"));
					} else if ((this.getClave1().length()>1024)) {
						log.warn("Clave demasiado grande");
						mensajes.add("clave", new ActionMessage("auxiliar.error.clave.grande"));
					} else if (Validaciones.libreCaracteresEspeciales(this.getClave1()) != null) {
						log.warn("Contiene caracteres especiales");
						mensajes.add("clave", new ActionMessage("formulario.caracteres_especiales",
								Validaciones.libreCaracteresEspeciales(this.getClave1())));
					} else if (Validaciones.libreCaracteresEspeciales(this.getClave1()) != null) {
						log.warn("Contiene caracteres especiales");
						mensajes.add("clave", new ActionMessage("formulario.caracteres_especiales",
								Validaciones.libreCaracteresEspeciales(this.getClave1())));
					}
					if ((!this.getClave2().equals(""))&&(!this.getClave1().equals(""))) 
						if (!this.getClave2().equals(this.getClave1())) {
							log.warn("Las claves no coinciden");
							mensajes.add("clave2", new ActionMessage("auxiliar.error.clave.nocoincide"));
						}
			}	
			if (this.getDireccion().length() > 50) {
				mensajes.add("direccion", new ActionMessage("auxiliar.error.direccion.grande"));
			} else if (Validaciones.libreCaracteresEspeciales(this.getDireccion()) != null) {
				log.warn("Contiene caracteres especiales");
				mensajes.add("direccion", new ActionMessage("formulario.caracteres_especiales",
						Validaciones.libreCaracteresEspeciales(this.getDireccion())));
			} else if (Validaciones.libreCaracteresEspeciales(this.getDireccion()) != null) {
				log.warn("Contiene caracteres especiales");
				mensajes.add("direccion", new ActionMessage("formulario.caracteres_especiales",
						Validaciones.libreCaracteresEspeciales(this.getDireccion())));
			}
			// email
			if (this.getEmail().length() > 0) {
				if (this.getEmail().length() > 50) {
					log.warn("El e-mail del usuario es demasiado grande");
					mensajes.add("email", new ActionMessage(
							"usuario.error.email.grande"));
				} else if (!Validaciones.esEmailValido(this.getEmail())) {
					log.warn("El formato de email no es correcto");
					mensajes.add("email", new ActionMessage("formulario.email"));
				} else if (Validaciones.libreCaracteresEspeciales(this.getEmail()) != null) {
					log.warn("Contiene caracteres especiales");
					mensajes.add("email", new ActionMessage(
							"formulario.caracteres_especiales", Validaciones
									.libreCaracteresEspeciales(this.getEmail())));
				}
			}
			if ((this.getEmail() == null) || ("".equals(this.getEmail()))) {
				mensajes.add("email", new ActionMessage(
						"recordar.email"));
			}
			// Localidad
			if (this.getLocalidad().equals("")) {
				mensajes.add("localidad", new ActionMessage("voluntario.localidad.vacio"));
			}
				//  Nombre
			if (this.getNombre().length() > 50) {
				mensajes.add("nombre", new ActionMessage("auxiliar.error.nombre.grande"));
			} else if (this.getNombre().equals("")) {
				mensajes.add("nombre", new ActionMessage("auxiliar.error.nombre.vacio"));			
			} else if (Validaciones.libreCaracteresEspeciales(this.getNombre()) != null) {
				log.warn("Contiene caracteres especiales");
				mensajes.add("nombre", new ActionMessage("formulario.caracteres_especiales",
						Validaciones.libreCaracteresEspeciales(this.getNombre())));
			} else if (Validaciones.libreCaracteresEspeciales(this.getNombre()) != null) {
				log.warn("Contiene caracteres especiales");
				mensajes.add("nombre", new ActionMessage("formulario.caracteres_especiales",
						Validaciones.libreCaracteresEspeciales(this.getNombre())));
			}
			// Comprobamos apellidos
			// Apellido1
			if (this.getApellido1().equals("")) {
				mensajes.add("apellido1", new ActionMessage(
						"auxiliar.error.apellido1.vacio"));
			} else if (this.getApellido1().length() > 50) {
				mensajes.add("apellido1", new ActionMessage(
						"auxiliar.error.apellido1.grande"));
			} else if (Validaciones.libreCaracteresEspeciales(this.getApellido1()) != null) {
				log.warn("Contiene caracteres especiales");
				mensajes.add("apellido1", new ActionMessage("formulario.caracteres_especiales",
						Validaciones.libreCaracteresEspeciales(this.getApellido1())));
			} else if (Validaciones.libreCaracteresEspeciales(this.getApellido1()) != null) {
				log.warn("Contiene caracteres especiales");
				mensajes.add("apellido1", new ActionMessage("formulario.caracteres_especiales",
						Validaciones.libreCaracteresEspeciales(this.getApellido1())));
			}
			// Apellido2
			if ((!this.getApellido2().equals("")) && (this.getApellido2().length() > 50)) {
				mensajes.add("apellido2", new ActionMessage("auxiliar.error.apellido2.grande"));
			} else if (Validaciones.libreCaracteresEspeciales(this.getApellido2()) != null) {
				log.warn("Contiene caracteres especiales");
				mensajes.add("apellido2", new ActionMessage("formulario.caracteres_especiales",
						Validaciones.libreCaracteresEspeciales(this.getApellido2())));
			} else if (Validaciones.libreCaracteresEspeciales(this.getApellido2()) != null) {
				log.warn("Contiene caracteres especiales");
				mensajes.add("apellido2", new ActionMessage("formulario.caracteres_especiales",
						Validaciones.libreCaracteresEspeciales(this.getApellido2())));
			}
			// Comprobamos DNI
			if (this.getDni().equals("")) {
				mensajes.add("dni", new ActionMessage(
						"auxiliar.error.dni.vacio"));
			} else if ((this.getDni().length() != 9) || (!Validaciones.esDniValido(this.getDni()))) {
				mensajes.add("dni", new ActionMessage(
						"auxiliar.error.dni.formato"));
			} else if (Validaciones.libreCaracteresEspeciales(this.getDni()) != null) {
				log.warn("Contiene caracteres especiales");
				mensajes.add("dni", new ActionMessage("formulario.caracteres_especiales",
						Validaciones.libreCaracteresEspeciales(this.getDni())));
			} 
			// Validamos teléfono
			if (this.getTelefono().length() > 50) {
				mensajes.add("telefono", new ActionMessage(
						"auxiliar.error.telefono.grande"));
			} else if ((!this.getTelefono().equals("")) && (!Validaciones.esTLFValido(this.getTelefono()))) {
				mensajes.add("telefono", new ActionMessage(
						"auxiliar.error.telefono.formato"));
			} else if (Validaciones.libreCaracteresEspeciales(this.getTelefono()) != null) {
				log.warn("Contiene caracteres especiales");
				mensajes.add("telefono", new ActionMessage("formulario.caracteres_especiales",
						Validaciones.libreCaracteresEspeciales(this.getTelefono())));
			} else if (Validaciones.libreCaracteresEspeciales(this.getTelefono()) != null) {
				log.warn("Contiene caracteres especiales");
				mensajes.add("telefono", new ActionMessage("formulario.caracteres_especiales",
						Validaciones.libreCaracteresEspeciales(this.getTelefono())));
			}
		}
		return mensajes;
	}

	/** 
	 * Method reset
	 * @param mapping
	 * @param request
	 */
	@Override
	public void reset(ActionMapping mapping, HttpServletRequest request) {

	}

	public void clean(ActionMapping mapping, HttpServletRequest request) {

		this.setDireccion("");
		this.setNombre("");
		this.setApellido1("");
		this.setApellido2("");
		this.setDni("");
		this.setTelefono("");
		this.setTitulacion("");
		this.setLogin("");
		this.setClave1("");
		this.setClave2("");
		this.setFecha_nacimiento("");
		this.setEmail("");
		this.setLocalidad("");
		this.setCreando(false);
		this.setId(null);
		this.setId_persona(null);
		this.setId_usuario(null);
		this.setRadio_disponible(null);
	}
	
	/** 
	 * Returns the PD_asignados.
	 * @return String
	 */
	public String[] getPD_asignados() {
		return PD_asignados;
	}

	/** 
	 * Set the PD_asignados.
	 * @param PD_asignados The PD_asignados to set
	 */
	public void setPD_asignados(String[] PD_asignados) {
		this.PD_asignados = PD_asignados;
	}

	/** 
	 * Returns the PD_no_asignados.
	 * @return String
	 */
	public String[] getPD_no_asignados() {
		return PD_no_asignados;
	}

	/** 
	 * Set the PD_no_asignados.
	 * @param PD_no_asignados The PD_no_asignados to set
	 */
	public void setPD_no_asignados(String[] PD_no_asignados) {
		this.PD_no_asignados = PD_no_asignados;
	}

	/** 
	 * Returns the nombre.
	 * @return String
	 */
	public String getNombre() {
		return nombre;
	}

	/** 
	 * Set the nombre.
	 * @param nombre The nombre to set
	 */
	public void setNombre(String nombre) {
		this.nombre = nombre;
	}

	/** 
	 * Returns the titulacion.
	 * @return String
	 */
	public String getTitulacion() {
		return titulacion;
	}

	/** 
	 * Set the titulacion.
	 * @param titulacion The titulacion to set
	 */
	public void setTitulacion(String titulacion) {
		this.titulacion = titulacion;
	}

	/** 
	 * Returns the dni.
	 * @return String
	 */
	public String getDni() {
		return dni;
	}

	/** 
	 * Set the dni.
	 * @param dni The dni to set
	 */
	public void setDni(String dni) {
		this.dni = dni;
	}

	/** 
	 * Returns the direccion.
	 * @return String
	 */
	public String getDireccion() {
		return direccion;
	}

	/** 
	 * Set the direccion.
	 * @param direccion The direccion to set
	 */
	public void setDireccion(String direccion) {
		this.direccion = direccion;
	}

	/** 
	 * Returns the telefono.
	 * @return String
	 */
	public String getTelefono() {
		return telefono;
	}

	/** 
	 * Set the telefono.
	 * @param telefono The telefono to set
	 */
	public void setTelefono(String telefono) {
		this.telefono = telefono;
	}

	/**
	 * @return the apellido1
	 */
	public String getApellido1() {
		return apellido1;
	}

	/**
	 * @param apellido1 the apellido1 to set
	 */
	public void setApellido1(String apellido1) {
		this.apellido1 = apellido1;
	}

	/**
	 * @return the apellido2
	 */
	public String getApellido2() {
		return apellido2;
	}

	/**
	 * @param apellido2 the apellido2 to set
	 */
	public void setApellido2(String apellido2) {
		this.apellido2 = apellido2;
	}

	/**
	 * @return the radio_disponible
	 */
	public String getRadio_disponible() {
		return radio_disponible;
	}

	/**
	 * @param radio_disponible the radio_disponible to set
	 */
	public void setRadio_disponible(String radio_disponible) {
		this.radio_disponible = radio_disponible;
	}

	/**
	 * @return the id_persona
	 */
	public String getId_persona() {
		return id_persona;
	}

	/**
	 * @param id_persona the id_persona to set
	 */
	public void setId_persona(String id_persona) {
		this.id_persona = id_persona;
	}

	/**
	 * @return the login
	 */
	public String getLogin() {
		return login;
	}

	/**
	 * @param login the login to set
	 */
	public void setLogin(String login) {
		this.login = login;
	}

	/**
	 * @return the clave
	 */
	public String getClave1() {
		return clave1;
	}

	/**
	 * @param clave the clave to set
	 */
	public void setClave1(String clave) {
		this.clave1 = clave;
	}

	/**
	 * @return the fec_alta_usuario
	 */
	public String getFec_alta_usuario() {
		return fec_alta_usuario;
	}

	/**
	 * @param fec_alta_usuario the fec_alta_usuario to set
	 */
	public void setFec_alta_usuario(String fec_alta_usuario) {
		this.fec_alta_usuario = fec_alta_usuario;
	}

	/**
	 * @return the fec_baja_usuario
	 */
	public String getFec_baja_usuario() {
		return fec_baja_usuario;
	}

	/**
	 * @param fec_baja_usuario the fec_baja_usuario to set
	 */
	public void setFec_baja_usuario(String fec_baja_usuario) {
		this.fec_baja_usuario = fec_baja_usuario;
	}

	/**
	 * @return the clave2
	 */
	public String getClave2() {
		return clave2;
	}

	/**
	 * @param clave2 the clave2 to set
	 */
	public void setClave2(String clave2) {
		this.clave2 = clave2;
	}

	/**
	 * @return the id
	 */
	public String getId() {
		return id;
	}

	/**
	 * @param id the id to set
	 */
	public void setId(String id) {
		this.id = id;
	}

	/**
	 * @return the id_usuario
	 */
	public String getId_usuario() {
		return id_usuario;
	}

	/**
	 * @param id_usuario the id_usuario to set
	 */
	public void setId_usuario(String id_usuario) {
		this.id_usuario = id_usuario;
	}

	/**
	 * @return the localidad
	 */
	public String getLocalidad() {
		return localidad;
	}

	/**
	 * @param localidad the localidad to set
	 */
	public void setLocalidad(String localidad) {
		this.localidad = localidad;
	}

	/**
	 * @return the creando
	 */
	public Boolean getCreando() {
		return creando;
	}

	/**
	 * @param creando the creando to set
	 */
	public void setCreando(Boolean creando) {
		this.creando = creando;
	}

	public String getId_asociacion() {
		return id_asociacion;
	}

	public void setId_asociacion(String id_asociacion) {
		this.id_asociacion = id_asociacion;
	}

	public String getFecha_nacimiento() {
		return fecha_nacimiento;
	}

	public void setFecha_nacimiento(String fecha_nacimiento) {
		this.fecha_nacimiento = fecha_nacimiento;
	}

	public String getEmail() {
		return email;
	}

	public void setEmail(String email) {
		this.email = email;
	}

}