package hibernate;

import java.util.Date;
import java.util.HashSet;
import java.util.Set;

/**
 * AbstractAsociacion entity provides the base persistence definition of the
 * Asociacion entity.
 * 
 * @author MyEclipse Persistence Tools
 */

public abstract class AbstractAsociacion implements java.io.Serializable {

	// Fields

	private Integer id;
	private Persona persona;
	private Localidad localidad;
	private String nombre;
	private String descripcion;
	private String direccion;
	private String telefono;
	private Date fecAlta;
	private Date fecBaja;
	private Set personaDependientes = new HashSet(0);
	private Set auxiliars = new HashSet(0);

	// Constructors

	/** default constructor */
	public AbstractAsociacion() {
	}

	/** minimal constructor */
	public AbstractAsociacion(Integer id) {
		this.id = id;
	}

	/** full constructor */
	public AbstractAsociacion(Integer id, Persona persona, Localidad localidad,
			String nombre, String descripcion, String direccion,
			String telefono, Date fecAlta, Date fecBaja,
			Set personaDependientes, Set auxiliars) {
		this.id = id;
		this.persona = persona;
		this.localidad = localidad;
		this.nombre = nombre;
		this.descripcion = descripcion;
		this.direccion = direccion;
		this.telefono = telefono;
		this.fecAlta = fecAlta;
		this.fecBaja = fecBaja;
		this.personaDependientes = personaDependientes;
		this.auxiliars = auxiliars;
	}

	// Property accessors

	public Integer getId() {
		return this.id;
	}

	public void setId(Integer id) {
		this.id = id;
	}

	public Persona getPersona() {
		return this.persona;
	}

	public void setPersona(Persona persona) {
		this.persona = persona;
	}

	public Localidad getLocalidad() {
		return this.localidad;
	}

	public void setLocalidad(Localidad localidad) {
		this.localidad = localidad;
	}

	public String getNombre() {
		return this.nombre;
	}

	public void setNombre(String nombre) {
		this.nombre = nombre;
	}

	public String getDescripcion() {
		return this.descripcion;
	}

	public void setDescripcion(String descripcion) {
		this.descripcion = descripcion;
	}

	public String getDireccion() {
		return this.direccion;
	}

	public void setDireccion(String direccion) {
		this.direccion = direccion;
	}

	public String getTelefono() {
		return this.telefono;
	}

	public void setTelefono(String telefono) {
		this.telefono = telefono;
	}

	public Date getFecAlta() {
		return this.fecAlta;
	}

	public void setFecAlta(Date fecAlta) {
		this.fecAlta = fecAlta;
	}

	public Date getFecBaja() {
		return this.fecBaja;
	}

	public void setFecBaja(Date fecBaja) {
		this.fecBaja = fecBaja;
	}

	public Set getPersonaDependientes() {
		return this.personaDependientes;
	}

	public void setPersonaDependientes(Set personaDependientes) {
		this.personaDependientes = personaDependientes;
	}

	public Set getAuxiliars() {
		return this.auxiliars;
	}

	public void setAuxiliars(Set auxiliars) {
		this.auxiliars = auxiliars;
	}

}