package hibernate;

import java.util.Date;
import java.util.HashSet;
import java.util.Set;

/**
 * AbstractExpediente entity provides the base persistence definition of the
 * Expediente entity.
 * 
 * @author MyEclipse Persistence Tools
 */

public abstract class AbstractExpediente implements java.io.Serializable {

	// Fields

	private Integer id;
	private Auxiliar auxiliar;
	private Byte listaEspera;
	private Byte concedido;
	private String motivoDenegacion;
	private Date fecAlta;
	private Date fecBaja;
	private Date fecRevisionSad;
	private Integer totalPuntuacion;
	private Set personaDependientes = new HashSet(0);
	private Set servicios = new HashSet(0);

	// Constructors

	/** default constructor */
	public AbstractExpediente() {
	}

	/** minimal constructor */
	public AbstractExpediente(Integer id) {
		this.id = id;
	}

	/** full constructor */
	public AbstractExpediente(Integer id, Auxiliar auxiliar, Byte listaEspera,
			Byte concedido, String motivoDenegacion, Date fecAlta,
			Date fecBaja, Date fecRevisionSad, Integer totalPuntuacion,
			Set personaDependientes, Set servicios) {
		this.id = id;
		this.auxiliar = auxiliar;
		this.listaEspera = listaEspera;
		this.concedido = concedido;
		this.motivoDenegacion = motivoDenegacion;
		this.fecAlta = fecAlta;
		this.fecBaja = fecBaja;
		this.fecRevisionSad = fecRevisionSad;
		this.totalPuntuacion = totalPuntuacion;
		this.personaDependientes = personaDependientes;
		this.servicios = servicios;
	}

	// Property accessors

	public Integer getId() {
		return this.id;
	}

	public void setId(Integer id) {
		this.id = id;
	}

	public Auxiliar getAuxiliar() {
		return this.auxiliar;
	}

	public void setAuxiliar(Auxiliar auxiliar) {
		this.auxiliar = auxiliar;
	}

	public Byte getListaEspera() {
		return this.listaEspera;
	}

	public void setListaEspera(Byte listaEspera) {
		this.listaEspera = listaEspera;
	}

	public Byte getConcedido() {
		return this.concedido;
	}

	public void setConcedido(Byte concedido) {
		this.concedido = concedido;
	}

	public String getMotivoDenegacion() {
		return this.motivoDenegacion;
	}

	public void setMotivoDenegacion(String motivoDenegacion) {
		this.motivoDenegacion = motivoDenegacion;
	}

	public Date getFecAlta() {
		return this.fecAlta;
	}

	public void setFecAlta(Date fecAlta) {
		this.fecAlta = fecAlta;
	}

	public Date getFecBaja() {
		return this.fecBaja;
	}

	public void setFecBaja(Date fecBaja) {
		this.fecBaja = fecBaja;
	}

	public Date getFecRevisionSad() {
		return this.fecRevisionSad;
	}

	public void setFecRevisionSad(Date fecRevisionSad) {
		this.fecRevisionSad = fecRevisionSad;
	}

	public Integer getTotalPuntuacion() {
		return this.totalPuntuacion;
	}

	public void setTotalPuntuacion(Integer totalPuntuacion) {
		this.totalPuntuacion = totalPuntuacion;
	}

	public Set getPersonaDependientes() {
		return this.personaDependientes;
	}

	public void setPersonaDependientes(Set personaDependientes) {
		this.personaDependientes = personaDependientes;
	}

	public Set getServicios() {
		return this.servicios;
	}

	public void setServicios(Set servicios) {
		this.servicios = servicios;
	}

}