package hibernate;

import java.util.Date;
import java.util.HashSet;
import java.util.Set;

/**
 * AbstractPersona entity provides the base persistence definition of the
 * Persona entity.
 * 
 * @author MyEclipse Persistence Tools
 */

public abstract class AbstractPersona implements java.io.Serializable {

	// Fields

	private Integer id;
	private Localidad localidad;
	private String nombre;
	private String apellido1;
	private String apellido2;
	private String nombre_apellidos;
	private String direccion;
	private String telefono;
	private String movil;
	private String codigoPostal;
	private String email;
	private Date fechaNacimiento;
	private Date fechaAlta;
	private Date fechaBaja;
	private String dni;
	private Set personaDependientes = new HashSet(0);
	private Set usuarios = new HashSet(0);

	// Constructors

	/** default constructor */
	public AbstractPersona() {
	}

	/** minimal constructor */
	public AbstractPersona(Integer id) {
		this.id = id;
		// this.dni = dni;
	}

	/** full constructor */
	public AbstractPersona(Integer id, Localidad localidad, String nombre,
			String apellido1, String apellido2, String direccion,
			String telefono, String movil, String codigoPostal, String email,
			Date fechaNacimiento, Date fechaAlta, Date fechaBaja, String dni,
			Set personaDependientes, Set usuarios) {
		this.id = id;
		this.localidad = localidad;
		this.nombre = nombre;
		this.apellido1 = apellido1;
		this.apellido2 = apellido2;
		this.direccion = direccion;
		this.telefono = telefono;
		this.movil = movil;
		this.codigoPostal = codigoPostal;
		this.email = email;
		this.fechaNacimiento = fechaNacimiento;
		this.fechaAlta = fechaAlta;
		this.fechaBaja = fechaBaja;
		this.dni = dni;
		this.personaDependientes = personaDependientes;
		this.usuarios = usuarios;
	}

	// Property accessors

	public Integer getId() {
		return this.id;
	}

	public void setId(Integer id) {
		this.id = id;
	}

	public Localidad getLocalidad() {
		return this.localidad;
	}

	public void setLocalidad(Localidad localidad) {
		this.localidad = localidad;
	}

	public String getNombre() {
		return this.nombre;
	}

	public void setNombre(String nombre) {
		this.nombre = nombre;
	}

	public String getApellido1() {
		return this.apellido1;
	}

	public void setApellido1(String apellido1) {
		this.apellido1 = apellido1;
	}

	public String getApellido2() {
		return this.apellido2;
	}

	public void setApellido2(String apellido2) {
		this.apellido2 = apellido2;
	}

	public String getDireccion() {
		return this.direccion;
	}

	public void setDireccion(String direccion) {
		this.direccion = direccion;
	}

	public String getTelefono() {
		return this.telefono;
	}

	public void setTelefono(String telefono) {
		this.telefono = telefono;
	}

	public String getMovil() {
		return this.movil;
	}

	public void setMovil(String movil) {
		this.movil = movil;
	}

	public String getCodigoPostal() {
		return this.codigoPostal;
	}

	public void setCodigoPostal(String codigoPostal) {
		this.codigoPostal = codigoPostal;
	}

	public String getEmail() {
		return this.email;
	}

	public void setEmail(String email) {
		this.email = email;
	}

	public Date getFechaNacimiento() {
		return this.fechaNacimiento;
	}

	public void setFechaNacimiento(Date fechaNacimiento) {
		this.fechaNacimiento = fechaNacimiento;
	}

	public Date getFechaAlta() {
		return this.fechaAlta;
	}

	public void setFechaAlta(Date fechaAlta) {
		this.fechaAlta = fechaAlta;
	}

	public Date getFechaBaja() {
		return this.fechaBaja;
	}

	public void setFechaBaja(Date fechaBaja) {
		this.fechaBaja = fechaBaja;
	}

	public String getDni() {
		return this.dni;
	}

	public void setDni(String dni) {
		this.dni = dni;
	}

	public Set getPersonaDependientes() {
		return this.personaDependientes;
	}

	public void setPersonaDependientes(Set personaDependientes) {
		this.personaDependientes = personaDependientes;
	}

	public Set getUsuarios() {
		return this.usuarios;
	}

	public void setUsuarios(Set usuarios) {
		this.usuarios = usuarios;
	}

	public String getNombre_apellidos() {
		if ((this.getApellido2() == null) || (this.getApellido2().equals("")))
			return this.getNombre() + " " + this.getApellido1();
		else
			return this.getNombre() + " " + this.getApellido1() + " " + this.getApellido2() ;
	}

	public void setNombre_apellidos(String nombre_apellidos) {
		this.nombre_apellidos = nombre_apellidos;
	}

}