package hibernate;

import java.util.Date;

/**
 * AbstractPersonaDependiente entity provides the base persistence definition of
 * the PersonaDependiente entity.
 * 
 * @author MyEclipse Persistence Tools
 */

public abstract class AbstractPersonaDependiente implements
		java.io.Serializable {

	// Fields

	private Integer id;
	private CuestionarioEstadoPsiquico cuestionarioEstadoPsiquico;
	private Auxiliar auxiliar;
	private CuestionarioEstadoEconomico cuestionarioEstadoEconomico;
	private Persona persona;
	private CuestionarioEstadoFisico cuestionarioEstadoFisico;
	private Asociacion asociacion;
	private CuestionarioEstadoFamiliar cuestionarioEstadoFamiliar;
	private String medicoCabecera;
	private String centroSalud;
	private Integer discapacidad;
	private String causaBaja;
	private Date fecAltaBeneficiario;
	private Date fecBajaBeneficiario;
	private String sexo;
	private String estadoCivil;
	private Boolean puedeFirmar;

	// Constructors

	/** default constructor */
	public AbstractPersonaDependiente() {
	}

	/** minimal constructor */
	public AbstractPersonaDependiente(Integer id) {
		this.id = id;
	}

	/** full constructor */
	public AbstractPersonaDependiente(Integer id,
			CuestionarioEstadoPsiquico cuestionarioEstadoPsiquico,
			Auxiliar auxiliar,
			CuestionarioEstadoEconomico cuestionarioEstadoEconomico,
			Persona persona, CuestionarioEstadoFisico cuestionarioEstadoFisico,
			Asociacion asociacion,
			CuestionarioEstadoFamiliar cuestionarioEstadoFamiliar,
			String medicoCabecera, String centroSalud, Integer discapacidad,
			String causaBaja, Date fecAltaBeneficiario,
			Date fecBajaBeneficiario, String sexo, String estadoCivil,
			Boolean puedeFirmar) {
		this.id = id;
		this.cuestionarioEstadoPsiquico = cuestionarioEstadoPsiquico;
		this.auxiliar = auxiliar;
		this.cuestionarioEstadoEconomico = cuestionarioEstadoEconomico;
		this.persona = persona;
		this.cuestionarioEstadoFisico = cuestionarioEstadoFisico;
		this.asociacion = asociacion;
		this.cuestionarioEstadoFamiliar = cuestionarioEstadoFamiliar;
		this.medicoCabecera = medicoCabecera;
		this.centroSalud = centroSalud;
		this.discapacidad = discapacidad;
		this.causaBaja = causaBaja;
		this.fecAltaBeneficiario = fecAltaBeneficiario;
		this.fecBajaBeneficiario = fecBajaBeneficiario;
		this.sexo = sexo;
		this.estadoCivil = estadoCivil;
		this.puedeFirmar = puedeFirmar;
	}

	// Property accessors

	public Integer getId() {
		return this.id;
	}

	public void setId(Integer id) {
		this.id = id;
	}

	public CuestionarioEstadoPsiquico getCuestionarioEstadoPsiquico() {
		return this.cuestionarioEstadoPsiquico;
	}

	public void setCuestionarioEstadoPsiquico(
			CuestionarioEstadoPsiquico cuestionarioEstadoPsiquico) {
		this.cuestionarioEstadoPsiquico = cuestionarioEstadoPsiquico;
	}

	public Auxiliar getAuxiliar() {
		return this.auxiliar;
	}

	public void setAuxiliar(Auxiliar auxiliar) {
		this.auxiliar = auxiliar;
	}

	public CuestionarioEstadoEconomico getCuestionarioEstadoEconomico() {
		return this.cuestionarioEstadoEconomico;
	}

	public void setCuestionarioEstadoEconomico(
			CuestionarioEstadoEconomico cuestionarioEstadoEconomico) {
		this.cuestionarioEstadoEconomico = cuestionarioEstadoEconomico;
	}

	public Persona getPersona() {
		return this.persona;
	}

	public void setPersona(Persona persona) {
		this.persona = persona;
	}

	public CuestionarioEstadoFisico getCuestionarioEstadoFisico() {
		return this.cuestionarioEstadoFisico;
	}

	public void setCuestionarioEstadoFisico(
			CuestionarioEstadoFisico cuestionarioEstadoFisico) {
		this.cuestionarioEstadoFisico = cuestionarioEstadoFisico;
	}

	public Asociacion getAsociacion() {
		return this.asociacion;
	}

	public void setAsociacion(Asociacion asociacion) {
		this.asociacion = asociacion;
	}

	public CuestionarioEstadoFamiliar getCuestionarioEstadoFamiliar() {
		return this.cuestionarioEstadoFamiliar;
	}

	public void setCuestionarioEstadoFamiliar(
			CuestionarioEstadoFamiliar cuestionarioEstadoFamiliar) {
		this.cuestionarioEstadoFamiliar = cuestionarioEstadoFamiliar;
	}

	public String getMedicoCabecera() {
		return this.medicoCabecera;
	}

	public void setMedicoCabecera(String medicoCabecera) {
		this.medicoCabecera = medicoCabecera;
	}

	public String getCentroSalud() {
		return this.centroSalud;
	}

	public void setCentroSalud(String centroSalud) {
		this.centroSalud = centroSalud;
	}

	public Integer getDiscapacidad() {
		return this.discapacidad;
	}

	public void setDiscapacidad(Integer discapacidad) {
		this.discapacidad = discapacidad;
	}

	public String getCausaBaja() {
		return this.causaBaja;
	}

	public void setCausaBaja(String causaBaja) {
		this.causaBaja = causaBaja;
	}

	public Date getFecAltaBeneficiario() {
		return this.fecAltaBeneficiario;
	}

	public void setFecAltaBeneficiario(Date fecAltaBeneficiario) {
		this.fecAltaBeneficiario = fecAltaBeneficiario;
	}

	public Date getFecBajaBeneficiario() {
		return this.fecBajaBeneficiario;
	}

	public void setFecBajaBeneficiario(Date fecBajaBeneficiario) {
		this.fecBajaBeneficiario = fecBajaBeneficiario;
	}

	public String getSexo() {
		return this.sexo;
	}

	public void setSexo(String sexo) {
		this.sexo = sexo;
	}

	public String getEstadoCivil() {
		return this.estadoCivil;
	}

	public void setEstadoCivil(String estadoCivil) {
		this.estadoCivil = estadoCivil;
	}

	public Boolean getPuedeFirmar() {
		return this.puedeFirmar;
	}

	public void setPuedeFirmar(Boolean puedeFirmar) {
		this.puedeFirmar = puedeFirmar;
	}

}