package hibernate;

import java.util.Date;
import java.util.HashSet;
import java.util.Set;

/**
 * AbstractUsuario entity provides the base persistence definition of the
 * Usuario entity.
 * 
 * @author MyEclipse Persistence Tools
 */

public abstract class AbstractUsuario implements java.io.Serializable {

	// Fields

	private Integer id;
	private Persona persona;
	private Perfil perfil;
	private String login;
	private Date fecAlta;
	private Date fecBaja;
	private String clave;
	private Set usuarioPerfils = new HashSet(0);
	private Set auxiliars = new HashSet(0);

	// Constructors

	/** default constructor */
	public AbstractUsuario() {
	}

	/** minimal constructor */
	public AbstractUsuario(Integer id, String login, String clave) {
		this.id = id;
		this.login = login;
		this.clave = clave;
	}

	/** full constructor */
	public AbstractUsuario(Integer id, Persona persona, Perfil perfil,
			String login, Date fecAlta, Date fecBaja, String clave,
			Set usuarioPerfils, Set auxiliars) {
		this.id = id;
		this.persona = persona;
		this.perfil = perfil;
		this.login = login;
		this.fecAlta = fecAlta;
		this.fecBaja = fecBaja;
		this.clave = clave;
		this.usuarioPerfils = usuarioPerfils;
		this.auxiliars = auxiliars;
	}

	// Property accessors

	public Integer getId() {
		return this.id;
	}

	public void setId(Integer id) {
		this.id = id;
	}

	public Persona getPersona() {
		return this.persona;
	}

	public void setPersona(Persona persona) {
		this.persona = persona;
	}

	public Perfil getPerfil() {
		return this.perfil;
	}

	public void setPerfil(Perfil perfil) {
		this.perfil = perfil;
	}

	public String getLogin() {
		return this.login;
	}

	public void setLogin(String login) {
		this.login = login;
	}

	public Date getFecAlta() {
		return this.fecAlta;
	}

	public void setFecAlta(Date fecAlta) {
		this.fecAlta = fecAlta;
	}

	public Date getFecBaja() {
		return this.fecBaja;
	}

	public void setFecBaja(Date fecBaja) {
		this.fecBaja = fecBaja;
	}

	public String getClave() {
		return this.clave;
	}

	public void setClave(String clave) {
		this.clave = clave;
	}

	public Set getUsuarioPerfils() {
		return this.usuarioPerfils;
	}

	public void setUsuarioPerfils(Set usuarioPerfils) {
		this.usuarioPerfils = usuarioPerfils;
	}

	public Set getAuxiliars() {
		return this.auxiliars;
	}

	public void setAuxiliars(Set auxiliars) {
		this.auxiliars = auxiliars;
	}

}