package hibernate;

import java.util.List;
import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.hibernate.LockMode;
import org.hibernate.Query;
import org.hibernate.criterion.Example;

/**
 * A data access object (DAO) providing persistence and search support for
 * RespuestaEstadoEconomico entities. Transaction control of the save(),
 * update() and delete() operations can directly support Spring
 * container-managed transactions or they can be augmented to handle
 * user-managed Spring transactions. Each of these methods provides additional
 * information for how to configure it for the desired type of transaction
 * control.
 * 
 * @see hibernate.RespuestaEstadoEconomico
 * @author MyEclipse Persistence Tools
 */

public class RespuestaEstadoEconomicoDAO extends BaseHibernateDAO {
	private static final Log log = LogFactory
			.getLog(RespuestaEstadoEconomicoDAO.class);
	// property constants
	public static final String PUNTUACION = "puntuacion";

	public void save(RespuestaEstadoEconomico transientInstance) {
		log.debug("saving RespuestaEstadoEconomico instance");
		try {
			getSession().save(transientInstance);
			log.debug("save successful");
		} catch (RuntimeException re) {
			log.error("save failed", re);
			throw re;
		}
	}

	public void delete(RespuestaEstadoEconomico persistentInstance) {
		log.debug("deleting RespuestaEstadoEconomico instance");
		try {
			getSession().delete(persistentInstance);
			log.debug("delete successful");
		} catch (RuntimeException re) {
			log.error("delete failed", re);
			throw re;
		}
	}

	public RespuestaEstadoEconomico findById(java.lang.Integer id) {
		log.debug("getting RespuestaEstadoEconomico instance with id: " + id);
		try {
			RespuestaEstadoEconomico instance = (RespuestaEstadoEconomico) getSession()
					.get("hibernate.RespuestaEstadoEconomico", id);
			return instance;
		} catch (RuntimeException re) {
			log.error("get failed", re);
			throw re;
		}
	}

	public List findByExample(RespuestaEstadoEconomico instance) {
		log.debug("finding RespuestaEstadoEconomico instance by example");
		try {
			List results = getSession().createCriteria(
					"hibernate.RespuestaEstadoEconomico").add(
					Example.create(instance)).list();
			log.debug("find by example successful, result size: "
					+ results.size());
			return results;
		} catch (RuntimeException re) {
			log.error("find by example failed", re);
			throw re;
		}
	}

	public List findByProperty(String propertyName, Object value) {
		log.debug("finding RespuestaEstadoEconomico instance with property: "
				+ propertyName + ", value: " + value);
		try {
			String queryString = "from RespuestaEstadoEconomico as model where model."
					+ propertyName + "= ?";
			Query queryObject = getSession().createQuery(queryString);
			queryObject.setParameter(0, value);
			return queryObject.list();
		} catch (RuntimeException re) {
			log.error("find by property name failed", re);
			throw re;
		}
	}

	public List findByPuntuacion(Object puntuacion) {
		return findByProperty(PUNTUACION, puntuacion);
	}

	public List findAll() {
		log.debug("finding all RespuestaEstadoEconomico instances");
		try {
			String queryString = "from RespuestaEstadoEconomico";
			Query queryObject = getSession().createQuery(queryString);
			return queryObject.list();
		} catch (RuntimeException re) {
			log.error("find all failed", re);
			throw re;
		}
	}

	public RespuestaEstadoEconomico merge(
			RespuestaEstadoEconomico detachedInstance) {
		log.debug("merging RespuestaEstadoEconomico instance");
		try {
			RespuestaEstadoEconomico result = (RespuestaEstadoEconomico) getSession()
					.merge(detachedInstance);
			log.debug("merge successful");
			return result;
		} catch (RuntimeException re) {
			log.error("merge failed", re);
			throw re;
		}
	}

	public void attachDirty(RespuestaEstadoEconomico instance) {
		log.debug("attaching dirty RespuestaEstadoEconomico instance");
		try {
			getSession().saveOrUpdate(instance);
			log.debug("attach successful");
		} catch (RuntimeException re) {
			log.error("attach failed", re);
			throw re;
		}
	}

	public void attachClean(RespuestaEstadoEconomico instance) {
		log.debug("attaching clean RespuestaEstadoEconomico instance");
		try {
			getSession().lock(instance, LockMode.NONE);
			log.debug("attach successful");
		} catch (RuntimeException re) {
			log.error("attach failed", re);
			throw re;
		}
	}
}