package hibernate;

import java.util.List;
import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.hibernate.LockMode;
import org.hibernate.Query;
import org.hibernate.criterion.Example;

/**
 * A data access object (DAO) providing persistence and search support for
 * RespuestaEstadoFamiliar entities. Transaction control of the save(), update()
 * and delete() operations can directly support Spring container-managed
 * transactions or they can be augmented to handle user-managed Spring
 * transactions. Each of these methods provides additional information for how
 * to configure it for the desired type of transaction control.
 * 
 * @see hibernate.RespuestaEstadoFamiliar
 * @author MyEclipse Persistence Tools
 */

public class RespuestaEstadoFamiliarDAO extends BaseHibernateDAO {
	private static final Log log = LogFactory
			.getLog(RespuestaEstadoFamiliarDAO.class);
	// property constants
	public static final String PUNTUACION = "puntuacion";

	public void save(RespuestaEstadoFamiliar transientInstance) {
		log.debug("saving RespuestaEstadoFamiliar instance");
		try {
			getSession().save(transientInstance);
			log.debug("save successful");
		} catch (RuntimeException re) {
			log.error("save failed", re);
			throw re;
		}
	}

	public void delete(RespuestaEstadoFamiliar persistentInstance) {
		log.debug("deleting RespuestaEstadoFamiliar instance");
		try {
			getSession().delete(persistentInstance);
			log.debug("delete successful");
		} catch (RuntimeException re) {
			log.error("delete failed", re);
			throw re;
		}
	}

	public RespuestaEstadoFamiliar findById(java.lang.Integer id) {
		log.debug("getting RespuestaEstadoFamiliar instance with id: " + id);
		try {
			RespuestaEstadoFamiliar instance = (RespuestaEstadoFamiliar) getSession()
					.get("hibernate.RespuestaEstadoFamiliar", id);
			return instance;
		} catch (RuntimeException re) {
			log.error("get failed", re);
			throw re;
		}
	}

	public List findByExample(RespuestaEstadoFamiliar instance) {
		log.debug("finding RespuestaEstadoFamiliar instance by example");
		try {
			List results = getSession().createCriteria(
					"hibernate.RespuestaEstadoFamiliar").add(
					Example.create(instance)).list();
			log.debug("find by example successful, result size: "
					+ results.size());
			return results;
		} catch (RuntimeException re) {
			log.error("find by example failed", re);
			throw re;
		}
	}

	public List findByProperty(String propertyName, Object value) {
		log.debug("finding RespuestaEstadoFamiliar instance with property: "
				+ propertyName + ", value: " + value);
		try {
			String queryString = "from RespuestaEstadoFamiliar as model where model."
					+ propertyName + "= ?";
			Query queryObject = getSession().createQuery(queryString);
			queryObject.setParameter(0, value);
			return queryObject.list();
		} catch (RuntimeException re) {
			log.error("find by property name failed", re);
			throw re;
		}
	}

	public List findByPuntuacion(Object puntuacion) {
		return findByProperty(PUNTUACION, puntuacion);
	}

	public List findAll() {
		log.debug("finding all RespuestaEstadoFamiliar instances");
		try {
			String queryString = "from RespuestaEstadoFamiliar";
			Query queryObject = getSession().createQuery(queryString);
			return queryObject.list();
		} catch (RuntimeException re) {
			log.error("find all failed", re);
			throw re;
		}
	}

	public RespuestaEstadoFamiliar merge(
			RespuestaEstadoFamiliar detachedInstance) {
		log.debug("merging RespuestaEstadoFamiliar instance");
		try {
			RespuestaEstadoFamiliar result = (RespuestaEstadoFamiliar) getSession()
					.merge(detachedInstance);
			log.debug("merge successful");
			return result;
		} catch (RuntimeException re) {
			log.error("merge failed", re);
			throw re;
		}
	}

	public void attachDirty(RespuestaEstadoFamiliar instance) {
		log.debug("attaching dirty RespuestaEstadoFamiliar instance");
		try {
			getSession().saveOrUpdate(instance);
			log.debug("attach successful");
		} catch (RuntimeException re) {
			log.error("attach failed", re);
			throw re;
		}
	}

	public void attachClean(RespuestaEstadoFamiliar instance) {
		log.debug("attaching clean RespuestaEstadoFamiliar instance");
		try {
			getSession().lock(instance, LockMode.NONE);
			log.debug("attach successful");
		} catch (RuntimeException re) {
			log.error("attach failed", re);
			throw re;
		}
	}
}