package hibernate;

import java.util.List;
import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.hibernate.LockMode;
import org.hibernate.Query;
import org.hibernate.criterion.Example;

/**
 * A data access object (DAO) providing persistence and search support for
 * RespuestaEstadoPsiquico entities. Transaction control of the save(), update()
 * and delete() operations can directly support Spring container-managed
 * transactions or they can be augmented to handle user-managed Spring
 * transactions. Each of these methods provides additional information for how
 * to configure it for the desired type of transaction control.
 * 
 * @see hibernate.RespuestaEstadoPsiquico
 * @author MyEclipse Persistence Tools
 */

public class RespuestaEstadoPsiquicoDAO extends BaseHibernateDAO {
	private static final Log log = LogFactory
			.getLog(RespuestaEstadoPsiquicoDAO.class);
	// property constants
	public static final String PUNTUACION = "puntuacion";

	public void save(RespuestaEstadoPsiquico transientInstance) {
		log.debug("saving RespuestaEstadoPsiquico instance");
		try {
			getSession().save(transientInstance);
			log.debug("save successful");
		} catch (RuntimeException re) {
			log.error("save failed", re);
			throw re;
		}
	}

	public void delete(RespuestaEstadoPsiquico persistentInstance) {
		log.debug("deleting RespuestaEstadoPsiquico instance");
		try {
			getSession().delete(persistentInstance);
			log.debug("delete successful");
		} catch (RuntimeException re) {
			log.error("delete failed", re);
			throw re;
		}
	}

	public RespuestaEstadoPsiquico findById(java.lang.Integer id) {
		log.debug("getting RespuestaEstadoPsiquico instance with id: " + id);
		try {
			RespuestaEstadoPsiquico instance = (RespuestaEstadoPsiquico) getSession()
					.get("hibernate.RespuestaEstadoPsiquico", id);
			return instance;
		} catch (RuntimeException re) {
			log.error("get failed", re);
			throw re;
		}
	}

	public List findByExample(RespuestaEstadoPsiquico instance) {
		log.debug("finding RespuestaEstadoPsiquico instance by example");
		try {
			List results = getSession().createCriteria(
					"hibernate.RespuestaEstadoPsiquico").add(
					Example.create(instance)).list();
			log.debug("find by example successful, result size: "
					+ results.size());
			return results;
		} catch (RuntimeException re) {
			log.error("find by example failed", re);
			throw re;
		}
	}

	public List findByProperty(String propertyName, Object value) {
		log.debug("finding RespuestaEstadoPsiquico instance with property: "
				+ propertyName + ", value: " + value);
		try {
			String queryString = "from RespuestaEstadoPsiquico as model where model."
					+ propertyName + "= ?";
			Query queryObject = getSession().createQuery(queryString);
			queryObject.setParameter(0, value);
			return queryObject.list();
		} catch (RuntimeException re) {
			log.error("find by property name failed", re);
			throw re;
		}
	}

	public List findByPuntuacion(Object puntuacion) {
		return findByProperty(PUNTUACION, puntuacion);
	}

	public List findAll() {
		log.debug("finding all RespuestaEstadoPsiquico instances");
		try {
			String queryString = "from RespuestaEstadoPsiquico";
			Query queryObject = getSession().createQuery(queryString);
			return queryObject.list();
		} catch (RuntimeException re) {
			log.error("find all failed", re);
			throw re;
		}
	}

	public RespuestaEstadoPsiquico merge(
			RespuestaEstadoPsiquico detachedInstance) {
		log.debug("merging RespuestaEstadoPsiquico instance");
		try {
			RespuestaEstadoPsiquico result = (RespuestaEstadoPsiquico) getSession()
					.merge(detachedInstance);
			log.debug("merge successful");
			return result;
		} catch (RuntimeException re) {
			log.error("merge failed", re);
			throw re;
		}
	}

	public void attachDirty(RespuestaEstadoPsiquico instance) {
		log.debug("attaching dirty RespuestaEstadoPsiquico instance");
		try {
			getSession().saveOrUpdate(instance);
			log.debug("attach successful");
		} catch (RuntimeException re) {
			log.error("attach failed", re);
			throw re;
		}
	}

	public void attachClean(RespuestaEstadoPsiquico instance) {
		log.debug("attaching clean RespuestaEstadoPsiquico instance");
		try {
			getSession().lock(instance, LockMode.NONE);
			log.debug("attach successful");
		} catch (RuntimeException re) {
			log.error("attach failed", re);
			throw re;
		}
	}
}