package hibernate;

import java.util.List;
import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.hibernate.LockMode;
import org.hibernate.Query;
import org.hibernate.criterion.Example;

/**
 * A data access object (DAO) providing persistence and search support for
 * SubtipoEvento entities. Transaction control of the save(), update() and
 * delete() operations can directly support Spring container-managed
 * transactions or they can be augmented to handle user-managed Spring
 * transactions. Each of these methods provides additional information for how
 * to configure it for the desired type of transaction control.
 * 
 * @see hibernate.SubtipoEvento
 * @author MyEclipse Persistence Tools
 */

public class SubtipoEventoDAO extends BaseHibernateDAO {
	private static final Log log = LogFactory.getLog(SubtipoEventoDAO.class);
	// property constants
	public static final String DESCRIPCION = "descripcion";

	public void save(SubtipoEvento transientInstance) {
		log.debug("saving SubtipoEvento instance");
		try {
			getSession().save(transientInstance);
			log.debug("save successful");
		} catch (RuntimeException re) {
			log.error("save failed", re);
			throw re;
		}
	}

	public void delete(SubtipoEvento persistentInstance) {
		log.debug("deleting SubtipoEvento instance");
		try {
			getSession().delete(persistentInstance);
			log.debug("delete successful");
		} catch (RuntimeException re) {
			log.error("delete failed", re);
			throw re;
		}
	}

	public SubtipoEvento findById(java.lang.Integer id) {
		log.debug("getting SubtipoEvento instance with id: " + id);
		try {
			SubtipoEvento instance = (SubtipoEvento) getSession().get(
					"hibernate.SubtipoEvento", id);
			return instance;
		} catch (RuntimeException re) {
			log.error("get failed", re);
			throw re;
		}
	}

	public List findByExample(SubtipoEvento instance) {
		log.debug("finding SubtipoEvento instance by example");
		try {
			List results = getSession().createCriteria(
					"hibernate.SubtipoEvento").add(Example.create(instance))
					.list();
			log.debug("find by example successful, result size: "
					+ results.size());
			return results;
		} catch (RuntimeException re) {
			log.error("find by example failed", re);
			throw re;
		}
	}

	public List findByProperty(String propertyName, Object value) {
		log.debug("finding SubtipoEvento instance with property: "
				+ propertyName + ", value: " + value);
		try {
			String queryString = "from SubtipoEvento as model where model."
					+ propertyName + "= ?";
			Query queryObject = getSession().createQuery(queryString);
			queryObject.setParameter(0, value);
			return queryObject.list();
		} catch (RuntimeException re) {
			log.error("find by property name failed", re);
			throw re;
		}
	}

	public List findByDescripcion(Object descripcion) {
		return findByProperty(DESCRIPCION, descripcion);
	}

	public List findAll() {
		log.debug("finding all SubtipoEvento instances");
		try {
			String queryString = "from SubtipoEvento";
			Query queryObject = getSession().createQuery(queryString);
			return queryObject.list();
		} catch (RuntimeException re) {
			log.error("find all failed", re);
			throw re;
		}
	}
	
	public List findAllTarea(String id_tarea) {
		log.debug("finding all SubtipoEvento instances");
		try {
			String queryString = "from SubtipoEvento where id_tipo_evento = " + id_tarea;
			Query queryObject = getSession().createQuery(queryString);
			return queryObject.list();
		} catch (RuntimeException re) {
			log.error("find all failed", re);
			throw re;
		}
	}

	public SubtipoEvento merge(SubtipoEvento detachedInstance) {
		log.debug("merging SubtipoEvento instance");
		try {
			SubtipoEvento result = (SubtipoEvento) getSession().merge(
					detachedInstance);
			log.debug("merge successful");
			return result;
		} catch (RuntimeException re) {
			log.error("merge failed", re);
			throw re;
		}
	}

	public void attachDirty(SubtipoEvento instance) {
		log.debug("attaching dirty SubtipoEvento instance");
		try {
			getSession().saveOrUpdate(instance);
			log.debug("attach successful");
		} catch (RuntimeException re) {
			log.error("attach failed", re);
			throw re;
		}
	}

	public void attachClean(SubtipoEvento instance) {
		log.debug("attaching clean SubtipoEvento instance");
		try {
			getSession().lock(instance, LockMode.NONE);
			log.debug("attach successful");
		} catch (RuntimeException re) {
			log.error("attach failed", re);
			throw re;
		}
	}
}