package hibernate;

import java.util.List;
import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.hibernate.LockMode;
import org.hibernate.Query;
import org.hibernate.criterion.Example;

/**
 * A data access object (DAO) providing persistence and search support for
 * UsuarioPerfil entities. Transaction control of the save(), update() and
 * delete() operations can directly support Spring container-managed
 * transactions or they can be augmented to handle user-managed Spring
 * transactions. Each of these methods provides additional information for how
 * to configure it for the desired type of transaction control.
 * 
 * @see hibernate.UsuarioPerfil
 * @author MyEclipse Persistence Tools
 */

public class UsuarioPerfilDAO extends BaseHibernateDAO {
	private static final Log log = LogFactory.getLog(UsuarioPerfilDAO.class);

	// property constants

	public void save(UsuarioPerfil transientInstance) {
		log.debug("saving UsuarioPerfil instance");
		try {
			getSession().save(transientInstance);
			log.debug("save successful");
		} catch (RuntimeException re) {
			log.error("save failed", re);
			throw re;
		}
	}

	public void delete(UsuarioPerfil persistentInstance) {
		log.debug("deleting UsuarioPerfil instance");
		try {
			getSession().delete(persistentInstance);
			log.debug("delete successful");
		} catch (RuntimeException re) {
			log.error("delete failed", re);
			throw re;
		}
	}

	public UsuarioPerfil findById(hibernate.UsuarioPerfilId id) {
		log.debug("getting UsuarioPerfil instance with id: " + id);
		try {
			UsuarioPerfil instance = (UsuarioPerfil) getSession().get(
					"hibernate.UsuarioPerfil", id);
			return instance;
		} catch (RuntimeException re) {
			log.error("get failed", re);
			throw re;
		}
	}

	public List findByExample(UsuarioPerfil instance) {
		log.debug("finding UsuarioPerfil instance by example");
		try {
			List results = getSession().createCriteria(
					"hibernate.UsuarioPerfil").add(Example.create(instance))
					.list();
			log.debug("find by example successful, result size: "
					+ results.size());
			return results;
		} catch (RuntimeException re) {
			log.error("find by example failed", re);
			throw re;
		}
	}

	public List findByProperty(String propertyName, Object value) {
		log.debug("finding UsuarioPerfil instance with property: "
				+ propertyName + ", value: " + value);
		try {
			String queryString = "from UsuarioPerfil as model where model."
					+ propertyName + "= ?";
			Query queryObject = getSession().createQuery(queryString);
			queryObject.setParameter(0, value);
			return queryObject.list();
		} catch (RuntimeException re) {
			log.error("find by property name failed", re);
			throw re;
		}
	}

	public List findAll() {
		log.debug("finding all UsuarioPerfil instances");
		try {
			String queryString = "from UsuarioPerfil";
			Query queryObject = getSession().createQuery(queryString);
			return queryObject.list();
		} catch (RuntimeException re) {
			log.error("find all failed", re);
			throw re;
		}
	}

	public UsuarioPerfil merge(UsuarioPerfil detachedInstance) {
		log.debug("merging UsuarioPerfil instance");
		try {
			UsuarioPerfil result = (UsuarioPerfil) getSession().merge(
					detachedInstance);
			log.debug("merge successful");
			return result;
		} catch (RuntimeException re) {
			log.error("merge failed", re);
			throw re;
		}
	}

	public void attachDirty(UsuarioPerfil instance) {
		log.debug("attaching dirty UsuarioPerfil instance");
		try {
			getSession().saveOrUpdate(instance);
			log.debug("attach successful");
		} catch (RuntimeException re) {
			log.error("attach failed", re);
			throw re;
		}
	}

	public void attachClean(UsuarioPerfil instance) {
		log.debug("attaching clean UsuarioPerfil instance");
		try {
			getSession().lock(instance, LockMode.NONE);
			log.debug("attach successful");
		} catch (RuntimeException re) {
			log.error("attach failed", re);
			throw re;
		}
	}
}