package hibernate;

import java.util.List;
import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.hibernate.LockMode;
import org.hibernate.Query;
import org.hibernate.criterion.Example;

/**
 * A data access object (DAO) providing persistence and search support for
 * VistaAsociacion entities. Transaction control of the save(), update() and
 * delete() operations can directly support Spring container-managed
 * transactions or they can be augmented to handle user-managed Spring
 * transactions. Each of these methods provides additional information for how
 * to configure it for the desired type of transaction control.
 * 
 * @see hibernate.VistaAsociacion
 * @author MyEclipse Persistence Tools
 */

public class VistaAsociacionDAO extends BaseHibernateDAO {
	private static final Log log = LogFactory.getLog(VistaAsociacionDAO.class);

	// property constants

	public void save(VistaAsociacion transientInstance) {
		log.debug("saving VistaAsociacion instance");
		try {
			getSession().save(transientInstance);
			log.debug("save successful");
		} catch (RuntimeException re) {
			log.error("save failed", re);
			throw re;
		}
	}

	public void delete(VistaAsociacion persistentInstance) {
		log.debug("deleting VistaAsociacion instance");
		try {
			getSession().delete(persistentInstance);
			log.debug("delete successful");
		} catch (RuntimeException re) {
			log.error("delete failed", re);
			throw re;
		}
	}

	public VistaAsociacion findById(hibernate.VistaAsociacionId id) {
		log.debug("getting VistaAsociacion instance with id: " + id);
		try {
			VistaAsociacion instance = (VistaAsociacion) getSession().get(
					"hibernate.VistaAsociacion", id);
			return instance;
		} catch (RuntimeException re) {
			log.error("get failed", re);
			throw re;
		}
	}

	public List findByExample(VistaAsociacion instance) {
		log.debug("finding VistaAsociacion instance by example");
		try {
			List results = getSession().createCriteria(
					"hibernate.VistaAsociacion").add(Example.create(instance))
					.list();
			log.debug("find by example successful, result size: "
					+ results.size());
			return results;
		} catch (RuntimeException re) {
			log.error("find by example failed", re);
			throw re;
		}
	}

	public List findByProperty(String propertyName, Object value) {
		log.debug("finding VistaAsociacion instance with property: "
				+ propertyName + ", value: " + value);
		try {
			String queryString = "from VistaAsociacion as model where model."
					+ propertyName + "= ?";
			Query queryObject = getSession().createQuery(queryString);
			queryObject.setParameter(0, value);
			return queryObject.list();
		} catch (RuntimeException re) {
			log.error("find by property name failed", re);
			throw re;
		}
	}

	public List findAll() {
		log.debug("finding all VistaAsociacion instances");
		try {
			String queryString = "from VistaAsociacion";
			Query queryObject = getSession().createQuery(queryString);
			return queryObject.list();
		} catch (RuntimeException re) {
			log.error("find all failed", re);
			throw re;
		}
	}

	public VistaAsociacion merge(VistaAsociacion detachedInstance) {
		log.debug("merging VistaAsociacion instance");
		try {
			VistaAsociacion result = (VistaAsociacion) getSession().merge(
					detachedInstance);
			log.debug("merge successful");
			return result;
		} catch (RuntimeException re) {
			log.error("merge failed", re);
			throw re;
		}
	}

	public void attachDirty(VistaAsociacion instance) {
		log.debug("attaching dirty VistaAsociacion instance");
		try {
			getSession().saveOrUpdate(instance);
			log.debug("attach successful");
		} catch (RuntimeException re) {
			log.error("attach failed", re);
			throw re;
		}
	}

	public void attachClean(VistaAsociacion instance) {
		log.debug("attaching clean VistaAsociacion instance");
		try {
			getSession().lock(instance, LockMode.NONE);
			log.debug("attach successful");
		} catch (RuntimeException re) {
			log.error("attach failed", re);
			throw re;
		}
	}
}