package hibernate;

import java.util.List;
import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.hibernate.LockMode;
import org.hibernate.Query;
import org.hibernate.criterion.Example;

/**
 * A data access object (DAO) providing persistence and search support for
 * VistaInformePd entities. Transaction control of the save(), update() and
 * delete() operations can directly support Spring container-managed
 * transactions or they can be augmented to handle user-managed Spring
 * transactions. Each of these methods provides additional information for how
 * to configure it for the desired type of transaction control.
 * 
 * @see hibernate.VistaInformePd
 * @author MyEclipse Persistence Tools
 */

public class VistaInformePdDAO extends BaseHibernateDAO {
	private static final Log log = LogFactory.getLog(VistaInformePdDAO.class);

	// property constants

	public void save(VistaInformePd transientInstance) {
		log.debug("saving VistaInformePd instance");
		try {
			getSession().save(transientInstance);
			log.debug("save successful");
		} catch (RuntimeException re) {
			log.error("save failed", re);
			throw re;
		}
	}

	public void delete(VistaInformePd persistentInstance) {
		log.debug("deleting VistaInformePd instance");
		try {
			getSession().delete(persistentInstance);
			log.debug("delete successful");
		} catch (RuntimeException re) {
			log.error("delete failed", re);
			throw re;
		}
	}

	public VistaInformePd findById(hibernate.VistaInformePdId id) {
		log.debug("getting VistaInformePd instance with id: " + id);
		try {
			VistaInformePd instance = (VistaInformePd) getSession().get(
					"hibernate.VistaInformePd", id);
			return instance;
		} catch (RuntimeException re) {
			log.error("get failed", re);
			throw re;
		}
	}

	public List findByExample(VistaInformePd instance) {
		log.debug("finding VistaInformePd instance by example");
		try {
			List results = getSession().createCriteria(
					"hibernate.VistaInformePd").add(Example.create(instance))
					.list();
			log.debug("find by example successful, result size: "
					+ results.size());
			return results;
		} catch (RuntimeException re) {
			log.error("find by example failed", re);
			throw re;
		}
	}

	public List findByProperty(String propertyName, Object value) {
		log.debug("finding VistaInformePd instance with property: "
				+ propertyName + ", value: " + value);
		try {
			String queryString = "from VistaInformePd as model where model."
					+ propertyName + "= ?";
			Query queryObject = getSession().createQuery(queryString);
			queryObject.setParameter(0, value);
			return queryObject.list();
		} catch (RuntimeException re) {
			log.error("find by property name failed", re);
			throw re;
		}
	}

	public List findAll() {
		log.debug("finding all VistaInformePd instances");
		try {
			String queryString = "from VistaInformePd";
			Query queryObject = getSession().createQuery(queryString);
			return queryObject.list();
		} catch (RuntimeException re) {
			log.error("find all failed", re);
			throw re;
		}
	}
	
	
	public List findAllAsociacion(String id_asociacion) {
		log.debug("finding all VistaInformePd instances");
		try {
			String queryString = "from VistaInformePd where idasociacion = " + id_asociacion;
			Query queryObject = getSession().createQuery(queryString);
			return queryObject.list();
		} catch (RuntimeException re) {
			log.error("find all failed", re);
			throw re;
		}
	}
	

	public VistaInformePd merge(VistaInformePd detachedInstance) {
		log.debug("merging VistaInformePd instance");
		try {
			VistaInformePd result = (VistaInformePd) getSession().merge(
					detachedInstance);
			log.debug("merge successful");
			return result;
		} catch (RuntimeException re) {
			log.error("merge failed", re);
			throw re;
		}
	}

	public void attachDirty(VistaInformePd instance) {
		log.debug("attaching dirty VistaInformePd instance");
		try {
			getSession().saveOrUpdate(instance);
			log.debug("attach successful");
		} catch (RuntimeException re) {
			log.error("attach failed", re);
			throw re;
		}
	}

	public void attachClean(VistaInformePd instance) {
		log.debug("attaching clean VistaInformePd instance");
		try {
			getSession().lock(instance, LockMode.NONE);
			log.debug("attach successful");
		} catch (RuntimeException re) {
			log.error("attach failed", re);
			throw re;
		}
	}
}