package hibernate;

import java.util.List;
import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.hibernate.LockMode;
import org.hibernate.Query;
import org.hibernate.criterion.Example;

/**
 * A data access object (DAO) providing persistence and search support for
 * VistaServicio entities. Transaction control of the save(), update() and
 * delete() operations can directly support Spring container-managed
 * transactions or they can be augmented to handle user-managed Spring
 * transactions. Each of these methods provides additional information for how
 * to configure it for the desired type of transaction control.
 * 
 * @see hibernate.VistaServicio
 * @author MyEclipse Persistence Tools
 */

public class VistaServicioDAO extends BaseHibernateDAO {
	private static final Log log = LogFactory.getLog(VistaServicioDAO.class);

	// property constants

	public void save(VistaServicio transientInstance) {
		log.debug("saving VistaServicio instance");
		try {
			getSession().save(transientInstance);
			log.debug("save successful");
		} catch (RuntimeException re) {
			log.error("save failed", re);
			throw re;
		}
	}

	public void delete(VistaServicio persistentInstance) {
		log.debug("deleting VistaServicio instance");
		try {
			getSession().delete(persistentInstance);
			log.debug("delete successful");
		} catch (RuntimeException re) {
			log.error("delete failed", re);
			throw re;
		}
	}

	public VistaServicio findById(hibernate.VistaServicioId id) {
		log.debug("getting VistaServicio instance with id: " + id);
		try {
			VistaServicio instance = (VistaServicio) getSession().get(
					"hibernate.VistaServicio", id);
			return instance;
		} catch (RuntimeException re) {
			log.error("get failed", re);
			throw re;
		}
	}

	public List findByExample(VistaServicio instance) {
		log.debug("finding VistaServicio instance by example");
		try {
			List results = getSession().createCriteria(
					"hibernate.VistaServicio").add(Example.create(instance))
					.list();
			log.debug("find by example successful, result size: "
					+ results.size());
			return results;
		} catch (RuntimeException re) {
			log.error("find by example failed", re);
			throw re;
		}
	}

	public List findByProperty(String propertyName, Object value) {
		log.debug("finding VistaServicio instance with property: "
				+ propertyName + ", value: " + value);
		try {
			String queryString = "from VistaServicio as model where model."
					+ propertyName + "= ?";
			Query queryObject = getSession().createQuery(queryString);
			queryObject.setParameter(0, value);
			return queryObject.list();
		} catch (RuntimeException re) {
			log.error("find by property name failed", re);
			throw re;
		}
	}

	public List findAll() {
		log.debug("finding all VistaServicio instances");
		try {
			String queryString = "from VistaServicio";
			Query queryObject = getSession().createQuery(queryString);
			return queryObject.list();
		} catch (RuntimeException re) {
			log.error("find all failed", re);
			throw re;
		}
	}

	
	public List findAllporDia(String id_voluntario , String dia) {
		log.debug("finding all VistaServicio instances");
		try {
			String queryString = "from VistaServicio where dia = " + dia + " AND id_voluntario = " + id_voluntario + " ORDER BY hora_inicio ASC";
			Query queryObject = getSession().createQuery(queryString);
			return queryObject.list();
		} catch (RuntimeException re) {
			log.error("find all failed", re);
			throw re;
		}
	}
	
	
	public VistaServicio merge(VistaServicio detachedInstance) {
		log.debug("merging VistaServicio instance");
		try {
			VistaServicio result = (VistaServicio) getSession().merge(
					detachedInstance);
			log.debug("merge successful");
			return result;
		} catch (RuntimeException re) {
			log.error("merge failed", re);
			throw re;
		}
	}

	public void attachDirty(VistaServicio instance) {
		log.debug("attaching dirty VistaServicio instance");
		try {
			getSession().saveOrUpdate(instance);
			log.debug("attach successful");
		} catch (RuntimeException re) {
			log.error("attach failed", re);
			throw re;
		}
	}

	public void attachClean(VistaServicio instance) {
		log.debug("attaching clean VistaServicio instance");
		try {
			getSession().lock(instance, LockMode.NONE);
			log.debug("attach successful");
		} catch (RuntimeException re) {
			log.error("attach failed", re);
			throw re;
		}
	}
}