package hibernate;

import java.util.List;
import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.hibernate.LockMode;
import org.hibernate.Query;
import org.hibernate.criterion.Example;

/**
 * A data access object (DAO) providing persistence and search support for
 * VistaUsuarios entities. Transaction control of the save(), update() and
 * delete() operations can directly support Spring container-managed
 * transactions or they can be augmented to handle user-managed Spring
 * transactions. Each of these methods provides additional information for how
 * to configure it for the desired type of transaction control.
 * 
 * @see hibernate.VistaUsuarios
 * @author MyEclipse Persistence Tools
 */

public class VistaUsuariosDAO extends BaseHibernateDAO {
	private static final Log log = LogFactory.getLog(VistaUsuariosDAO.class);

	// property constants

	public void save(VistaUsuarios transientInstance) {
		log.debug("saving VistaUsuarios instance");
		try {
			getSession().save(transientInstance);
			log.debug("save successful");
		} catch (RuntimeException re) {
			log.error("save failed", re);
			throw re;
		}
	}

	public void delete(VistaUsuarios persistentInstance) {
		log.debug("deleting VistaUsuarios instance");
		try {
			getSession().delete(persistentInstance);
			log.debug("delete successful");
		} catch (RuntimeException re) {
			log.error("delete failed", re);
			throw re;
		}
	}

	public VistaUsuarios findById(hibernate.VistaUsuariosId id) {
		log.debug("getting VistaUsuarios instance with id: " + id);
		try {
			VistaUsuarios instance = (VistaUsuarios) getSession().get(
					"hibernate.VistaUsuarios", id);
			return instance;
		} catch (RuntimeException re) {
			log.error("get failed", re);
			throw re;
		}
	}

	public List findByExample(VistaUsuarios instance) {
		log.debug("finding VistaUsuarios instance by example");
		try {
			List results = getSession().createCriteria(
					"hibernate.VistaUsuarios").add(Example.create(instance))
					.list();
			log.debug("find by example successful, result size: "
					+ results.size());
			return results;
		} catch (RuntimeException re) {
			log.error("find by example failed", re);
			throw re;
		}
	}

	public List findByProperty(String propertyName, Object value) {
		log.debug("finding VistaUsuarios instance with property: "
				+ propertyName + ", value: " + value);
		try {
			String queryString = "from VistaUsuarios as model where model."
					+ propertyName + "= ?";
			Query queryObject = getSession().createQuery(queryString);
			queryObject.setParameter(0, value);
			return queryObject.list();
		} catch (RuntimeException re) {
			log.error("find by property name failed", re);
			throw re;
		}
	}

	public List findAll() {
		log.debug("finding all VistaUsuarios instances");
		try {
			String queryString = "from VistaUsuarios";
			Query queryObject = getSession().createQuery(queryString);
			return queryObject.list();
		} catch (RuntimeException re) {
			log.error("find all failed", re);
			throw re;
		}
	}

	public VistaUsuarios merge(VistaUsuarios detachedInstance) {
		log.debug("merging VistaUsuarios instance");
		try {
			VistaUsuarios result = (VistaUsuarios) getSession().merge(
					detachedInstance);
			log.debug("merge successful");
			return result;
		} catch (RuntimeException re) {
			log.error("merge failed", re);
			throw re;
		}
	}

	public void attachDirty(VistaUsuarios instance) {
		log.debug("attaching dirty VistaUsuarios instance");
		try {
			getSession().saveOrUpdate(instance);
			log.debug("attach successful");
		} catch (RuntimeException re) {
			log.error("attach failed", re);
			throw re;
		}
	}

	public void attachClean(VistaUsuarios instance) {
		log.debug("attaching clean VistaUsuarios instance");
		try {
			getSession().lock(instance, LockMode.NONE);
			log.debug("attach successful");
		} catch (RuntimeException re) {
			log.error("attach failed", re);
			throw re;
		}
	}
}