package hibernate;

import java.util.List;
import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.hibernate.LockMode;
import org.hibernate.Query;
import org.hibernate.criterion.Example;

/**
 * A data access object (DAO) providing persistence and search support for
 * VistaVoluntarios entities. Transaction control of the save(), update() and
 * delete() operations can directly support Spring container-managed
 * transactions or they can be augmented to handle user-managed Spring
 * transactions. Each of these methods provides additional information for how
 * to configure it for the desired type of transaction control.
 * 
 * @see hibernate.VistaVoluntarios
 * @author MyEclipse Persistence Tools
 */

public class VistaVoluntariosDAO extends BaseHibernateDAO {
	private static final Log log = LogFactory.getLog(VistaVoluntariosDAO.class);

	// property constants

	public void save(VistaVoluntarios transientInstance) {
		log.debug("saving VistaVoluntarios instance");
		try {
			getSession().save(transientInstance);
			log.debug("save successful");
		} catch (RuntimeException re) {
			log.error("save failed", re);
			throw re;
		}
	}

	public void delete(VistaVoluntarios persistentInstance) {
		log.debug("deleting VistaVoluntarios instance");
		try {
			getSession().delete(persistentInstance);
			log.debug("delete successful");
		} catch (RuntimeException re) {
			log.error("delete failed", re);
			throw re;
		}
	}

	public VistaVoluntarios findById(hibernate.VistaVoluntariosId id) {
		log.debug("getting VistaVoluntarios instance with id: " + id);
		try {
			VistaVoluntarios instance = (VistaVoluntarios) getSession().get(
					"hibernate.VistaVoluntarios", id);
			return instance;
		} catch (RuntimeException re) {
			log.error("get failed", re);
			throw re;
		}
	}

	public List findByExample(VistaVoluntarios instance) {
		log.debug("finding VistaVoluntarios instance by example");
		try {
			List results = getSession().createCriteria(
					"hibernate.VistaVoluntarios").add(Example.create(instance))
					.list();
			log.debug("find by example successful, result size: "
					+ results.size());
			return results;
		} catch (RuntimeException re) {
			log.error("find by example failed", re);
			throw re;
		}
	}

	public List findByProperty(String propertyName, Object value) {
		log.debug("finding VistaVoluntarios instance with property: "
				+ propertyName + ", value: " + value);
		try {
			String queryString = "from VistaVoluntarios as model where model."
					+ propertyName + "= ?";
			Query queryObject = getSession().createQuery(queryString);
			queryObject.setParameter(0, value);
			return queryObject.list();
		} catch (RuntimeException re) {
			log.error("find by property name failed", re);
			throw re;
		}
	}

	public List findAll() {
		log.debug("finding all VistaVoluntarios instances");
		try {
			String queryString = "from VistaVoluntarios";
			Query queryObject = getSession().createQuery(queryString);
			return queryObject.list();
		} catch (RuntimeException re) {
			log.error("find all failed", re);
			throw re;
		}
	}

	
	public List findAllAsociacion(String id_asociacion) {
		log.debug("finding all VistaVoluntarios instances");
		try {
			String queryString = "from VistaVoluntarios where fec_baja_usuario IS NULL AND id_asociacion = " + id_asociacion;
			Query queryObject = getSession().createQuery(queryString);
			return queryObject.list();
		} catch (RuntimeException re) {
			log.error("find all failed", re);
			throw re;
		}
	}
	
	
	public VistaVoluntarios merge(VistaVoluntarios detachedInstance) {
		log.debug("merging VistaVoluntarios instance");
		try {
			VistaVoluntarios result = (VistaVoluntarios) getSession().merge(
					detachedInstance);
			log.debug("merge successful");
			return result;
		} catch (RuntimeException re) {
			log.error("merge failed", re);
			throw re;
		}
	}

	public void attachDirty(VistaVoluntarios instance) {
		log.debug("attaching dirty VistaVoluntarios instance");
		try {
			getSession().saveOrUpdate(instance);
			log.debug("attach successful");
		} catch (RuntimeException re) {
			log.error("attach failed", re);
			throw re;
		}
	}

	public void attachClean(VistaVoluntarios instance) {
		log.debug("attaching clean VistaVoluntarios instance");
		try {
			getSession().lock(instance, LockMode.NONE);
			log.debug("attach successful");
		} catch (RuntimeException re) {
			log.error("attach failed", re);
			throw re;
		}
	}
}