
package util;

import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.Calendar;
import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;


public class DatesToolbox {
	
	private static final Log log = LogFactory.getLog(DatesToolbox.class);
	
	private static final String SEPARADOR_FECHA = "/";
	private static final String SEPARADOR_HORA = ":";
	
	public final static int SPANISH = 0;
	public final static int US = 1;
	
	public static java.util.Date getDBDateFromSpanish(String fecha){
		
		java.util.Date d = null;
		SimpleDateFormat sdf = new SimpleDateFormat("dd"+SEPARADOR_FECHA+"MM"+SEPARADOR_FECHA+"yyyy");
		
		try {
			if ( (fecha != null) && (!fecha.equals("")) ) {
				d = sdf.parse(fecha);
			} else {
				return null;
			}
		} catch (ParseException e) {
			log.error(e);
			e.printStackTrace();
		}
		
		return d;
	}

	public static String getStringDateFromDate(java.util.Date fecha, int locale, String separador){
		
		Calendar c = Calendar.getInstance();
		c.setTime(fecha);
		StringBuffer sb = new StringBuffer();
		
		switch(locale){
			case SPANISH : {
				sb.append(c.get(Calendar.DATE))
				  .append(separador)
				  .append((c.get(Calendar.MONTH)+1))
				  .append(separador)
				  .append(c.get(Calendar.YEAR));
				
				break;
			}
			case US : {
				sb.append(c.get(Calendar.YEAR))
				  .append(separador)
				  .append((c.get(Calendar.MONTH)+1))
				  .append(separador)
				  .append(c.get(Calendar.DATE));				  
			}
		}
		
		return sb.toString();
	}
	
	public static String getStringSpanishDateFromDate(java.util.Date fecha){
		
		return getStringDateFromDate(fecha, SPANISH, SEPARADOR_FECHA);
	}
	
	
	 public static String getStringHourFromDate(java.util.Date fecha){
			
			Calendar c = Calendar.getInstance();
			c.setTime(fecha);
			StringBuffer sb = new StringBuffer();
			
			
			
			sb.append(c.get(Calendar.HOUR))
			   .append(SEPARADOR_HORA);
			Integer iAux = c.get(Calendar.MINUTE);
			String strConcatena= "0";
			if (iAux>10) strConcatena="";
						
			 sb.append(strConcatena + c.get(Calendar.MINUTE))
			  .append(SEPARADOR_HORA);
			  
			iAux = c.get(Calendar.MINUTE);
			strConcatena= "0";
			if (iAux>10) strConcatena="";  
			  
			sb.append(strConcatena + c.get(Calendar.SECOND));
				
			return sb.toString();
		}
	
	    // String en formato correcto
		public static boolean ComprobarFecha(java.lang.String strFecha){
			 
			 try{ 				
				 String aux[] = strFecha.split(SEPARADOR_FECHA);
				 if (aux.length != 3) return false;
				 if (Integer.parseInt(aux[0])==0 || Integer.parseInt(aux[0])>99) return false;
				 if (Integer.parseInt(aux[1])==0 || Integer.parseInt(aux[1])>99) return false;
				 if (Integer.parseInt(aux[2])>9999) return false;
				 return true;		 
			 }catch (Exception e){					   
				    log.error(e);
				    e.printStackTrace();
				    return false;					   
			 }	 
			 
		}
		
		
		 //  String con formato correcto
		public static boolean ComprobarHora(java.lang.String strHora){
			 boolean bReturn = false;
			 try{ 				
				 String aux[] = strHora.split(SEPARADOR_HORA);
				 if (aux.length>3) return bReturn;
				 if (Integer.parseInt(aux[0])>23) return bReturn;
				 if (Integer.parseInt(aux[1])>59) return bReturn;
				 if (Integer.parseInt(aux[2])>59) return bReturn;
				 bReturn= true;		 
			 }catch (Exception e){					   
				    log.error(e);
				    e.printStackTrace();					   
			 }	 
			 return bReturn; 	
		}
}
